package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: EMailDialog.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: VModel student login facility.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.colorchooser.*;

// -----------------------------------------------------------------------------
// Notes:
// * Should the file IO routines be included in this class?
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: EMailDialog
// Description: VModel student login facility.  
// -----------------------------------------------------------------------------
public class EMailDialog extends JDialog implements VModelConstants {
	// InnerClasses and Interfaces
	// --------------------------------------------------------------------------

	// Properties and Accessors
	// --------------------------------------------------------------------------
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return(gui); }
	public VModelGUI gui ( VModelGUI g ) { return(gui = g); }

	protected InfoPane infoPane = null;
	public InfoPane infoPane( ) { return( infoPane ); } // reader infoPane
	public InfoPane infoPane( InfoPane l ) { return( infoPane = l ); }
	public InfoPane infoPane( EMailDialog l ) { 
		validate();
		if (infoPane() == null) infoPane(new InfoPane(l));
		else infoPane().setVisible(true);
		return( infoPane() ); 
	} // method InfoPane
	
	public static final String eMailServer = "relay.acns.nwu.edu";
	public static final int eMailPort = 25;
	
	JTextField coachAddress = new JTextField("robota@cs.nwu.edu");
	JTextField eMailAddress = new JTextField("");
	JTextField eMailSubject = new JTextField("VModel");
	TextArea eMailMessage = new TextArea(" ", 4, 40, TextArea.SCROLLBARS_BOTH);
	JCheckBox bugReport = new JCheckBox("I think I found a bug in VModel.");
	JCheckBox helpRequest = new JCheckBox("I need help using VModel.");
	JCheckBox coachRequest = new JCheckBox("I am submitting a model for analysis.");
		
	// Methods.
	// --------------------------------------------------------------------------
    public void show ( ) {
    	coachAddress.setText("robota@cs.nwu.edu");
    	eMailAddress.setText(gui().preferences().getString("EMAIL"));
    	eMailSubject.setText("VModel: " + gui().selectedModel().label());
    	eMailMessage.setText(" ");
    	bugReport.setSelected(false);
    	helpRequest.setSelected(false);
    	coachRequest.setSelected(false);
    	infoPane(this);
    	validate();
    	super.show();
    } // method show

	// Inner Classes
	// --------------------------------------------------------------------------
    public class InfoPane extends JPanel implements ActionListener {	
    	EMailDialog parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, textPanel1 = null, textPanel2 = null, textPanel3 = null, buttonPanel = null;
    	JButton back = null, ok = null, cancel = null;
    	JColorChooser clrChooser = null;
    	
    	public void setVisible ( boolean b ) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed ( ActionEvent e ) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
    			try {
					Socket sock = new Socket(eMailServer, 25);
					DataInputStream dis = new DataInputStream(sock.getInputStream());
					PrintStream ps = new PrintStream(sock.getOutputStream());
					QRGutils.debug("EMailDialog","actionPerformed start=" + dis.readLine());
					ps.print("helo " + eMailAddress.getText() + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed helo=" + dis.readLine());
					ps.print("mail from: " + eMailAddress.getText() + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed " + "mail from: " + eMailAddress.getText());
					QRGutils.debug("EMailDialog","actionPerformed mail=" + dis.readLine());
// TEMPORARY KLUDGE UNTIL ROBOTA IS RUNNING
					if (bugReport.isSelected()) ps.print("rcpt to: " + "vmodelbugs@cs.northwestern.edu" + "\r\n");
					else ps.print("rcpt to: " + coachAddress.getText() + "\r\n");
					//ps.print("rcpt to: " + coachAddress.getText() + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed " + "rcpt to: " + coachAddress.getText());
					QRGutils.debug("EMailDialog","actionPerformed rcpt=" + dis.readLine());
					ps.print("data" + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed data=" + dis.readLine());
// TEMPORARY KLUDGE UNTIL ROBOTA IS RUNNING
					if (bugReport.isSelected()) ps.print("TO: " + "vmodelbugs@cs.northwestern.edu" + "\r\n");
					else ps.print("TO: " + coachAddress.getText() + "\r\n");
					// ps.print("TO: " + coachAddress.getText() + "\r\n");
					ps.print("FROM: " + eMailAddress.getText() + "\r\n");
					ps.print("SUBJECT: " + eMailSubject.getText() + "\r\n\r\n");
					ps.println(PROJECT + " v" + VERSION + "\n");
					ps.println("Student: " + gui().preferences().getString("NAME") + "\n");
					if (bugReport.isSelected()) ps.println("REQUEST: Bug Report\n");
					else if (helpRequest.isSelected()) ps.println("REQUEST: VModel Help\n");
					else ps.println("REQUEST: VModel Coach\n");
					ps.println("MESSAGE:");
					ps.println("\"" + eMailMessage.getText() + "\"\n");
					if (gui().selectedModel() != null) {
						ps.println("Model:");
						ps.println(gui().selectedModel().modelElement());
					} // end if model
					ps.print("\r\n" + "." + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed data2=" + dis.readLine());
					ps.print("quit" + "\r\n");
					QRGutils.debug("EMailDialog","actionPerformed quit=" + dis.readLine());
					ps.flush();
					sock.close();
				} catch (Exception exc) { exc.printStackTrace();}
				parent.hide();
    		} else if (e.getSource() == cancel) parent.hide(); //System.exit(-1);
    	} // method actionPerformed
    	
    	public InfoPane ( EMailDialog parent ) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		//textPanel = new JPanel(new GridLayout(22, 1));
    		textPanel = new JPanel();
    		textPanel.add(new JLabel("To:"));
    		textPanel.add(coachAddress);
    		textPanel.add(new JLabel("From:"));
    		textPanel.add(eMailAddress);
    		textPanel.add(new JLabel("subject:"));
    		textPanel.add(eMailSubject);
    		textPanel.add(new JLabel("Purpose:"));
    		textPanel.add(bugReport);
    		textPanel.add(helpRequest);
    		textPanel.add(coachRequest);
    		textPanel.add(new JLabel("Message:"));
    		textPanel.add(eMailMessage);
    		textPanel.setSize(getPreferredSize().width,200);
    		this.add(textPanel, BorderLayout.NORTH);

    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor InfoPane
    } // innerclass InfoPane

	// Constructor
	// --------------------------------------------------------------------------
	public EMailDialog( VModelGUI gui ) {
		super((Frame) null, "VModel Preferences");
    	setSize(430,385);
    	setModal(true);
		gui(gui);
		infoPane(this);
	} // constructor EMailDialog

} // class EMailDialog

// -----------------------------------------------------------------------------
// End of File: EMailDialog.java                (c) 2002 Northwestern University
