package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: HTMLbrowser.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: A Simple Web Browser. 
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import javax.swing.*;
import java.util.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import java.net.*;
import javax.swing.filechooser.*;
import javax.swing.text.*;
import javax.swing.text.html.*;

// -----------------------------------------------------------------------------
// Notes:
// * Very simple to suit the task in VModel.
// * Need to add a toolbar with forward/backward
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: HTMLbrowser
// Description: A Simple Web Browser. 
// -----------------------------------------------------------------------------
public class HTMLbrowser extends JFrame implements VModelConstants, HyperlinkListener, 
			ActionListener, WindowConstants, SwingConstants, KeyListener {
	// Properties & Accessors 
	// -------------------------------------------------------------------------
	protected VModel system = null;
	public VModel system ( ) { return(system); }
	public VModel system ( VModel s ) { return(system = s); }

	protected JTextPane viewPane = null;
	public JTextPane viewPane ( ) {
		if (viewPane == null) {
			viewPane(new JTextPane());
			viewPane.setEditable(false);
			viewPane.addHyperlinkListener(this);
		} // end if viewPane 
		return( viewPane ); 
	} // reader viewPane
	public JTextPane viewPane ( JTextPane v ) { return( viewPane = v); }

	protected JScrollPane scrollPane = null;
	public JScrollPane scrollPane ( ) {
		if (scrollPane == null) {
			scrollPane(new JScrollPane()); 
			if (scrollPane.getViewport() == null) scrollPane.setViewport(new JViewport());
			scrollPane.getViewport().setView(viewPane());
		} // end if scrollPane
		return( scrollPane ); 
	} // reader JScrollPane
	public JScrollPane scrollPane ( JScrollPane s ) { return( scrollPane = s); }

    protected JLabel statusbar = null;
	public JLabel statusbar( ) { 
		if (statusbar == null) {
			statusbar(new JLabel(" "));
			statusbar.setBorder(new LineBorder(GREY, 2));
		} // end if statusbar
		return( statusbar ); 
	} // reader statusbar
	public JLabel statusbar( JLabel s ) { return( statusbar = s ); }

    protected JButton back = null;
	public JButton back( ) { return( back ); }
	public JButton back( JButton b ) { return( back = b ); }

    protected JButton forward = null;
	public JButton forward( ) { return( forward ); }
	public JButton forward( JButton b ) { return( forward = b ); }

    protected Stack forwardStack = null;
	public Stack forwardStack( ) { 
		if (forwardStack == null) forwardStack(new Stack());
		return( forwardStack ); 
	} // reader forwardStack
	public Stack forwardStack( Stack b ) { return( forwardStack = b ); }

    protected Stack backStack = null;
	public Stack backStack( ) { 
		if (backStack == null) backStack(new Stack());
		return( backStack ); 
	} // reader backStack
	public Stack backStack( Stack b ) { return( backStack = b ); }

    protected String currentAddress = "";
	public String currentAddress( ) { return( currentAddress ); }
	public String currentAddress( String b ) { return( currentAddress = b ); }

	// Methods
	// -------------------------------------------------------------------------
	public void gotoPage ( String base, String page ) {
		if ((page != null) && (page.length() > 0)) {
			setPage(base + page);
			setBase(base);
			setVisible(true);
		} // end if page
	} // setPage

	public void setPage ( String address ) {
		try { 
			setPage(new URL(address)); 
			currentAddress(address);
		} catch(Exception e) {
			try { 
				setPage(new URL("file://" + address));
			} catch(Exception e2) {
				QRGutils.debug("HTMLbrowsers", "setPage e=" + e2);
			} // end try - catch
		} // end try - catch
	} // setPage

	public void setPage ( URL address ) {
		try { 
			viewPane().setPage(address);
			if ((currentAddress() != null) && (currentAddress().length() > 0)) {
				backStack().push(currentAddress());
				back().setEnabled(true);
			} // end if currentAddress
			currentAddress(address.toString());
			forwardStack(null);
			forward().setEnabled(false);
		} catch(Exception e) {
			QRGutils.debug("HTMLbrowsers", "setPage url e=" + e);
		} // end try - catch
	} // setPage

	public void setPageAux ( String address ) {
		try { 
			setPageAux(new URL(address)); 
			currentAddress(address);
		} catch(Exception e) {
			try { 
				setPageAux(new URL("file://" + address));
			} catch(Exception e2) {
				QRGutils.debug("HTMLbrowsers", "setPage e=" + e2);
			} // end try - catch
		} // end try - catch
	} // setPageAux

	public void setPageAux ( URL address ) {
		try { 
			viewPane().setPage(address);
		} catch(Exception e) {
			QRGutils.debug("HTMLbrowsers", "setPage url e=" + e);
		} // end try - catch
	} // setPageAux

	public void setBase ( String address ) {
		try { setBase(new URL(address)); }
		catch(Exception e) {
			try { setBase(new URL("file://" + address)); }
			catch(Exception e2) {
				QRGutils.debug("HTMLbrowsers", "setBase e=" + e2);
			} // end try - catch
		} // end try - catch
	} // setBase

	public void setBase ( URL address ) {
		try { 
			((HTMLDocument) viewPane().getDocument()).setBase(address);
		} catch(Exception e) {
			QRGutils.debug("HTMLbrowsers", "setBase url e=" + e);
		} // end try - catch
	} // setBase

	public String statusbar( String s ) {
		statusbar().setText(s); 
		return( statusbar().getText() ); 
	} // method statusbar

	// HyperlinkListener Methods
	// -------------------------------------------------------------------------
	public void hyperlinkUpdate(HyperlinkEvent e) {
		if (e.getEventType() == HyperlinkEvent.EventType.ENTERED) {
			statusbar(e.getURL().toString());
		} else if (e.getEventType() == HyperlinkEvent.EventType.EXITED) {
			statusbar(" ");
		} else if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
			JEditorPane pane = (JEditorPane) e.getSource();
			if (e instanceof HTMLFrameHyperlinkEvent) {
				HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
				HTMLDocument doc = (HTMLDocument)pane.getDocument();
				doc.processHTMLFrameHyperlinkEvent(evt);
			} else {
				try {
					setPage(e.getURL());
				} catch (Throwable t) {
					QRGutils.debug("HTMLbrowser", "hyperlinkUpdate e=" + e);
					t.printStackTrace();
				} // end try - catch
			} // end if HTMLFrameHyperlinkEvent
		} // end if eventType
	} // method hyperlinkUpdate
	
	
	// ActionListener Methods
	// -------------------------------------------------------------------------
	public void actionPerformed (ActionEvent e ) {
		String foo = "";
		if (e.getSource() == back()) {
			if (!backStack().empty()) {
				if ((currentAddress() != null) && (currentAddress().length() > 0)) {
					forwardStack().push(currentAddress());
					forward.setEnabled(true);
				} // end if currentAddress
				foo = (String) backStack().pop();
				setPageAux(foo);
				if (backStack().empty()) back.setEnabled(false);
			} // end if empty
		} else if (e.getSource() == forward()) {
			if (!forwardStack().empty()) {
				if ((currentAddress() != null) && (currentAddress().length() > 0)) {
					backStack().push(currentAddress());
					back.setEnabled(true);
				} // end if currentAddress
				foo = (String) forwardStack().pop();
				setPageAux(foo);
				if (forwardStack().empty()) forward.setEnabled(false);
			} // end if empty
		} // end if source
	} // method actionPerformed

	// KeyListener methods
	// -----------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	} // method keyTyped
	
	public void keyPressed(KeyEvent e) {
		int kcode = e.getKeyCode();
		int kmod = e.getModifiers();

		// Window
		if ((kcode == KeyEvent.VK_W) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			setVisible(false);

		// model operations
		if ((kcode == KeyEvent.VK_LEFT) || ((QRGutils.detectPlatform() == MACINTOSH) && (kcode == KeyEvent.VK_BACK_SPACE)))
			back().doClick();
		
		if ((kcode == KeyEvent.VK_RIGHT) || ((QRGutils.detectPlatform() == MACINTOSH) && (kcode == KeyEvent.VK_SPACE)))
			forward().doClick();
	} // Method keyPressed
	
	public void keyReleased(KeyEvent e) {
	} // Method keyReleased

	// Constructors
	// -------------------------------------------------------------------------
	public HTMLbrowser ( VModel system ) { 
		super(); 
		system(system);
		JPanel south = new JPanel(new BorderLayout());
		JPanel buttons = new JPanel(new GridLayout(1,2));
		addKeyListener(this);
		getContentPane().addKeyListener(this);
		buttons.addKeyListener(this);
		back(new JButton(system().gui().getImage("back.gif")));
		back().addActionListener(this);
		back().setEnabled(false);
		back().addKeyListener(this);
		buttons.add(back());
		forward(new JButton(system().gui().getImage("forward.gif")));
		forward().addActionListener(this);
		forward().setEnabled(false);
		forward().addKeyListener(this);
		buttons.add(forward());
		south.add(buttons, BorderLayout.WEST);
		south.add(statusbar(), BorderLayout.CENTER);
		south.addKeyListener(this);
		getContentPane().add(south, BorderLayout.SOUTH);
		getContentPane().add(scrollPane(), BorderLayout.CENTER);
		scrollPane().addKeyListener(this);
		viewPane().addKeyListener(this);
		statusbar().addKeyListener(this);
		setSize(640,480);
		setLocation(QRGutils.center(getSize()));
		setTitle("VModel Help");
		setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
		setIconImage(system().gui().icon());
		setVisible(false);
	} // constructor HTMLbrowser
	
	public HTMLbrowser ( VModel system, String base, String page ) { 
		this(system); 
		gotoPage(base, page);
	} // constructor HTMLbrowser
	
	public HTMLbrowser ( VModel system, String page ) { 
		this(system, QRGutils.QRGroot() + HELPPATH, page); 
	} // constructor HTMLbrowser
	
} // class HTMLbrowser
    
// -----------------------------------------------------------------------------
// End of File: HTMLbrowser.java                (c) 2001 Northwestern University