package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelAttribute.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: A tag - value pair.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Notes:
// * 
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelAttribute 
// Description: A tag - value pair.
// -----------------------------------------------------------------------------
public class VModelAttribute implements VModelConstants, Cloneable {
   // Properties & Accessors
   // --------------------------------------------------------------------------
   protected static int count = 0; // class allocated
   public static int count ( ) { return(count); }
   public static int count ( int c ) { return(count = c); }

   protected int id = -1;
   public int id ( ) { return(id); }
   public int id ( int i ) { return(id = i); }

   protected String tag = "";
   public String tag ( ) { return(tag); }
   public String tag ( String t ) { return( tag = t.toUpperCase() ); }

   protected Object value = null;
   public Object value ( ) { return(value); }
   public Object value ( Object v ) { return( value = v ); }

   // Method: toString
   // --------------------------------------------------------------------------
   public String toString ( ) { return( tag() + " = \"" + value() + "\"" ); }

   // Method: clone
   // --------------------------------------------------------------------------
   public Object clone ( ) {
   	VModelAttribute result =  new VModelAttribute( );
   	result.tag(new String(tag()));
   	if (value instanceof String) result.value(new String((String)value()));
   	else result.value(value());
   	return( result ); 
   } // method clone

   // Constructors
   // --------------------------------------------------------------------------
   public VModelAttribute( ) {
		id(count++);
   } // constructor VModelAttribute

   public VModelAttribute( String tag, Object value) {
      this();
		tag(tag);
		value(value);
   } // constructor VModelAttribute

   public VModelAttribute( Object value) {
       this(value.getClass().getName(), value);
   } // constructor VModelAttribute

} // class VModelAttribute

// -----------------------------------------------------------------------------
// End of File: VModelAttribute.java            (c) 2001 Northwestern University
