package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelCoach.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelCoach gathers together an Intelligent Tutor and several
//            utilities for explanation generation, student scaffolding, and
//            help.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;

// -----------------------------------------------------------------------------
// Class: VModelCoach
// Description: VModel Coach provides tutoring and explanations. 
// Properties:
//   VModel vmodel - Reference back to VModel system class.
// -----------------------------------------------------------------------------
public class VModelCoach implements VModelConstants {
	public VModel system; // Reference back to VModel system class.
	
	// Emotional State
	public static final int HAPPY = 0;
	public static final int INDIFFERENT = 1;
	public static final int ANGRY = 2;
	public static final int PUZZLED = 3;
	public int state = HAPPY;

	// --------------------------------------------------------------------------
	// Method: VModelCoach
	// Description: This is the constructor method for the class.
	// -----------------------------------------------------------------------
	public VModelCoach(VModel system) {
		system(system);
	} // constructor VModelCoach

	// Property Accessors
	// -----------------------------------------------------------------------
	public VModel system( ) { return(system); } 
	public VModel system( VModel s ) { return(system = s); } 

	public int state( ) { return(state); } 
	public int state( int s ) { return(state = s); } 

} // class VModelCoach

// -----------------------------------------------------------------------------
// End of File: VModelCoach.java                (c) 2001 Northwestern University
