package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/source
// -----------------------------------------------------------------------------
// File name: VModelGUI.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModel main window.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.applet.*;
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.net.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import java.awt.image.*;
import edu.qrg.vmodel.controllers.common.*;
import com.sun.jimi.core.*;			
import com.sun.jimi.core.options.*;

// -----------------------------------------------------------------------------
// NOTES: 
// Main gui parts: menubar, toolbar, tree, desktop, statusbar, helpbrowser
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelGUI
// Description: VModel GUI manager. 
// -----------------------------------------------------------------------------
public class VModelGUI 
	   implements VModelConstants, WindowConstants, SwingConstants,
	   			  VModelEvent.VModelEventListener, KeyListener, WindowListener {
	// Properties and Accessors
	// --------------------------------------------------------------------------
	protected VModel system = null;
	public VModel system ( ) { return(system); }
	public VModel system ( VModel s ) { return(system = s); }

	protected Container frame = null;
	public Container frame ( ) { return(frame); }
	public Container frame ( Container f ) { return(frame = f); }
				  
    protected JLabel statusbar = null;
	public JLabel statusbar( ) { 
		if (statusbar == null) {
			statusbar(new JLabel(PROJECT + " v" + VERSION + 
					 		     " Copyright " + COPYRIGHT + " " + 
							  	 COPYRIGHTATTRIBUTION + "  MEM:" +
							  	 Runtime.getRuntime().totalMemory() + "/" +
							  	 Runtime.getRuntime().freeMemory()));
			statusbar.setBorder(new LineBorder(GREY, 2));
			getContentPane().add(statusbar, BorderLayout.SOUTH);
			statusbar.setVisible(true);
			getContentPane().validate();
		} // end if statusbar
		return( statusbar ); 
	} // reader statusbar
	public JLabel statusbar( JLabel s ) { return( statusbar = s ); }

	protected boolean frameContainment = false;
	public boolean frameContainment( ) { return( frameContainment ); }
	public boolean frameContainment( boolean c ) { return( frameContainment = c ); }
	
	protected Container VModelGUISplash = null;
	public Container VModelGUISplash( ) { return( VModelGUISplash ); }
	public Container VModelGUISplash( Container c ) { return( VModelGUISplash = c ); }
	
	protected PrintPreviewDialog printPreview = null;
	public PrintPreviewDialog printPreview ( ) { return( printPreview ); }
	public PrintPreviewDialog printPreview ( PrintPreviewDialog p ) { return( printPreview = p ); }

	protected ModelOverviewDialog modelOverview = null;
	public ModelOverviewDialog modelOverview ( ) { return( modelOverview ); }
	public ModelOverviewDialog modelOverview ( ModelOverviewDialog p ) { return( modelOverview = p ); }

    // images
    protected Vector images = null;
	public Vector images( ) {
		if (images == null) images = new Vector(); 
		return( images ); 
	} // reader images
	public Vector images( Vector i ) { return( images = i ); }

    protected Image icon = null;
	public Image icon( ) { return( icon ); }
	public Image icon( Image i ) { return( icon = i ); }

    protected ImageIcon backgroundImage = null;
	public ImageIcon backgroundImage( ) { return( backgroundImage ); }
	public ImageIcon backgroundImage( ImageIcon i ) { return( backgroundImage = i ); }

    protected Vector clipboard = null;
	public Vector clipboard( ) {
		if (clipboard == null) clipboard(new Vector()); 
		return( clipboard ); 
	} // method clipboard
	public Vector clipboard( Vector c ) { return( clipboard = c ); }

//    public ImageIcon [] smileys;
			    
    protected Vector models = null;
	public Vector models( ) {
		if (models == null) models = new Vector(); 
		return( models ); 
	} // reader models
	public Vector models( Vector m ) { return( models = m ); }

	protected JFileChooser fileDialog = null;
	public JFileChooser fileDialog ( ) {
		if (fileDialog == null) {
			fileDialog(new JFileChooser() {
				public void approveSelection() {
					boolean approve = false;
					String filename = getSelectedFile().getName();
					String suffix = "";
					String preferredSuffix = "";
					javax.swing.filechooser.FileFilter filter = getFileFilter();
					if (filter == modelFileFilter()) preferredSuffix = "." + VMODEL_SUFFIX;
					else if (filter == jpgFileFilter()) preferredSuffix = "." + JPEG_SUFFIX;
					else if (filter == tifFileFilter()) preferredSuffix = "." + TIFF_SUFFIX;
					else if (filter == htmlFileFilter()) preferredSuffix = "." + HTML_SUFFIX;
					suffix = filename.substring(filename.length() - preferredSuffix.length(), filename.length());
					if (suffix.equalsIgnoreCase(preferredSuffix)) {
						if (!getApproveButtonText().equalsIgnoreCase("OPEN")) { // assume save dialog
							if (!getSelectedFile().exists()) approve = true;
							else approve = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The file, " + filename + ", already exists.\n Do you want to overwrite it?", "Alert! File Exists", JOptionPane.YES_NO_OPTION));
						} else approve = true;
					} else {
						JOptionPane.showMessageDialog(null, "Your filename must end with " + preferredSuffix, "Alert! Improper Filename.", JOptionPane.ERROR_MESSAGE);
					} // end if preferredSuffix
					if (approve) super.approveSelection();
				} // method approveSelection
			}); // anonymous subclass
			fileDialog.setFileHidingEnabled(true);
//			fileDialog.setFileSelectionMode(JFileChooser.FILES_ONLY);
			fileDialog.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
			fileDialog.setMultiSelectionEnabled(false);
		} // if fileDialog
		return( fileDialog );
	} // reader fileDialog
	public JFileChooser fileDialog ( JFileChooser f ) { return( fileDialog = f ); }
	
	protected VModelFileFilter modelFileFilter = null;
	public VModelFileFilter modelFileFilter ( ) {
		if (modelFileFilter == null) modelFileFilter(new VModelFileFilter(VMODEL_SUFFIX,"VModel File"));
		return( modelFileFilter );
	} // reader modelFileFilter
	public VModelFileFilter modelFileFilter ( VModelFileFilter f ) { return( modelFileFilter = f ); }
	
	protected VModelFileFilter jpgFileFilter = null;
	public VModelFileFilter jpgFileFilter ( ) {
		if (jpgFileFilter == null) jpgFileFilter(new VModelFileFilter(JPEG_SUFFIX,"JPEG File"));
		return( jpgFileFilter );
	} // reader jpgFileFilter
	public VModelFileFilter jpgFileFilter ( VModelFileFilter f ) { return( jpgFileFilter = f ); }
	
	protected VModelFileFilter tifFileFilter = null;
	public VModelFileFilter tifFileFilter ( ) {
		if (tifFileFilter == null) tifFileFilter(new VModelFileFilter(TIFF_SUFFIX,"TIFF File"));
		return( tifFileFilter );
	} // reader tifFileFilter
	public VModelFileFilter tifFileFilter ( VModelFileFilter f ) { return( tifFileFilter = f ); }
	
	protected VModelFileFilter htmlFileFilter = null;
	public VModelFileFilter htmlFileFilter ( ) {
		if (htmlFileFilter == null) htmlFileFilter(new VModelFileFilter(HTML_SUFFIX,"HTML File"));
		return( htmlFileFilter );
	} // reader htmlFileFilter
	public VModelFileFilter htmlFileFilter ( VModelFileFilter f ) { return( htmlFileFilter = f ); }
	
	protected VModelFileFilter cmlFileFilter = null;
	public VModelFileFilter cmlFileFilter ( ) {
		if (cmlFileFilter == null) cmlFileFilter(new VModelFileFilter(CML_SUFFIX, "Compositional Modeling Language File"));
		return( cmlFileFilter );
	} // reader cmlFileFilter
	public VModelFileFilter cmlFileFilter ( VModelFileFilter f ) { return( cmlFileFilter = f ); }
	
	protected VModelModel selectedModel = null;
	public VModelModel selectedModel ( ) { return( selectedModel ); }
	public VModelModel selectedModel ( VModelModel s ) { return( selectedModel = s ); }
	
	protected ModelsDesktopPane modelsDesktop = null;
	public ModelsDesktopPane modelsDesktop ( ) {
		if (modelsDesktop == null) modelsDesktop(new ModelsDesktopPane());
		return( modelsDesktop );
	} // reader modelsDesktop
	public ModelsDesktopPane modelsDesktop ( ModelsDesktopPane m ) { return( modelsDesktop = m ); }

	protected BackgroundPanel backgroundPane = null;
	public BackgroundPanel backgroundPane ( ) {
		if (backgroundPane == null) backgroundPane(new BackgroundPanel(new BorderLayout()));
		return( backgroundPane );
	} // reader backgroundPane
	public BackgroundPanel backgroundPane ( BackgroundPanel b ) { return( backgroundPane = b ); }

	protected JPanel outsidePanel = null;
	public JPanel outsidePanel ( ) {
		if (outsidePanel == null) outsidePanel(new JPanel(new BorderLayout()));
		return( outsidePanel );
	} // reader outsidePanel
	public JPanel outsidePanel ( JPanel o ) { return( outsidePanel = o ); }

	protected JPanel insidePanel = null;
	public JPanel insidePanel ( ) {
		if (insidePanel == null) insidePanel(new JPanel(new BorderLayout()));
		return( insidePanel );
	} // reader insidePanel
	public JPanel insidePanel ( JPanel i ) { return( insidePanel = i ); }

    protected JFrame ontologyFrame = null;
	public JFrame ontologyFrame ( ) { return( ontologyFrame ); } 
	public JFrame ontologyFrame ( JFrame o ) { return( ontologyFrame = o ); }

    protected JSplitPane splitpane = null;
	public JSplitPane splitpane ( ) { return( splitpane ); } 
	public JSplitPane splitpane ( JSplitPane i ) { return( splitpane = i ); }
	
	protected HTMLbrowser browser = null;
	public HTMLbrowser browser ( ) { 
		if (browser == null) browser(new HTMLbrowser());
		return( browser ); 
	} // reader browser
	public HTMLbrowser browser ( HTMLbrowser b ) { return( browser = b ); }

	protected VModelPreferencesDialog preferencesDialog = null;
	public VModelPreferencesDialog preferencesDialog ( ) { 
		if (preferencesDialog == null) preferencesDialog(new VModelPreferencesDialog(this));
		return( preferencesDialog ); 
	} // reader preferencesDialog
	public VModelPreferencesDialog preferencesDialog ( VModelPreferencesDialog b ) { return( preferencesDialog = b ); }

	protected EMailDialog eMailDialog = null;
	public EMailDialog eMailDialog ( ) { 
		if (eMailDialog == null) eMailDialog(new EMailDialog(this));
		return( eMailDialog ); 
	} // reader eMailDialog
	public EMailDialog eMailDialog ( EMailDialog b ) { return( eMailDialog = b ); }

	// Toolbars 
	protected JToolBar modeToolbar = null;
	public JToolBar modeToolbar ( ) { 
		if (modeToolbar == null) modeToolbar(new JToolBar());
		return(modeToolbar);
	} // reader modeToolbar
	public JToolBar modeToolbar ( JToolBar t ) { return( modeToolbar = t ); }

	protected JToolBar coachToolbar = null;
	public JToolBar coachToolbar ( ) { 
		if (coachToolbar == null) coachToolbar(new JToolBar());
		return(coachToolbar);
	} // reader coachToolbar
	public JToolBar coachToolbar ( JToolBar t ) { return( coachToolbar = t ); }

	protected JToolBar editToolbar = null;
	public JToolBar editToolbar ( ) { 
		if (editToolbar == null) editToolbar(new JToolBar());
		return(editToolbar);
	} // reader editToolbar
	public JToolBar editToolbar ( JToolBar t ) { return( editToolbar = t ); }

	protected JButton problemMode = null;
	public JButton problemMode ( ) { 
		if (problemMode == null) {
			problemMode(new JButton("Problem Statement", getImage("prob-statement.jpg")));
			problemMode.setToolTipText("Problem Statement Mode");
			problemMode.addKeyListener(system().gui());
			problemMode.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					modeChange("PROBLEM");
					//hilite(problemMode);
				} // method actionPerformed
			}); // ActionListener
		} // end if problemMode
		return(problemMode);
	} // reader problemMode
	public JButton problemMode ( JButton b ) { return( problemMode = b ); }

	protected JButton buildMode = null;
	public JButton buildMode ( ) { 
		if (buildMode == null) {
			buildMode(new JButton("Build Model", getImage("model-mode.jpg")));
			buildMode.addKeyListener(system().gui());
			buildMode.setToolTipText("Build Model Mode");
			buildMode.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					modeChange("BUILD");
					//hilite(buildMode);
				} // method actionPerformed
			}); // ActionListener
		} // end if buildMode
		return(buildMode);
	} // reader buildMode
	public JButton buildMode ( JButton b ) { return( buildMode = b ); }

	protected JButton selectButton = null;
	public JButton selectButton ( ) { 
		if (selectButton == null) {
			selectButton(new JButton(getImage("hand.gif")));
			selectButton.setToolTipText("Select items.");
			selectButton.addKeyListener(system().gui());
			selectButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					VModelPeerOntology.selectedTree(null);
					VModelPeerOntology.selectedOntology(null);
				} // method actionPerformed
			}); // ActionListener
		} // end if selectButton
		return(selectButton);
	} // reader selectButton
	public JButton selectButton ( JButton b ) { return( selectButton = b ); }

	protected JButton groupButton = null;
	public JButton groupButton ( ) { 
		if (groupButton == null) {
			groupButton(new JButton(getImage("group.jpg")));
			groupButton.setToolTipText("Group selected items.");
			groupButton.addKeyListener(system().gui());
			groupButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					((VModelPeerModel) selectedModel().modelElement().peer()).groupSelected();
				} // method actionPerformed
			}); // ActionListener
		} // end if groupButton
		return(groupButton);
	} // reader groupButton
	public JButton groupButton ( JButton b ) { return( groupButton = b ); }

	protected JButton deleteButton = null;
	public JButton deleteButton ( ) { 
		if (deleteButton == null) {
			deleteButton(new JButton(getImage("delete.jpg")));
			deleteButton.setToolTipText("Delete selected items.");
			deleteButton.addKeyListener(system().gui());
			deleteButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (selectedModel() != null) delete(); 
				} // method actionPerformed
			}); // ActionListener
		} // end if deleteButton
		return(deleteButton);
	} // reader deleteButton
	public JButton deleteButton ( JButton b ) { return( deleteButton = b ); }

	protected JButton cutButton = null;
	public JButton cutButton ( ) { 
		if (cutButton == null) {
			cutButton(new JButton(getImage("cut.gif")));
			cutButton.setToolTipText("Cut selected items.");
			cutButton.addKeyListener(system().gui());
			cutButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (selectedModel() != null) cut(); 
				} // method actionPerformed
			}); // ActionListener
		} // end if cutButton
		return(cutButton);
	} // reader cutButton
	public JButton cutButton ( JButton b ) { return( cutButton = b ); }

	protected JButton copyButton = null;
	public JButton copyButton ( ) { 
		if (copyButton == null) {
			copyButton(new JButton(getImage("copy.gif")));
			copyButton.setToolTipText("Copy selected items.");
			copyButton.addKeyListener(system().gui());
			copyButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (selectedModel() != null) copy(); 
				} // method actionPerformed
			}); // ActionListener
		} // end if copyButton
		return(copyButton);
	} // reader copyButton
	public JButton copyButton ( JButton b ) { return( copyButton = b ); }

	protected JButton pasteButton = null;
	public JButton pasteButton ( ) { 
		if (pasteButton == null) {
			pasteButton(new JButton(getImage("paste.gif")));
			pasteButton.setToolTipText("Paste selected items.");
			pasteButton.addKeyListener(system().gui());
			pasteButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					if (selectedModel() != null) paste(); 
				} // method actionPerformed
			}); // ActionListener
		} // end if pasteButton
		return(pasteButton);
	} // reader pasteButton
	public JButton pasteButton ( JButton b ) { return( pasteButton = b ); }

	protected JButton coachButton = null;
	public JButton coachButton ( ) { 
		if (coachButton == null) {
			coachButton(new JButton(getImage("smiley-coach.gif")));
			coachButton.setToolTipText("Build mode coach.");
			coachButton.addKeyListener(system().gui());
			coachButton.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					grammarCheck();
				} // method actionPerformed
			}); // ActionListener
		} // end if coachButton
		return(coachButton);
	} // reader coachButton
	public JButton coachButton ( JButton b ) { return( coachButton = b ); }
	
	public void grammarCheck ( ) {
		if (selectedModel() != null) {
			VModelElement mumble = null;
			VModelPeerRelationship grumble = null;
			int count = 0, errcount = 0;
			JPopupMenu popupMenu = new JPopupMenu("VModel Coach");
			JMenuItem menuItem = null;
			boolean check = false;
			boolean icheck = false;
			String label = "";
			for(int i = 0; i < selectedModel().allElements().size(); i++) {
				mumble = (VModelElement) selectedModel().allElements().elementAt(i);
				if (mumble.typep("RELATIONSHIP")) {
					grumble = (VModelPeerRelationship) mumble.peer();
					check = true;
					icheck = true;
					label = "";
					if (mumble.input() != null) {
						icheck = selectedModel().checkConnectableInput(mumble, mumble.input());
						check &= icheck;
						if (!icheck) label += mumble.input().getString("LABEL") + "->";
					}
					label += mumble.getString("LABEL");
					if (mumble.output() != null) {
						icheck = selectedModel().checkConnectableOutput(mumble, mumble.output());
						check &= icheck;
						if (!icheck) label += "->" + mumble.output().getString("LABEL");
					}
					menuItem = new CoachMenuItem(label,mumble);
					if (check) menuItem.setIcon(getImage("smiley-coach-small.gif"));
					else {
						menuItem.setIcon(getImage("puzzle-coach-small.gif"));
						errcount++;
					} 
					popupMenu.add(menuItem);
					count++;
				} // end if relationship
			} // for i
			if ((count == 0) || (errcount == 0)) JOptionPane.showMessageDialog(null, "No worries, Mate.", "VModel Coach", JOptionPane.ERROR_MESSAGE,getImage("professor-coach.jpg"));
			else popupMenu.show((Component) selectedModel().peer(),0,0);
		} // end if selectedModel
	} // method grammarCheck
	
	public CoachMenuItem makeCoachMenuItem ( String l, VModelElement r ) { return( new CoachMenuItem(l,r)); }
	
	public class CoachMenuItem extends JMenuItem implements ActionListener {
		VModelElement relationship = null;
		String rlabel = "";
		public void actionPerformed ( ActionEvent e ) {
			String message = "The connection between " + rlabel + " does not work becuase:\r\n\r\n";
			String rLabel = relationship.getString("LABEL");
			String sLabel = "";
			String dLabel = "";
			boolean flag = false;
			if ((relationship.input() != null) && 
				 !selectedModel().checkConnectableInput(relationship, relationship.input())) {
				flag = true;
				message += "Objects of type " + relationship.input().getString("TYPE") + " cannot be connected as input to a " + relationship.getString("LABEL") + " relationship.\r\n";
				message += "Because " + relationship.getString("LABEL") + " is a " + relationship.getString("CATEGORY") + ".\r\n";
				message += "And objects of type " + relationship.input().getString("TYPE") + " can only be connected as input to\r\n";
				message += "relationships of type(s): " + relationship.input().getString("ALLOWED-OUTPUTS") + ".\r\n\r\n";
			}
			if ((relationship.output() != null) &&
				 !selectedModel().checkConnectableOutput(relationship, relationship.output())) {
				flag = true;
				message += "Objects of type " + relationship.output().getString("TYPE") + " cannot be connected as output from a " + relationship.getString("LABEL") + " relationship.\r\n";
				message += "Because " + relationship.getString("LABEL") + " is a " + relationship.getString("CATEGORY") + ".\r\n";
				message += "And objects of type " + relationship.output().getString("TYPE") + " can only be connected as output\r\n";
				message += "from relationships of type(s): " + relationship.output().getString("ALLOWED-OUTPUTS") + ".\r\n\r\n";
			}
			String [] buttons = {"View help information on " + relationship.getString("TYPE") + " relationships.", "OK"};
			if (flag) {
				if (JOptionPane.YES_OPTION == JOptionPane.showOptionDialog(null, message, "VModel Coach", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE,getImage("professor-coach.jpg"), buttons, null)) {
					browser().setTitle("VModel Coach");
					browser().setSize(700,300);
					browser().setLocation(QRGutils.center(browser().getSize()));
					browser().gotoPage(QRGutils.QRGroot() + HELPPATH, relationship.getString("HELP-LINK"));
				}
			} else JOptionPane.showMessageDialog(null, "No worries, Mate.", "VModel Coach", JOptionPane.ERROR_MESSAGE,getImage("professor-coach.jpg"));
		} // method actionPerformed
		public CoachMenuItem ( String label, VModelElement r ) {
			super(label);
			addActionListener(this);
			relationship = r;
			rlabel = label;
		} // constructor CoachMenuItem
	} // innerclass CoachMenuItem

	public void grammarCheckAux ( ) {
		if (selectedModel() != null) {
			VModelElement mumble = null;
			VModelPeerRelationship grumble = null;
			double count = 0.0, errcount = 0.0;
			double score = 0.0;
			boolean check = false;
			String label = "";
			for(int i = 0; i < selectedModel().allElements().size(); i++) {
				mumble = (VModelElement) selectedModel().allElements().elementAt(i);
				if (mumble.typep("RELATIONSHIP")) {
					grumble = (VModelPeerRelationship) mumble.peer();
					check = true;
					if (mumble.input() != null) {
						check &= selectedModel().checkConnectableInput(mumble, mumble.input());
					}
					label += mumble.getString("LABEL");
					if (mumble.output() != null) {
						check &= selectedModel().checkConnectableOutput(mumble, mumble.output());
					}
					if (!check) errcount++;
					count++;
				} // end if relationship
			} // for i
			if (count == 0) score = 1.0;
			else score = (count - errcount) / count;
			if (score > 0.99) coachButton().setIcon(getImage("smiley-coach.jpg"));
			else if (score > 0.00) coachButton().setIcon(getImage("puzzle-coach.jpg"));
			else coachButton().setIcon(getImage("frowny-coach.jpg"));
			coachButton().setBackground(new Color((int)Math.floor(128+((1.0 - score) * 127.0)), (int)Math.floor(128-((1.0 - score) * 127.0)), (int)Math.floor(128-((1.0 - score) * 127.0))));
		} // end if selectedModel
	} // method grammarCheck


// www.pcdi.com
	
	protected int groupColorIndex = -1;
	protected Color [] groupColors = {GREEN,YELLOW,PURPLE,DARKRED,LIGHTPINK,ORANGE,CYAN,LAVENDER,YUCKYPUCE,NUTBROWN,
	                               GRASSGREEN,ROYALBLUE,DARKYELLOW,MAGENTA,PLUM,
	                               DARKGRASSGREEN,DARKYUCKYPUCE,GREENBROWN,
								   BRIGHTGREEN,LIGHTYELLOW,SKYBLUE,DARKPINK,
								   DARKGREEN,DARKLAVENDER,REDBROWN,DARKGOLD,
								   MEDIUMGREEN,DARKSKYBLUE,LIGHTBROWN,LIGHTBLUE,REDORANGE};
	public Color groupColor ( ) {
		groupColorIndex++;
		if (groupColorIndex >= groupColors.length) groupColorIndex = 0;
		return(groupColors[groupColorIndex]);
	} // method groupColor

	// menubar 
	// --------------------------------------------------------------------------
	protected JMenuBar menubar = null;
	public JMenuBar menubar ( ) {
		if (menubar == null) menubar(new JMenuBar());
		return(menubar);
	} // reader menubar
	public JMenuBar menubar ( JMenuBar m ) { return( menubar = m ); }

  	protected JMenu menuFile = null;
  	public JMenu menuFile ( ) {
  		if (menuFile == null) menuFile = new JMenu("File");
  		return(menuFile);
  	} // reader menuFile
  	public JMenu menuFile ( JMenu m ) { return(menuFile = m); }

  	protected JMenuItem menuFileNew = null;
  	public JMenuItem menuFileNew ( ) {
  		if (menuFileNew == null) {
  			menuFileNew = new JMenuItem("New Model", getImage("new.gif"));
  			menuFileNew.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								makeModel();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileNew
  		return(menuFileNew);
  	} // reader menuFileNew
  	public JMenuItem menuFileNew ( JMenuItem m ) { return( menuFileNew = m ); }

  	protected JMenuItem menuFileOpen = null;
  	public JMenuItem menuFileOpen ( ) {
  		if (menuFileOpen == null) {
  			menuFileOpen = new JMenuItem("Open Model File", getImage("open.gif"));
  			menuFileOpen.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								loadModel();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileOpen
  		return(menuFileOpen);
  	} // reader menuFileOpen
  	public JMenuItem menuFileOpen ( JMenuItem m ) { return( menuFileOpen = m ); }

  	protected JMenuItem menuFileSave = null;
  	public JMenuItem menuFileSave ( ) {
  		if (menuFileSave == null) {
  			menuFileSave = new JMenuItem("Save Model File", getImage("save.gif"));
  			menuFileSave.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								save();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // menuFileSave
  		} // end if menuFileSave
  		return(menuFileSave);
  	} // reader menuFileSave
  	public JMenuItem menuFileSave ( JMenuItem m ) { return( menuFileSave = m ); }

  	protected JMenuItem menuFileSaveAs = null;
  	public JMenuItem menuFileSaveAs ( ) {
  		if (menuFileSaveAs == null) {
  			menuFileSaveAs = new JMenuItem("Save Model File As");
  			menuFileSaveAs.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								save(false);
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // menuFileSaveAs
  		} // end if menuFileSaveAs
  		return(menuFileSaveAs);
  	} // reader menuFileSaveAs
  	public JMenuItem menuFileSaveAs ( JMenuItem m ) { return( menuFileSaveAs = m ); }

  	protected JMenu menuFileExport = null;
  	public JMenu menuFileExport ( ) {
  		if (menuFileExport == null) menuFileExport = new JMenu("Export");
  		return(menuFileExport);
  	} // reader menuFileExport
  	public JMenu menuFileExport ( JMenu m ) { return( menuFileExport = m ); }

  	protected JMenuItem menuFileExportJPG = null;
  	public JMenuItem menuFileExportJPG ( ) {
  		if (menuFileExportJPG == null) {
  			menuFileExportJPG = new JMenuItem("Export to JPEG");
  			menuFileExportJPG.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								saveImage(IMAGE_JPEG);
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // menuFileExportJPG
  		} // end if menuFileExportJPG
  		return(menuFileExportJPG);
  	} // reader menuFileExportJPG
  	public JMenuItem menuFileExportJPG ( JMenuItem m ) { return( menuFileExportJPG = m ); }

  	protected JMenuItem menuFileExportTIF = null;
  	public JMenuItem menuFileExportTIF ( ) {
  		if (menuFileExportTIF == null) {
  			menuFileExportTIF = new JMenuItem("Export to TIFF");
  			menuFileExportTIF.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								saveImage(IMAGE_TIFF);
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // menuFileExportTIF
  		} // end if menuFileExportTIF
  		return(menuFileExportTIF);
  	} // reader menuFileExportTIF
  	public JMenuItem menuFileExportTIF ( JMenuItem m ) { return( menuFileExportTIF = m ); }

  	protected JMenuItem menuFileExportHTML = null;
  	public JMenuItem menuFileExportHTML ( ) {
  		if (menuFileExportHTML == null) {
  			menuFileExportHTML = new JMenuItem("Export to HTML");
  			menuFileExportHTML.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								saveHTML();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // menuFileExportHTML
  		} // end if menuFileExportHTML
  		return(menuFileExportHTML);
  	} // reader menuFileExportHTML
  	public JMenuItem menuFileExportHTML ( JMenuItem m ) { return( menuFileExportHTML = m ); }

  	protected JMenuItem menuFileClose = null;
  	public JMenuItem menuFileClose ( ) {
  		if (menuFileClose == null) {
  			menuFileClose = new JMenuItem("Close");
  			menuFileClose.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								if (selectedModel() != null) closeModel(selectedModel());
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuFileClose);
  	} // reader menuFileClose
  	public JMenuItem menuFileClose ( JMenuItem m ) { return( menuFileClose = m ); }

  	protected JMenuItem menuFileCloseAll = null;
  	public JMenuItem menuFileCloseAll ( ) {
  		if (menuFileCloseAll == null) {
  			menuFileCloseAll = new JMenuItem("Close All");
  			menuFileCloseAll.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								closeAllModels();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileCloseAll
  		return(menuFileCloseAll);
  	} // reader menuFileCloseAll
  	public JMenuItem menuFileCloseAll ( JMenuItem m ) { return( menuFileCloseAll = m ); }

  	protected JMenuItem menuFilePrintPreview = null;
  	public JMenuItem menuFilePrintPreview ( ) {
  		if (menuFilePrintPreview == null) {
  			menuFilePrintPreview = new JMenuItem("Print Preview", getImage("preview.gif"));
  			menuFilePrintPreview.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								printPreview().show();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFilePrintPreview
  		return(menuFilePrintPreview);
  	} // reader menuFilePrintPreview
  	public JMenuItem menuFilePrintPreview ( JMenuItem m ) { return( menuFilePrintPreview = m ); }

  	protected JMenuItem menuFilePrint = null;
  	public JMenuItem menuFilePrint ( ) {
  		if (menuFilePrint == null) {
  			menuFilePrint = new JMenuItem("Print", getImage("print.gif"));
  			menuFilePrint.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								printModel();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFilePrint
  		return(menuFilePrint);
  	} // reader menuFilePrint
  	public JMenuItem menuFilePrint ( JMenuItem m ) { return( menuFilePrint = m ); }

  	protected JMenuItem menuFileExit = null;
  	public JMenuItem menuFileExit ( ) {
  		if (menuFileExit == null) {
  			menuFileExit = new JMenuItem("Exit");
  			menuFileExit.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
  								close();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuFileExit);
  	} // reader menuFileExit
  	public JMenuItem menuFileExit ( JMenuItem m ) { return( menuFileExit = m ); }

  	protected JMenu menuEdit = null;
  	public JMenu menuEdit ( ) {
  		if (menuEdit == null) menuEdit = new JMenu("Edit");
  		return(menuEdit);
  	} // reader menuEdit
  	public JMenu menuEdit ( JMenu m ) { return( menuEdit = m ); }

  	protected JMenuItem menuEditSelectAll = null;
  	public JMenuItem menuEditSelectAll ( ) {
  		if (menuEditSelectAll == null) {
  			menuEditSelectAll = new JMenuItem("Select All");
  			//menuEditSelectAll = new JMenuItem("Close");
  			menuEditSelectAll.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								if ((selectedModel() != null) && (selectedModel().modelElement() != null) && 
									(selectedModel().modelElement().peer() != null)) 
									((VModelPeerElement) selectedModel().modelElement().peer()).selectAll();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuEditSelectAll);
  	} // reader menuEditSelectAll
  	public JMenuItem menuEditSelectAll ( JMenuItem m ) { return( menuEditSelectAll = m ); }

  	protected JMenuItem menuEditCut = null;
  	public JMenuItem menuEditCut ( ) {
  		if (menuEditCut == null) {
  			menuEditCut = new JMenuItem("Cut", getImage("cut.gif"));
  			menuEditCut.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
					if (selectedModel() != null) cut(); 
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditCut
  		return(menuEditCut);
  	} // reader menuEditCut
  	public JMenuItem menuEditCut ( JMenuItem m ) { return( menuEditCut = m ); }

  	protected JMenuItem menuEditCopy = null;
  	public JMenuItem menuEditCopy ( ) {
  		if (menuEditCopy == null) {
  			menuEditCopy = new JMenuItem("Copy", getImage("copy.gif"));
  			menuEditCopy.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
					if (selectedModel() != null) copy(); 
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditCopy
  		return(menuEditCopy);
  	} // reader menuEditCopy
  	public JMenuItem menuEditCopy ( JMenuItem m ) { return( menuEditCopy = m ); }

  	protected JMenuItem menuEditPaste = null;
  	public JMenuItem menuEditPaste ( ) {
  		if (menuEditPaste == null) {
  			menuEditPaste = new JMenuItem("Paste", getImage("paste.gif"));
  			menuEditPaste.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
					if (selectedModel() != null) paste(); 
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditPaste
  		return(menuEditPaste);
  	} // reader menuEditPaste
  	public JMenuItem menuEditPaste ( JMenuItem m ) { return( menuEditPaste = m ); }

  	protected JMenuItem menuEditGroup = null;
  	public JMenuItem menuEditGroup ( ) {
  		if (menuEditGroup == null) {
  			menuEditGroup = new JMenuItem("Group", getImage("group.jpg"));
  			menuEditGroup.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
					((VModelPeerModel) selectedModel().modelElement().peer()).groupSelected();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditGroup
  		return(menuEditGroup);
  	} // reader menuEditGroup
  	public JMenuItem menuEditGroup ( JMenuItem m ) { return( menuEditGroup = m ); }

  	protected JMenuItem menuEditPreferences = null;
  	public JMenuItem menuEditPreferences ( ) {
  		if (menuEditPreferences == null) {
  			menuEditPreferences = new JMenuItem("Preferences");
  			menuEditPreferences.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								preferencesDialog().show();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditPreferences
  		return(menuEditPreferences);
  	} // reader menuEditPreferences
  	public JMenuItem menuEditPreferences ( JMenuItem m ) { return( menuEditPreferences = m ); }

  	protected JMenu menuView = null;
  	public JMenu menuView ( ) {
  		if (menuView == null) menuView = new JMenu("View");
  		return(menuView);
  	} // reader menuView
  	public JMenu menuView ( JMenu m ) { return( menuView = m ); }

  	protected JRadioButtonMenuItem menuViewCascade = null;
  	public JRadioButtonMenuItem menuViewCascade ( ) {
  		if (menuViewCascade == null) {
  			menuViewCascade = new JRadioButtonMenuItem("Cascade Model Windows");
  			menuViewCascade.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								cascadeModelFrames();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewCascade
  		return(menuViewCascade);
  	} // reader menuViewCascade
  	public JRadioButtonMenuItem menuViewCascade ( JRadioButtonMenuItem m ) { return( menuViewCascade = m ); }

  	protected JRadioButtonMenuItem menuViewTile = null;
  	public JRadioButtonMenuItem menuViewTile ( ) {
  		if (menuViewTile == null) {
  			menuViewTile = new JRadioButtonMenuItem("Tile Model Windows");
  			menuViewTile.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								tileModelFrames();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewTile
  		return(menuViewTile);
  	} // reader menuViewTile
  	public JRadioButtonMenuItem menuViewTile ( JRadioButtonMenuItem m ) { return( menuViewTile = m ); }

  	protected JCheckBoxMenuItem menuViewProblem = null;
  	public JCheckBoxMenuItem menuViewProblem ( ) {
  		if (menuViewProblem == null) {
  			menuViewProblem = new JCheckBoxMenuItem("Show Problem Statement");
  			menuViewProblem.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					final ActionEvent evnt = e;
   					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								((VModelFrame) selectedModel().peer()).showProblemStatement(((JCheckBoxMenuItem) evnt.getSource()).getState());
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewProblem
  		return(menuViewProblem);
  	} // reader menuViewProblem
  	public JCheckBoxMenuItem menuViewProblem ( JCheckBoxMenuItem m ) { return( menuViewProblem = m ); }

  	protected JRadioButtonMenuItem menuViewAll = null;
  	public JRadioButtonMenuItem menuViewAll ( ) {
  		if (menuViewAll == null) menuViewAll = new JRadioButtonMenuItem("View All Maps");
  		return(menuViewAll);
  	} // reader menuViewAll
  	public JRadioButtonMenuItem menuViewAll ( JRadioButtonMenuItem m ) { return( menuViewAll = m ); }

  	protected JRadioButtonMenuItem menuViewCausal = null;
  	public JRadioButtonMenuItem menuViewCausal ( ) {
  		if (menuViewCausal == null) menuViewCausal = new JRadioButtonMenuItem("Highlight Causes");
  		return(menuViewCausal);
  	} // reader menuViewCausal
  	public JRadioButtonMenuItem menuViewCausal ( JRadioButtonMenuItem m ) { return( menuViewCausal = m ); }

  	protected JRadioButtonMenuItem menuViewSituation = null;
  	public JRadioButtonMenuItem menuViewSituation ( ) {
  		if (menuViewSituation == null) menuViewSituation = new JRadioButtonMenuItem("Highlight Objects & Describers");
  		return(menuViewSituation);
  	} // reader menuViewSituation
  	public JRadioButtonMenuItem menuViewSituation ( JRadioButtonMenuItem m ) { return( menuViewSituation = m ); }

  	protected JRadioButtonMenuItem menuViewEvidence = null;
  	public JRadioButtonMenuItem menuViewEvidence ( ) {
  		if (menuViewEvidence == null) menuViewEvidence = new JRadioButtonMenuItem("Highlight Justify Map");
  		return(menuViewEvidence);
  	} // reader menuViewEvidence
  	public JRadioButtonMenuItem menuViewEvidence ( JRadioButtonMenuItem m ) { return( menuViewEvidence = m ); }

  	protected JRadioButtonMenuItem menuViewButJustify = null;
  	public JRadioButtonMenuItem menuViewButJustify ( ) {
  		if (menuViewButJustify == null) menuViewButJustify = new JRadioButtonMenuItem("Hide Justify Map");
  		return(menuViewButJustify);
  	} // reader menuViewButJustify
  	public JRadioButtonMenuItem menuViewButJustify ( JRadioButtonMenuItem m ) { return( menuViewButJustify = m ); }

  	protected JMenu menuWindow = null;
  	public JMenu menuWindow ( ) {
  		if (menuWindow == null) menuWindow = new JMenu("Window");
  		return(menuWindow);
  	} // reader menuWindow
  	public JMenu menuWindow ( JMenu m ) { return( menuWindow = m ); }

  	protected JMenu menuWindowModels = null;
  	public JMenu menuWindowModels ( ) {
  		if (menuWindowModels == null) menuWindowModels(new JMenu("Models"));
  		return(menuWindowModels);
  	} // reader menuWindowModels
  	public JMenu menuWindowModels ( JMenu m ) { return( menuWindowModels = m ); }

  	protected ButtonGroup menuWindowModelsGroup = null;
  	public ButtonGroup menuWindowModelsGroup ( ) {
  		if (menuWindowModelsGroup == null) menuWindowModelsGroup(new ButtonGroup());
  		return(menuWindowModelsGroup);
  	} // reader menuWindowModelsGroup
  	public ButtonGroup menuWindowModelsGroup ( ButtonGroup m ) { return( menuWindowModelsGroup = m ); }

  	protected JCheckBoxMenuItem menuWindowLibrary = null;
  	public JCheckBoxMenuItem menuWindowLibrary ( ) {
  		if (menuWindowLibrary == null) {
  			menuWindowLibrary = new JCheckBoxMenuItem("Show Model Library");
  			menuWindowLibrary.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								showModelLibrary(menuWindowLibrary().getState());
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuWindowLibrary
  		return(menuWindowLibrary);
  	} // reader menuWindowLibrary
  	public JCheckBoxMenuItem menuWindowLibrary ( JCheckBoxMenuItem m ) { return( menuWindowLibrary = m ); }

  	protected JMenuItem menuWindowModelOverview = null;
  	public JMenuItem menuWindowModelOverview ( ) {
  		if (menuWindowModelOverview == null) {
  			menuWindowModelOverview = new JMenuItem("Model Overview", getImage("preview.gif"));
  			menuWindowModelOverview.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								modelOverview().show();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuWindowModelOverview
  		return(menuWindowModelOverview);
  	} // reader menuWindowModelOverview
  	public JMenuItem menuWindowModelOverview ( JMenuItem m ) { return( menuWindowModelOverview = m ); }

  	protected JMenu menuHelp = null;
  	public JMenu menuHelp ( ) {
  		if (menuHelp == null) menuHelp = new JMenu("Help");
  		return(menuHelp);
  	} // reader menuHelp
  	public JMenu menuHelp ( JMenu m ) { return( menuHelp = m ); }

  	protected JMenuItem menuHelpIndex = null;
  	public JMenuItem menuHelpIndex ( ) {
  		if (menuHelpIndex == null) {
  			menuHelpIndex = new JMenuItem("Index");
  			menuHelpIndex.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								browser().setTitle("VModel Help");
								browser().setSize(800,600);
								browser().setLocation(QRGutils.center(browser().getSize()));
								browser().gotoPage(QRGutils.QRGroot() + HELPPATH, "index.htm");
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuHelpIndex
  		return(menuHelpIndex);
  	} // reader menuHelpIndex
  	public JMenuItem menuHelpIndex ( JMenuItem m ) { return( menuHelpIndex = m ); }

  	protected JMenuItem menuEMailCoach = null;
  	public JMenuItem menuEMailCoach ( ) {
  		if (menuEMailCoach == null) {
  			menuEMailCoach = new JMenuItem("eMail Doctor V.");
  			menuEMailCoach.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
  								eMailDialog().show();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEMailCoach
  		return(menuEMailCoach);
  	} // reader menuEMailCoach
  	public JMenuItem menuEMailCoach ( JMenuItem m ) { return( menuEMailCoach = m ); }

  	protected JMenuItem menuGrammarCoach = null;
  	public JMenuItem menuGrammarCoach ( ) {
  		if (menuGrammarCoach == null) {
  			menuGrammarCoach = new JMenuItem("VModel Coach");
  			menuGrammarCoach.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
  								grammarCheck();
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuGrammarCoach
  		return(menuGrammarCoach);
  	} // reader menuGrammarCoach
  	public JMenuItem menuGrammarCoach ( JMenuItem m ) { return( menuGrammarCoach = m ); }

  	protected JMenuItem menuHelpAbout = null;
  	public JMenuItem menuHelpAbout ( ) {
  		if (menuHelpAbout == null) {
  			menuHelpAbout = new JMenuItem("About");
  			menuHelpAbout.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					try {
  						Thread t = new Thread() {
  							public void run ( ) {
								browser().setTitle("About " + PROJECT + " v" + VERSION);
								browser().setSize(340,400);
								browser().setLocation(QRGutils.center(browser().getSize()));
								browser().gotoPage(QRGutils.QRGroot() + HELPPATH, "about.html");
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception ex) { }
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuHelpAbout
  		return(menuHelpAbout);
  	} // reader menuHelpAbout
  	public JMenuItem menuHelpAbout ( JMenuItem m ) { return( menuHelpAbout = m ); }

	// Methods
	// --------------------------------------------------------------------------
	public void showFrame ( boolean v ) { 
		if (frame() != system()) {
			//frame().setLocation(0,0);
			//frame().setSize(640,480); 
			frame().setVisible(v); 
		} // end if frame
	} // method setVisible
	
	public void showModelLibrary ( boolean b ) {
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
			if (b) {
				insidePanel().remove(modelsDesktop());
				splitpane().setRightComponent(modelsDesktop());
				splitpane().setDividerLocation(preferences().getInt("GUI", "TREE-WIDTH"));
				insidePanel().add(splitpane(), BorderLayout.CENTER);
				insidePanel().validate();
			} else {
				splitpane().remove(modelsDesktop());
				insidePanel().remove(splitpane());
				insidePanel().add(modelsDesktop(), BorderLayout.CENTER);
				insidePanel().validate();
			} // end if b
		} else {
			ontologyFrame().setVisible(b);
		} // end if frameContainment
		if (b) menuWindowLibrary().setLabel("Hide Model Library");
		else menuWindowLibrary().setLabel("Show Model Library");
	} // method showModelLibrary 
	
	public Container getContentPane ( ) {
		Container result = null;
		if (QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER")) 
			result = ((JApplet) frame()).getContentPane();
		else result = ((JFrame) frame()).getContentPane();
		return(result);
	} // method getContentPane

	public JLayeredPane getLayeredPane ( ) {
		JLayeredPane result = null;
		if (QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER")) 
			result = ((JApplet) frame()).getLayeredPane();
		else result = ((JFrame) frame()).getLayeredPane();
		return(result);
	} // method getLayeredPane

	public JRootPane getRootPane ( ) {
		JRootPane result = null;
		if (QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER")) 
			result = ((JApplet) frame()).getRootPane();
		else result = ((JFrame) frame()).getRootPane();
		return(result);
	} // method getRootPane

	public Component getGlassPane ( ) {
		Component result = null;
		if (QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER")) 
			result = ((JApplet) frame()).getGlassPane();
		else result = ((JFrame) frame()).getGlassPane();
		return(result);
	} // method getGlassPane

	public String statusbar( String s ) {
		statusbar().setText(s); 
		return( statusbar().getText() ); 
	} // method statusbar

	public boolean statusbar( boolean b ) {
		statusbar().setVisible(b); 
		getContentPane().validate();
		return( b ); 
	} // method statusbar

	public Container showSplash ( boolean b ) { 
		int w = 302;
		int h = 202;
		String iconPath = QRGutils.QRGroot() + IMAGEPATH;
		ImageIcon image = null;
		JPanel pane = null;
		JLabel label = null;
		if (VModelGUISplash() == null) {
			if (QRGutils.isApplet()) {
				pane = new JPanel(new BorderLayout());
				pane.setBackground(SPLASH);
				image = QRGutils.getImageIcon(iconPath + "VModelSplash.gif");
				if (image == null) QRGutils.warn("Splash Screen", "File not Found: VmodelSplash.gif");
				label = new JLabel(image);
				VModelGUISplash(pane);
				pane.add(label, BorderLayout.CENTER);
				pane.setLocation(0, 0);
				pane.setSize(((JApplet) QRGutils.applet()).getContentPane().getSize());
				((JApplet) QRGutils.applet()).getLayeredPane().add(pane, 0);
				frame().validate();
			} else {
				VModelGUISplash(new JWindow());
				image = QRGutils.getImageIcon(iconPath + "VModelSplash.gif");
				if (image == null) QRGutils.warn("Splash Screen", "File not Found: VmodelSplash.gif");
				label = new JLabel(image);
				((JWindow) VModelGUISplash()).getContentPane().setLayout(new GridLayout(1,1));
				((JWindow) VModelGUISplash()).getContentPane().add(label);
				QRGutils.calcScreenSize();
				((JWindow) VModelGUISplash()).setLocation(
					((int)QRGutils.screenDimensions.getSize().width-w)/2, 
					((int)QRGutils.screenDimensions.getSize().height/2-h)/2);
				((JWindow) VModelGUISplash()).setSize(w, h);
			} // end if !isApplet
			label.setVisible(true);
		} // end if VModelGUISplash
		VModelGUISplash().setVisible(b || (QRGutils.isApplet() && (!preferences().getBoolean("GUI", "APPEAR-IN-BROWSER"))));
		VModelGUISplash().validate();
		VModelGUISplash().repaint();
		frame().validate();
		frame().repaint();
		return(VModelGUISplash());
	} // default constructor VModelGUISplash

	// Toolbars 
	// --------------------------------------------------------------------------
	public void hilite ( JButton button ) {
		problemMode().setBackground(null);
		buildMode().setBackground(null);
		if (button != null) button.setBackground(YELLOW);
	} // method hitlite

	public void makeToolbars() {
		ButtonGroup modeGroup = new ButtonGroup();
		modeGroup.add(problemMode());
		modeGroup.add(buildMode());
		
		modeToolbar().add(problemMode());
		modeToolbar().add(buildMode());
		modeToolbar().setLayout(new GridLayout(1,modeToolbar().getComponentCount()));
		
		//editToolbar().add(selectButton());
		editToolbar().add(groupButton());
		//editToolbar().addSeparator(new Dimension(10,10));
		editToolbar().add(deleteButton());
		editToolbar().add(cutButton());
		editToolbar().add(copyButton());
		editToolbar().add(pasteButton());
		editToolbar().setLayout(new GridLayout(1,editToolbar().getComponentCount()));
		
		coachToolbar().add(coachButton());
		coachToolbar().setLayout(new GridLayout(1,coachToolbar().getComponentCount()));
				
	} // method makeToolbars
	

	// menubar 
	// --------------------------------------------------------------------------
	public void makeMenubar ( ) {
		boolean flag = QRGutils.isApplet();
		menubar().add(menuFile());
  		menuFile().add(menuFileNew());
  		if (!flag) {
  			menuFile().add(menuFileOpen());
			menuFile().addSeparator();
  			menuFile().add(menuFileSave());
  			menuFile().add(menuFileSaveAs());
  			menuFile().add(menuFileExport());
  			menuFileExport().add(menuFileExportJPG());
  			menuFileExport().add(menuFileExportHTML());
  			menuFileExport().addSeparator();
  			menuFileExport().add(menuFileExportTIF());
  		} // end if flag
		menuFile().addSeparator();
  		menuFile().add(menuFileClose());
  		menuFile().add(menuFileCloseAll());
		if (!flag) {
			menuFile().addSeparator();
  			menuFile().add(menuFilePrintPreview());
  			menuFile().add(menuFilePrint());
  		} // end if flag
		menuFile().addSeparator();
  		menuFile().add(menuFileExit());
		menubar().add(menuEdit());
		menuEdit().add(menuEditSelectAll());
		menuEdit().addSeparator();
		menuEdit().add(menuEditCut());
		menuEdit().add(menuEditCopy());
		menuEdit().add(menuEditPaste());
		menuEdit().add(menuEditGroup());
		if (!flag) {
			menuEdit().addSeparator();
			menuEdit().add(menuEditPreferences());
		} // end if flag
		menubar().add(menuView());
		menuView().add(menuViewProblem());
/*
  		menuView().addSeparator();
		ButtonGroup mapsGroup = new ButtonGroup();
		mapsGroup.add(menuViewAll());
		mapsGroup.add(menuViewCausal());
		mapsGroup.add(menuViewSituation());
		mapsGroup.add(menuViewEvidence());
		mapsGroup.add(menuViewButJustify());
		menuView().add(menuViewAll());
		menuView().add(menuViewCausal());
		menuView().add(menuViewSituation());
		menuView().add(menuViewEvidence());
		menuView().add(menuViewButJustify());
*/
		menubar().add(menuWindow());
		ButtonGroup tileGroup = new ButtonGroup();
		tileGroup.add(menuViewCascade());
		tileGroup.add(menuViewTile());
		menuWindow().add(menuViewCascade());
		menuWindow().add(menuViewTile());
  		menuWindow().addSeparator();
		menuWindow().add(menuWindowLibrary());
  		menuWindow().addSeparator();
		menuWindow().add(menuWindowModelOverview());
  		menuWindow().addSeparator();
		menuWindow().add(menuWindowModels());
		menubar().add(menuHelp());
		menuHelp().add(menuHelpIndex());
		menuHelp().add(menuGrammarCoach());
  		menuHelp().addSeparator();
		menuHelp().add(menuEMailCoach());
  		menuHelp().addSeparator();
		menuHelp().add(menuHelpAbout());
		
  /*
  JMenuItem menuFileOpenAssignment = new JMenuItem("Open Assignment");
  JMenuItem menuFileLoadOntology = new JMenuItem("Load Ontology");
  JMenuItem menuFileExportCML = new JMenuItem("Export to CML");
 */
	} // method makeMenubar

    // IMAGE CACHE
    // -----------------------------------------------------------------------
    // Description: Finds an image in the cache.
    // Side Effects: 
    // -----------------------------------------------------------------------
    public VModelAttribute findImage( String filename ) {
		VModelAttribute attribute = null;
		for(int i = 0; i < images().size(); i++) {
		    attribute = (VModelAttribute) images().elementAt(i);
		    if (attribute.tag().equalsIgnoreCase(filename)) break;
		    else attribute = null;
		} // end for i
		return(attribute);
    } // method getImage

    // Description: Loads and caches an image file. 
    // Side Effects: Overwrites previously cached load of file.
    // -----------------------------------------------------------------------
    public ImageIcon loadImage ( String filename ) {
		String mumble = QRGutils.QRGroot()+IMAGEPATH+filename;
		VModelAttribute grumble = findImage(filename);
		ImageIcon result = null;
		if ((!QRGutils.isApplet()) && (grumble == null) && 
			(!((new File(mumble)).exists())))
			QRGutils.debug("loadImage", "File Not Found: " + mumble);
		else {
			result = QRGutils.getImageIcon(mumble);
			if (result != null) {
			    if (grumble == null)
					images().addElement(new VModelAttribute(filename, result));
			    else grumble.value(result);
			} else if (grumble != null) result = (ImageIcon) grumble.value();
		} // end if exists
		return(result);
    } // method loadImage

    // Description: Gets/Loads a cached image file. 
    // Side Effects: Loads file if not in the cache.
	// -----------------------------------------------------------------------
    public ImageIcon getImage( String filename ) {
		ImageIcon result = null;
		VModelAttribute attribute = findImage(filename);
		if (attribute == null) result = loadImage(filename);
		else result = (ImageIcon) attribute.value();
		return(result);
    } // method getImage

    // Description: Load several commonly used images.
    // Side Effects: 
    // -----------------------------------------------------------------------
	public void loadImages ( ) {
		// Named images (very common)
		icon(QRGutils.getImage(QRGutils.QRGroot()+IMAGEPATH+"vmodel.gif"));
		Object bgImage = preferences().getString("GUI", "BACKGROUND-IMAGE");
		if (bgImage != null) backgroundImage(getImage((String) bgImage));
		loadImage("back.gif");
/*
		loadImage("forward.gif");
		loadImage("blue-left-arrow.gif");
		loadImage("blue-right-arrow.gif");
		loadImage("blue-down-arrow.gif");
		loadImage("blue-up-arrow.gif");
		loadImage("black-left-arrow.gif");
		loadImage("black-right-arrow.gif");
		loadImage("black-down-arrow.gif");
		loadImage("black-up-arrow.gif");
		loadImage("pink-left-arrow.gif");
		loadImage("pink-right-arrow.gif");
		loadImage("pink-down-arrow.gif");
		loadImage("pink-up-arrow.gif");
		loadImage("wizard.gif");
		loadImage("little-black-arrow.gif");
		loadImage("little-blue-arrow.gif");
		loadImage("little-pink-arrow.gif");
		loadImage("little-black-arrow.gif");
		loadImage("little-black-arrow.gif");
*/
		// Cache these
		loadImage("new.gif");
		loadImage("open.gif");
		loadImage("save.gif");
		loadImage("print.gif");
		loadImage("preview.gif");
		loadImage("hand.gif");
		loadImage("cut.gif");
		loadImage("copy.gif");
		loadImage("paste.gif");
		loadImage("explain-on.jpg");
		loadImage("explain-off.jpg");
		loadImage("exp-arrow.jpg");
		loadImage("dynamicbox-off.jpg");
		loadImage("describe-on.jpg");
		loadImage("describe-off.jpg");
		loadImage("des-arrow.jpg");
		loadImage("situationbox-off.jpg");
		loadImage("justify-on.jpg");
		loadImage("justify-off.jpg");
		loadImage("just-arrow.jpg");
		loadImage("evidentiarybox-off.jpg");
		loadImage("vmodel.gif");
		loadImage("vmodelabout.gif");
		loadImage("vmodelsplash.gif");
		loadImage("background.jpg");
		loadImage("smiley-coach.gif");
		loadImage("smiley-coach2.gif");
		// hmmmm....
	/*
		loadImage("vmodel.gif");
		loadImage("vmodel2.gif");
		loadImage("vmodel3.gif");
		loadImage("situationbox-on.jpg");
		loadImage("explain-on.jpg");
		loadImage("explain-off.jpg");
		loadImage("exp-arrow.jpg");
		loadImage("dynamicbox-off.jpg");
		loadImage("describe-on.jpg");
		loadImage("describe-off.jpg");
		loadImage("des-arrow.jpg");
		loadImage("situationbox-off.jpg");
		loadImage("justify-on.jpg");
		loadImage("justify-off.jpg");
		loadImage("just-arrow.jpg");
		loadImage("evidentiarybox-off.jpg");
*/
    } // method loadImages
        
	// Models
	// --------------------------------------------------------------------------
	
	public int save ( ) {
	 	selectedModel().savePrep();
	 	selectedModel().savePrepAux( selectedModel().modelElement() );
    	return(save( selectedModel().getBoolean("SAVEDONCE") ));
    } // method save

	public int save ( boolean savedB4 ) {
		if (!savedB4) { 
			fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
			fileDialog.setDialogTitle("Save VModel File");
			fileDialog.setApproveButtonText("Save");
			String filename = selectedModel().getString("LABEL");
			if (!filename.toUpperCase().endsWith(".VMF")) filename = QRGutils.replaceExtension(filename, "vmf");
			String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
			String filepath = dir + filename;
			File file = new File(filepath);
			Image pic = null;
			int result = 0;
			boolean loop = true;
			fileDialog().setFileFilter(modelFileFilter());
			fileDialog().setSelectedFile(file);
			fileDialog().setCurrentDirectory(file);
			fileDialog().rescanCurrentDirectory();
			//filedialog.setModal(true);
			
			result = fileDialog().showDialog((Component) frame(), null);
			if(result == JFileChooser.APPROVE_OPTION) {
				file = fileDialog.getSelectedFile();
				filename = file.getName();
				if(filename == null) {
					((Component) selectedModel().peer()).requestFocus();
					return(-1);
				} else {
					filename = QRGutils.addExtension(filename, "vmf");
					dir = file.getParent() + "/";
					filepath = dir + filename;
					((VModelFrame) selectedModel().peer()).setTitle(filename);
					selectedModel().set("LABEL", filename);
					selectedModel().set("FILEPATH", filepath);
					selectedModel().set("FILE", filename);
					selectedModel().set("PATH", dir);
					return(save(filename));
				} // end if filename
			} // end if APPROVED
		}// if savedOnce
		return(save(selectedModel().getString("FILE")));
	} // method save
	
	public int save (String filename) {
		boolean tsavedOnce = selectedModel().getBoolean("SAVEDONCE");
		int result = -1;
		selectedModel().set("SAVEDONCE",true);
		//savePrep();
		selectedModel().save(filename);
		((VModelFrame) selectedModel().peer()).dirty(false);
		result = 0;
		return(result);
	} // method save
	
//	public void showModelLibrary ( boolean state ) {
//		if (framecontainment) splitpane.setDividerLocation(state ? splitpane.getLastDividerLocation() : 0);
//		else treecontainer.setVisible(state);
//	} // method showModelLibrary

// need to add in undo support
	public void delete ( ) { 
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if ((elmp != null) && (elmp.isAncestorSelected())) elmp.selected(false);
		} // for i
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) {
				elm = elmp.peer();
				if (elm != null) {
					elmp.contractAll(elm);
				} // if elm
			} // if elmp
		} // for i
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) {
				elm = elmp.peer();
				if (elm != null) {
					elmp.selected(false);
					cutAux(elm);
				} // if elm
			} // if elmp
		} // for i
		((VModelFrame) selectedModel().peer()).repaint();
	} // delete

	public void copy ( ) { 
		clipboard(null);
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if ((elmp != null) && (elmp.isAncestorSelected())) elmp.selected(false);
		} // for i
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) elm = elmp.peer();
			if (elm != null) {
				if (elmp != null) elmp.selected(false);
				clipboard().addElement(elm.clone());
			} // if elm
		} // for i
		((VModelFrame) selectedModel().peer()).repaint();
	} // copy 

	public void cut ( ) { 
		clipboard(null);
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if ((elmp != null) && (elmp.isAncestorSelected())) elmp.selected(false);
		} // for i
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) {
				elm = elmp.peer();
				if (elm != null) {
					elmp.contractAll(elm);
					clipboard().addElement(elm.clone());
				} // if elm
			} // if elmp
		} // for i
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) {
				elm = elmp.peer();
				if (elm != null) {
					elmp.selected(false);
					cutAux(elm);
				} // if elm
			} // if elmp
		} // for i
		((VModelFrame) selectedModel().peer()).repaint();
	} // cut
	
	public void cutAux ( VModelElement element ) {
		VModelElement child = null;
		VModelPeerElement peer = null;
		for(int i = (element.elements().size() - 1); i >= 0; i--) {
			if ((element.elements().size() > 0) && (element.elements().size() > i)) {
				child = (VModelElement) element.elements().elementAt(i);
				if (child != null) cutAux(child);
			} // end if size
		} // for i
		peer = (VModelPeerElement) element.peer();
		selectedModel().remove(element);
		if ((peer != null) && peer.getParent() != null) peer.getParent().remove(peer);
		element.peer(null);
	} // method cutAux
	
	public VModelElement cloneElement( VModelElement e ) {
		VModelElement result = new VModelElement(e.tag());
		e.savePrep();
		((VModelElement)result).copyAttributes(e);
		copyElements(e, result);
		((VModelElement)result).set("KEY",((VModelElement)result).id());
		((VModelElement)result).set("ID",e.get("ID"));
		((VModelElement)result).parent(e.parent());
		return(result);
	} // method clone
	
	public void copyElements ( VModelElement e, VModelElement r ) {
		// Does not copy properties - only attributes and elements.
		VModelElement mumble = null;
		VModelElement grumble = null;
		for(int i = 0; i < e.elements().size(); i++) {
			mumble = (VModelElement)e.elements().elementAt(i);
			grumble = (VModelElement) cloneElement(mumble);
			r.add(grumble);
		} // for i
	} // method copyElements

	public void paste ( ) { 
		VModelElement cluster = new VModelElement("GROUP");
		VModelPeerElement elmp = null;
		VModelElement elm = null;
		VModelElement mumble = null;
		for(int i = ((VModelFrame) selectedModel().peer()).selectedElements().size() - 1; i >=0; i--) {
			elmp = (VModelPeerElement) ((VModelFrame) selectedModel().peer()).selectedElements().elementAt(i);
			if (elmp != null) elmp.selected(false);
		} // for i
		for(int i = clipboard().size() - 1; i >=0; i--) {
			elm = (VModelElement) clipboard().elementAt(i);
			mumble = cloneElement(elm);
			cluster.add(mumble);
			mumble.set("ID",elm.get("ID"));
			mumble.set("XOFFSET",elm.getInt("XOFFSET") + 5);
			mumble.set("YOFFSET",elm.getInt("YOFFSET") + 5);
			elm.set("XOFFSET",elm.getInt("XOFFSET") + 5);
			elm.set("YOFFSET",elm.getInt("YOFFSET") + 5);
			//cluster.add(elm);
		} // for i
		selectedModel().groupInit(cluster);
		for(int i = cluster.elements().size() - 1; i >=0; i--) {
			elm = (VModelElement) cluster.elements().elementAt(i);
		((VModelPeerModel) selectedModel().modelElement().peer()).cadPane().addVModelElement(elm);
		} // for i
		for(int i = cluster.elements().size() - 1; i >=0; i--) {
			elm = (VModelElement) cluster.elements().elementAt(i);
			elmp = (VModelPeerElement) elm.peer();
			if (elmp != null) {
				elmp.validate();
				elmp.setVisible(true);
				elmp.setSize(elmp.getPreferredSize().width,elmp.getPreferredSize().height);
				elmp.selected(true);
			} // end if elmp
		} // for i
		selectedModel().allElements().removeElement(cluster);
		((VModelPeerModel) selectedModel().modelElement().peer()).validate();
		((VModelPeerModel) selectedModel().modelElement().peer()).repaint();
		((JComponent) selectedModel().peer()).repaint();
	} // paste 


	protected int nextX = 0;
	public int nextX ( ) { return(nextX); }
	public int nextX ( int n ) { return(nextX = n); }

	protected int nextY = 0;
	public int nextY ( ) { return( nextY ); }
	public int nextY ( int n ) { return( nextY = n ); }

    public void makeModel () {
		VModelModel model = new VModelModel(system);
		model.modelElement().set("MODEL_MODE", PROBLEM_MODE);
		model.modelElement().set("SHOW-PROBLEM-STATEMENT", true);
		makeModel(model);
    } // method makeModel
     
    public void makeModel (VModelModel model) {
		VModelFrame modelFrame = null;
		VModelElement modelElement = model.modelElement();
    	model.log(true);
    	modelElement.set("AUTHOR", preferences().getString("NAME"));
    	modelElement.set("EMAIL", preferences().getString("EMAIL"));
    	if (models().isEmpty()) {
    		nextX(0);
    		nextY(0);
    	} // end if models
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
			int mw = modelsDesktop().getSize().width/2;
			int mh = modelsDesktop().getSize().height/2;
				modelFrame = new VModelInternalFrame(this, model, nextX(), nextY(), mw, mh);
//				try {modelFrame.setMaximum(preferences().getBoolean("GUI","MAXIMIZE-NEW-MODELS"));}
//				catch (Exception e) {}
		    	nextX(nextX() + 20);
		    	if (nextX() > mw) nextX(nextX() - mw);
		    	nextY(nextY() + 20);
		    	if (nextY() > mh) nextY(nextY() - mh);
			modelsDesktop().add((Component) modelFrame);
			models().addElement(model);
			if (preferences().getBoolean("GUI","MAXIMIZE-NEW-MODELS")) {
				try {modelFrame.setMaximum(true);}
				catch (Exception e) {}
				if (QRGutils.detectPlatform() == MACINTOSH) modelFrame.reshape(0, 0, mw*2, mh*2);
			} // end if maximized
		} else {
			int xoffset = (ontologyFrame().isVisible() ? ontologyFrame().getSize().width : 0) + 15;
			int yoffset = frame().getSize().height + 33;
			int mw = (QRGutils.screenDimensions().width - xoffset)/2;
			int mh = (QRGutils.screenDimensions().height - yoffset)/2;
			if (preferences().getBoolean("GUI","MAXIMIZE-NEW-MODELS")) {
				modelFrame = new VModelExternalModelFrame(this, model, xoffset,yoffset, mw*2,mh*2);
			} else {
				modelFrame = new VModelExternalModelFrame(this, model, xoffset+nextX(),yoffset+nextY(), mw,mh);
				nextX(nextX() + 20);
	    		if (nextX() > mw) nextX(nextX() - mw);
	    		nextY(nextY() + 20);
	    		if (nextY() > mh) nextY(nextY() - mh);
	    	} // end if maximize
			models().addElement(model);
		} // end if frameContainment
		modelFrame.setVisible(true);
		modelsDesktop().moveToFront((Component) modelFrame);
    	model.peer(modelFrame);
	    select(model);
    } // method makeModel
    
	// www.musicspace.com  darins dance moves

    public void select ( VModelModel model ) {
    	select((VModelFrame) model.peer());
    } // method select
    
    public void select ( VModelFrame modelFrame ) {
    	if (selectedModel() != null) {
    		if (selectedModel().peer() instanceof JInternalFrame) {
    			try { ((JInternalFrame) selectedModel().peer()).setSelected(false);}
    			catch (Exception ex) {}
    			//modelsDesktop().getDesktopManager().deactivateFrame((JInternalFrame) selectedModel().peer());
    		} // end if selectedModel
    	} // end if is JInternalFrame
    	modelFrame.setVisible(true);
    	modelFrame.show();
    	selectedModel(modelFrame.peer());
    	modeChange(selectedModel().modelElement().getInt("MODEL_MODE"));
    	modelFrame.menuitem().setSelected(true);
		modelsDesktop().moveToFront((Component) modelFrame);
    } // method select
    
	public void modeChange ( int mode ) {
		switch (mode) {
			case NULL_MODE: { modeChange(PROBLEM_MODE); break; }
			case PROBLEM_MODE: { modeChange("PROBLEM"); break; }
			case BUILD_MODE: { modeChange("BUILD"); break; }
			case ANALYZE_MODE: { modeChange("ANALYZE"); break; }
			case JUSTIFY_MODE: { modeChange("JUSTIFY"); break; }
			default: { modeChange(null); break; }
		} // end select mode
	} // method modeChange

	public void modeChange ( String mode ) {
		grammarCheckAux();
		if ((mode == null) || mode.equals("") || mode.equalsIgnoreCase("NULL_MODE")) {
			mode = "NULL_MODE";
			for(int i = 0; i < system().ontology().ontologies().size(); i++) 
				((VModelPeerOntology) ((VModelElement) system().ontology().ontologies().elementAt(i)).peer()).modeChange(mode);
			hilite(null);
		} else {
			((VModelPeerModel) selectedModel().modelElement().peer()).updateProblemStatement();
			if ((selectedModel().modelElement().getInt("MODEL_MODE") == PROBLEM_MODE) && (!mode.equalsIgnoreCase("PROBLEM"))) {
				String s = selectedModel().modelElement().getString("PROBLEM_STATEMENT");			
				if ((s == null) || s.equalsIgnoreCase("???") || s.equalsIgnoreCase("")) {
					JOptionPane.showMessageDialog(null, "You have not entered a Problem Statement.", "OK", JOptionPane.ERROR_MESSAGE);
					mode = "PROBLEM";					
				}			
			}
			for(int i = 0; i < system().ontology().ontologies().size(); i++) 
				((VModelPeerOntology) ((VModelElement) system().ontology().ontologies().elementAt(i)).peer()).modeChange(mode);
			if (mode.equalsIgnoreCase("PROBLEM")) {
				hilite(problemMode());
				if (selectedModel() != null) {
					selectedModel().modelElement().set("MODEL_MODE", PROBLEM_MODE);
					((VModelPeer) selectedModel().modelElement().peer()).displayMode(PROBLEM_MODE);
					if (selectedModel().peer() != null) ((VModelFrame) selectedModel().peer()).hideProblemStatement ();
				} // end if selectedModel
			} else if (mode.equalsIgnoreCase("BUILD")) {
				hilite(buildMode());
				if (selectedModel() != null) {
					selectedModel().modelElement().set("MODEL_MODE", BUILD_MODE);
					((VModelPeer) selectedModel().modelElement().peer()).displayMode(MODEL_MODE);
					if (selectedModel().peer() != null) menuViewProblem().setState(((VModelFrame) selectedModel().peer()).showProblemStatement(selectedModel().getBoolean("SHOW-PROBLEM-STATEMENT")));
				} // end if selectedModel
			} // end if mode
		} // end if mode
		// toolbars
		VModelPeerOntology.toolbarTopOntologies().setLayout(new GridLayout(1,VModelPeerOntology.toolbarTopOntologies().getComponentCount()));
		VModelPeerOntology.toolbarTopOntologies().validate();
		VModelPeerOntology.toolbarOntologies().setLayout(new GridLayout(1,VModelPeerOntology.toolbarOntologies().getComponentCount()));
		VModelPeerOntology.toolbarOntologies().validate();
		modeToolbar().setLayout(new GridLayout(1,modeToolbar().getComponentCount()));
		modeToolbar().validate();
		modeToolbar().getParent().validate();
		modeToolbar().getParent().getParent().validate();
		editToolbar().setLayout(new GridLayout(1,editToolbar().getComponentCount()));
		editToolbar().validate();
		coachToolbar().setLayout(new GridLayout(1,coachToolbar().getComponentCount()));
		coachToolbar().validate();
		// buttons
		problemMode().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		buildMode().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		selectButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		groupButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		deleteButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		cutButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		copyButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		pasteButton().setEnabled(mode.equalsIgnoreCase("BUILD"));
		coachButton().setEnabled(selectedModel() != null);
		// menus
		menuFileSave().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFileSaveAs().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFileExport().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFileClose().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFileCloseAll().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFilePrint().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuFilePrintPreview().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuEditSelectAll().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuEditCut().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuEditCopy().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuEditPaste().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuEditGroup().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuView().setEnabled(mode.equalsIgnoreCase("BUILD"));
		menuViewCascade().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuViewTile().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuWindowModels().setEnabled(!mode.equalsIgnoreCase("NULL_MODE"));
		menuWindowModelOverview().setEnabled(selectedModel() != null);
		menuGrammarCoach().setEnabled(selectedModel() != null);
		menuEMailCoach().setEnabled(selectedModel() != null);
	} // method modeChange

	public VModelModel loadModel ( ) {
		fileDialog().setDialogType(JFileChooser.OPEN_DIALOG);
		fileDialog().setDialogTitle("Open VModel File");
		fileDialog.setApproveButtonText("Open");
		String filename = "";
		String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
		String filepath = dir + filename;
		File file = new File(filepath);
		Image pic = null;
		int result = 0;
		boolean loop = true;
		fileDialog().setFileFilter(modelFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
//		filedialog.setModal(true);
		
//		result = fileDialog().showOpenDialog((Component) frame());
		result = fileDialog().showDialog((Component) frame(), null);
		if (result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			filename = file.getName();
			if(filename != null) {
				filename = QRGutils.addExtension(filename, "vmf");
				dir = file.getParent() + "/";
				return(loadModel(dir, filename));
			} // end if filename
		} // end APPROVED
		return(null);
	} // method loadModel

	public VModelModel loadModel ( VModelElement e ) {
		VModelModel result = null;
		VModelModel.system(system());
		if (e.typep("FILE")) result = VModelModel.loadModel(e.getString("FULLFILEPATH")); 
		else result = new VModelModel(system(), e);
		if (result != null){
			 result.set("SAVEDONCE", true);
			 makeModel(result);
		} // end if result
		return(result);
	} // method loadModel

	public VModelModel loadModel ( String dir, String filename ) {
		VModelModel result = null;
		VModelModel.system(system());
		result = VModelModel.loadModel(dir + filename);
		if (result != null){
			 result.set("SAVEDONCE", true);
			 makeModel(result);
		} // end if result
		return(result);
	} // method loadModel
	
	public void cascadeModelFrames() { 
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) 
			cascadeModelFrames(modelsDesktop().getAllFrames());
		else {
			Container frames[] = new Container[models().size()];
			for(int i = 0; i < models().size(); i++)
				frames[i] = (Container) ((VModelModel)models().elementAt(i)).peer();
			cascadeModelFrames(frames);
		} // end if framecontainment 
	} // method cascadeModelFrames
	public void tileModelFrames() {
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) 
			tileModelFrames(modelsDesktop().getAllFrames());
		else {
			Container frames[] = new Container[models().size()];
			for(int i = 0; i < models().size(); i++)
				frames[i] = (Container) ((VModelModel)models().elementAt(i)).peer();
			tileModelFrames(frames);
		} // end if framecontainment 
	} // method tileModelFrames

	public void tileModelFrames(Container frames[]) {
		int counter = 0;
		int rows = 0;
		int cols = 0;
		int extra = 0;
		int width = 0;
		int height = 0;
		int r = 0;
		int c = 0;
		int xoffset = 0;
		int yoffset = 0;
		int length = frames.length;
		int desktopheight = 0;
		for (int i = 0; i < length; i++) {
			if (!((VModelFrame)frames[i]).isIcon()) counter++;
		} // for i
		rows = (int)Math.sqrt(counter);
		cols = counter/rows;
		extra = counter - rows * cols;
		if (extra != 0) {
			counter++;
			rows = (int)Math.sqrt(counter);
			cols = counter/rows;
			extra = counter - rows * cols;
		} // end if extra
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
			width = modelsDesktop().getWidth()/cols;
			desktopheight = modelsDesktop().getHeight();
			height = desktopheight/rows;
		} else {
			xoffset = (ontologyFrame().isVisible() ? ontologyFrame().getSize().width : 0) + 10;
			yoffset = frame().getSize().height + 40;
			width = (QRGutils.screenDimensions().width - xoffset)/cols;
			desktopheight = (QRGutils.screenDimensions().height - yoffset);
			height = desktopheight/rows;
		} // end if framecontainment
		for (int j = 0; j < length; j++) {
			if (!((VModelFrame)frames[j]).isIcon()) {
				try {
					if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
						((VModelFrame)frames[j]).setMaximum(false);
						((VModelFrame)frames[j]).reshape(c*width, r*height, width, height);
					} else {
						((VModelFrame)frames[j]).reshape(xoffset + c*width,yoffset + r*height, width, height);
					} // end if framecontainment
					r++;
					if (r == rows) {
						r = 0;
						c++;
						if (c == cols - extra) {
							rows++;
							height = desktopheight/rows;
						}
					}
				} catch (Exception pve) {
				pve.printStackTrace();
				}
			}
		} // for j
		if (selectedModel() != null) ((VModelFrame) selectedModel().peer()).show();
	} // method tileWindows

	public void cascadeModelFrames(Container frames[]) {
		int fDistance = 20;
		int x = 10;
		int y = 10;
		int width = 0;
		int height = 0;
		int xoffset = 0;
		int yoffset = 0;
		int desktopheight = 0;
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
			width = modelsDesktop().getWidth()/2;
			desktopheight = modelsDesktop().getHeight();
			height = desktopheight/2;
		} else {
			xoffset = (ontologyFrame().isVisible() ? ontologyFrame().getSize().width : 0) + 10;
			yoffset = frame().getSize().height + 30;
			width = (QRGutils.screenDimensions().width - xoffset)/2;
			desktopheight = (QRGutils.screenDimensions().height - yoffset);
			height = desktopheight/2;
		} // end if framecontainment
		for (int i = frames.length - 1; i >= 0; i--) {
			if (!((VModelFrame)frames[i]).isIcon()) {
				try {
					if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
						((VModelFrame)frames[i]).setMaximum(false);
						((VModelFrame)frames[i]).reshape(xoffset + x,yoffset + y, width, height);
					} else {
						((VModelFrame)frames[i]).reshape(xoffset + x,yoffset + y, width, height);
					} // end if framecontainment
					x+=fDistance;
					y+=fDistance;
					if (x > width)
					x += - width;
					if (y > height)
					y += - height;
				} catch (Exception pve) {
					pve.printStackTrace();
				} // end try - catch
			} // end if
		} // for i
		if (selectedModel() != null) ((VModelFrame) selectedModel().peer()).show();
	} // method cascadeWindows
	
	
   public FileDialog filedlg = null;
	public void saveImage ( String type ) {
		Dimension size = ((VModelPeerModel) selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
		Image img = ((VModelPeerModel) selectedModel().modelElement().peer()).createImage(size.width, size.height);
		Graphics ig = img.getGraphics();
		String name = selectedModel().getString("LABEL");
		String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
		if (type == IMAGE_JPEG) {
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
		} else {	
			if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, "tif");
		}
		String filepath = dir + name;
		File file = new File(filepath);
		int result = 0;
		ig.setClip(0,0,size.width,size.height);
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setApproveButtonText("Export");
		if (type == IMAGE_JPEG) {
			fileDialog.setDialogTitle("Export VModel JPG Image File");
			fileDialog().setFileFilter(jpgFileFilter());
		} else {
			fileDialog.setDialogTitle("Export VModel TIF Image File");
			fileDialog().setFileFilter(tifFileFilter());
		} // end if type
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog((Component) frame(), null);
		if(result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			name = file.getName();
			dir = file.getParent() + "/";
			if (name != null) {
	//			((VModelPeerElement) selectedModel().modelElement().peer()).cadPane().modelPane().paintAll(ig);
				((VModelFrame) selectedModel().peer()).print(ig);
				if (type == IMAGE_JPEG) {
					if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
					saveJPEG(img, name);
				} else {	
					TIFF tiff = new TIFF();
					if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, "tif");
					tiff.encode(img, dir + name, tiff.RGB_COLOR);
				}
			} // end if name
		} // end if APPROVED
	} // end method saveImage

    public void saveJPEG(Image pic, String filepath) {
	    try {
			JPGOptions fo = new JPGOptions();
			fo.setQuality(90);
			JimiWriter jw = Jimi.createJimiWriter(filepath);
			jw.setSource(pic);
			if (fo != null) {
				jw.setOptions(fo);
			}
			jw.putImage(filepath);
	    } catch (Exception ex) {
			QRGutils.warn("VModelGUI.saveJPEG", "IOException in saveJPEG()");
	    } // end try - catch
    }

	public void saveHTML ( ) {
		Dimension size = ((VModelPeerModel) selectedModel().modelElement().peer()).cadPane().view().getExtentSize();
		Image img = ((VModelPeerModel) selectedModel().modelElement().peer()).createImage(size.width, size.height);
		Graphics ig = img.getGraphics();
		String name = selectedModel().getString("LABEL");
		String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
		if (!name.toUpperCase().endsWith(".HTML")) name = QRGutils.replaceExtension(name, "html");
		String filepath = dir + name;
		File file = new File(filepath);
		int result = 0;
		ig.setClip(0,0,size.width,size.height);
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setApproveButtonText("Export");
		fileDialog.setDialogTitle("Export VModel as a Web Page");
		fileDialog().setFileFilter(htmlFileFilter());
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showSaveDialog((Component) frame());
		if(result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			name = file.getName();
			dir = file.getParent() + "/";
			if (name != null) {
	//			((VModelPeerElement) selectedModel().modelElement().peer()).cadPane().modelPane().paintAll(ig);
				((VModelFrame) selectedModel().peer()).print(ig);
				if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
//				JPEG jpg = new JPEG();
//				jpg.compress(img, dir + name);
				saveJPEG(img, dir + name);
	
				try {
					String jpgname = name;
					name = QRGutils.replaceExtension(name, "html");
				    FileWriter fw = new FileWriter(dir+name);
				    PrintWriter pw = new PrintWriter(fw);
				    pw.println("<!doctype html public \"-//w3c//dtd html 4.0 transitional//en\">");
				    pw.println("<HTML>");
				    pw.println(" <HEAD>");
			        pw.println("  <META NAME=\"Author\" CONTENT=\""+preferences().getString("NAME")+"\">");
				    pw.println("  <META NAME=\"Description\" CONTENT=\""+selectedModel().get("DESCRIPTION")+"\">");
			        pw.println("  <META NAME=\"KeyWords\" CONTENT=\"VModel, QRG, Northwestern University\">");
				    pw.println("  <TITLE>VModel "+name+"</TITLE>");
				    pw.println(" </HEAD>");
				    pw.println(" <BODY TEXT=\"#000000\" BGCOLOR=\"#A0B0C0\">");
				    pw.println("   <CENTER>");
				    pw.println("    The following VModel was built by "+preferences().getString("NAME")+"<BR>");
				    pw.println("    <IMG SRC=\""+jpgname+"\" ALT=\"Picture of a VModel design.\" BORDER=\"2\"><BR><BR>");
				    pw.println("   <TABLE WIDTH=\"50%\">");
			        pw.println("    <TR><TD ALIGN=\"RIGHT\"><B>MODEL:</B></TD><TD>" + selectedModel().label()+"</TD></TR>");
			        pw.println("    <TR><TD ALIGN=\"RIGHT\"><B>AUTHOR:</B></TD><TD> " + preferences().getString("NAME")+"</TD></TR>");
			        pw.println("    <TR><TD ALIGN=\"RIGHT\"><B>DESCRIPTION:</B></TD><TD><P ALIGN=\"JUSTIFY\">" + selectedModel().get("DESCRIPTION")+"</P></TD></TR>");
			        pw.println("    <TR><TD ALIGN=\"RIGHT\"><B>Problem Statement:</B></TD><TD><P ALIGN=\"JUSTIFY\">" + selectedModel().problemStatement()+"</P></TD></TR>");
				    pw.println("   </TABLE><BR><BR>");
				    pw.println("   </CENTER>");
				    pw.println(" </BODY>");
				    pw.close();
				    fw.close();
											browser().setTitle("VModel ");
											browser().setSize(800,600);
											browser().setLocation(QRGutils.center(browser().getSize()));
											browser().gotoPage(dir, name);
				} // try
				catch ( Exception e ) {
				    QRGutils.debug("VModelGUI", "saveHTML Error: \n" + e);
				    e.printStackTrace();
				}
	
			} // end if name
		} // end if APPROVED
	} // end method saveImage

	public void printModel ( ) {
		if (selectedModel() != null) {
   			PrintJob pjob = Toolkit.getDefaultToolkit().getPrintJob((JFrame) frame(), selectedModel().label(), null);
   			if (pjob != null) {
        		ImageFilter filter = new RotateFilter(Math.PI / 2);
        		ImageProducer producer = null;
        		Image rotatedImage = null;
				Dimension size = ((VModelPeerModel) selectedModel().modelElement().peer()).cadPane().modelPane().getSize();
				int width = size.width, height = size.height;
				int pageNumber = 0;
				Image img = ((VModelPeerModel) selectedModel().modelElement().peer()).createImage(PAGE_WIDTH, PAGE_HEIGHT);
				Image txt = ((VModelPeerModel) selectedModel().modelElement().peer()).createImage(PAGE_WIDTH, 32);
				Graphics ig = img.getGraphics();
				Graphics tg = txt.getGraphics();
				Graphics pg = null;
				for(int h = 0; h < height; h += PAGE_HEIGHT) {
					for(int w = 0; w < width; w += PAGE_WIDTH) {
						pageNumber++;
						ig.setColor(WHITE);
						ig.fillRect(-5,-5,PAGE_WIDTH + 5,PAGE_HEIGHT + 32 + 5);
						ig.translate(-w,-h);
						ig.setClip(w,h,PAGE_WIDTH,PAGE_HEIGHT);
						((VModelFrame) selectedModel().peer()).print(ig);
        				producer = new FilteredImageSource(img.getSource(), filter);
        				rotatedImage = system().createImage(producer);
		   				pg = pjob.getGraphics();
						pg.setColor(WHITE);
						pg.fillRect(0,0,pg.getClipBounds().width + 5,pg.getClipBounds().height + 5);
						pg.setColor(BLACK);
						pg.drawString("VModel: " + selectedModel().label(), 10,8);
						pg.drawString("Student: " + preferences().getString("NAME"), 10,16);
						pg.drawString("Page: " + pageNumber, 10,24);
						pg.translate(32,32);
						pg.drawLine(0,0,0,32);
						pg.drawLine(0,0,32,0);
						pg.drawLine(PAGE_HEIGHT,0,PAGE_HEIGHT,32);
						pg.drawLine(PAGE_HEIGHT,0,PAGE_HEIGHT-32,0);
						pg.drawLine(0,PAGE_WIDTH,0,PAGE_WIDTH-32);
						pg.drawLine(0,PAGE_WIDTH,32,PAGE_WIDTH);
						pg.drawLine(PAGE_HEIGHT,PAGE_WIDTH,PAGE_HEIGHT,PAGE_WIDTH-32);
						pg.drawLine(PAGE_HEIGHT,PAGE_WIDTH,PAGE_HEIGHT-32,PAGE_WIDTH);
						pg.setColor(WHITE);
						pg.setClip(2,2,PAGE_HEIGHT -4,PAGE_WIDTH -4);
						pg.drawImage(rotatedImage,0,0,null);
			   			pg.dispose();
						ig.translate(w,h);
		   			} // end for hi;
		   		} // end for w;
				pageNumber++;
				pg = pjob.getGraphics();
				pg.setColor(WHITE);
				pg.fillRect(0,0,pg.getClipBounds().width + 5,pg.getClipBounds().height + 5);
				pg.setColor(BLACK);
				pg.drawString("VModel: " + selectedModel().label(), 10,8);
				pg.drawString("Student: " + preferences().getString("NAME"), 10,16);
				pg.drawString("Page: " + pageNumber, 10,24);
				pg.drawString("Problem Statement: ", 10,40);
				JTextPane ps = new JTextPane();
				ps.setSize(pg.getClipBounds().width-20,pg.getClipBounds().height - 48);
				ps.setText(selectedModel().problemStatement());
				pg.translate(10,48);
				ps.print(pg);
	   			pg.dispose();
				pjob.end();
   			} // end if pjob
	   } // end if selectedModel
	} // end method printModel


	// ontologies
	// --------------------------------------------------------------------------
	public void makeOntologyPeers ( ) {
		for( int i = 0; i < system().ontology().ontologies().size(); i++) {
			new VModelPeerOntology(system(), this, (VModelElement) system().ontology().ontologies().elementAt(i));
		} // end for i
	} // method makeOntologyPeers
	
/*
	public VModelOntology addToOntology (VModelElement element) {
		VModelOntology result = new VModelOntology(element);
/*		VModelOntology parent = null;
		DefaultTreeModel parentTree = null;
		if (element.getString("TYPE").equalsIgnoreCase("GROUP")) {
			parent = modelLibraryGroupsOntology;
			parentTree = modelLibraryGroupsModel;
		} else if (element.getString("TYPE").equalsIgnoreCase("MODEL")) {
			parent = modelLibraryModelsOntology;
			parentTree = modelLibraryModelsModel;
		} else {
			parent = modelLibraryObjectsOntology;
			parentTree = modelLibraryObjectsModel;
		} // end if type
		parent.add(result);
		parentTree.reload();
		((DefaultTreeModel)tree.getModel()).reload();
		expandTree(tree);
		//tree.setSelectionPath(result.treepath);
//*		return(result);
	} // method makeOntology
*/

	// --------------------------------------------------------------------------
	// Preferences
	// --------------------------------------------------------------------------
	public VModelPreferences preferences( ) {
		return(system().preferences());
	} // method localPreferences
	
	public VModelElement localPreferences ( ) {
		return(preferences().localPreferences());
	} // method localPreferences
	
	// Set attribute values.
	// -----------------------------------------------------------------------
    public Object set ( String tag, Object value ) {
		Object result = null;
		if (localPreferences() != null) {
			if (preferences()!= null)
				result = preferences().set(tag, value);
			result = localPreferences().set(tag, value);
		} else QRGutils.debug("PREFERENCES", "Variable localPreferences()= null.");
		return(result);
    } // method set

    public Object set ( String tag, int value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, boolean value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, double value ) {
		return(set(tag, "" + value));
    } // method set

    public Object set ( String tag, Color value ) {
		return(set(tag, "" + value.getRGB()));
    } // method set

	// Set attribute values of a child element.
	// -----------------------------------------------------------------------
    public Object set ( String etag, String atag, Object value ) {
		Object result = null;
		if (localPreferences()!= null) {
			if (preferences()!= null)
				result = preferences().set(etag, atag, value);
			result = localPreferences().set(etag, atag, value);
		} else QRGutils.debug("PREFERENCES", "Variable preferences()= null.");
		return(result);
    } // method set

    public Object set ( String etag, String atag, int value ) {
		return(set(etag, atag, "" + value));
    } // method set

    public Object set ( String etag, String atag, double value ) {
		return(set(etag, atag, "" + value));
    } // method set

    public Object set ( String etag, String atag, boolean value ) {
		return(set(etag, atag, "" + value));
    } // method set

    public Object set ( String etag, String atag, Color value ) {
		return(set(etag, atag, "" + value.getRGB()));
    } // method set

	// Close
	// -----------------------------------------------------------------------
	public void close ( ) {
		int n = 0;
		if (closeAllModels() != -1) system().quit(0);
	} // method close

	public int closeAllModels ( ) {
		int n = 0;
		VModelModel model = null;
		for(int i = models().size()-1; i >= 0; i--) {
			model = (VModelModel)models().elementAt(i);
			select(model);
			if (closeModel(model) == -1) return(-1);
		} // for i
		return(0);
	} // method close

	public int closeModel(VModelModel model) {
		int result = 0;
		if (model.dirty()) {
			boolean continuep = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The model, " + model.getString("LABEL") + ", has not been saved.\n Do you want to close it anyway?", "Alert! Model Not Saved.", JOptionPane.YES_NO_OPTION));
			if (!continuep) result = -1;
		} // end if dirty
		if (result == 0) closeModelAux(model);
		return(result);
	} // method closeModel
	
	public int closeModelAux(VModelModel model) {
		int result = 0;
		models().removeElement(model);
		menuWindowModels().remove(((VModelFrame) model.peer()).menuitem());
		((VModelFrame) model.peer()).close();
		((VModelFrame) model.peer()).dispose();
		if (models().isEmpty()) {
			selectedModel(null);
			modeChange(null);
			//enableWidgets(-1);
			if (!preferences().getBoolean("GUI", "ALLOW-EMPTY-DESKTOP")) makeModel();
		} else {
			if (model == selectedModel()) {
				select((VModelModel)models().elementAt(models().size()-1));
			} // end if model
		} // end if size else
		return(result);
	} // method closeModel
	
	// VModelEvent.VModelEventLisenter Methods
	// -------------------------------------------------------------------------
	public boolean event ( VModelEvent e ) {
		if ((e.eventID() == ADD_TO_ONTOLOGY) && (selectedModel() != null)) {
			boolean flag = true;
			VModelPeerOntology mumble = null;
			VModelElement grumble = (VModelElement) e.argument2();
			for(int i = 0; i < VModelPeerOntology.allPeerOntologies().size(); i++) {
				mumble = (VModelPeerOntology) VModelPeerOntology.allPeerOntologies().elementAt(i);
				if (mumble.peer().getString("TYPE").equalsIgnoreCase(grumble.getString("TYPE"))) {
					//mumble.tree().removeSelectionPath(mumble.treepath());
					mumble.peer(grumble);
			//			((DefaultTreeModel)mumble.tree().getModel()).reload();
			//			mumble.expandNode(mumble.tree(), mumble.treenode());
					flag = false;
					break;
				}
			} // for i
			if (flag) {
						VModelElement m = (VModelElement) e.argument2();
						VModelElement p = m.parent();
						VModelElement s = p.parent();
						VModelPeerOntology q = (VModelPeerOntology) p.peer();
						VModelPeerOntology r = (VModelPeerOntology) s.peer();
						VModelPeerOntology foo = new VModelPeerOntology(system(), this, (VModelElement) e.argument2(), ((VModelPeerOntology) ((VModelElement) e.argument1()).peer()));  
						//r.tree().treeDidChange();
						//r.tree().collapsePath(foo.treepath());
						((DefaultTreeModel)r.tree().getModel()).reload();
						//foo.expandTree(r.tree());
						foo.expandNode(r.tree(), foo.treenode());
			}
		} else if ((e.eventID() == REMOVE_FROM_ONTOLOGY) && (selectedModel() != null)) {
QRGutils.debug("VModelGUI","event REMOVE_FROM_ONTOLOGY");
VModelPeerOntology mumble = (VModelPeerOntology) ((VModelElement) e.argument1()).peer();
mumble.tree().removeSelectionPath(mumble.treepath());
((DefaultTreeModel)mumble.tree().getModel()).reload();
/*
VModelPeerOntology mumble = null;
VModelElement grumble = (VModelElement) e.argument2();
for(int i = 0; i < VModelPeerOntology.allPeerOntologies().size(); i++) {
	mumble = (VModelPeerOntology) VModelPeerOntology.allPeerOntologies().elementAt(i);
	if (mumble.peer().getString("TYPE").equalsIgnoreCase(grumble.getString("TYPE"))) {
		mumble.tree().removeSelectionPath(mumble.treepath());
		break;
	}
} // for i
*/
		} else if ((e.eventID() == AUTO_ADD_TO_GROUP) && (selectedModel() != null)) {
			VModelElement element = (VModelElement) e.argument2();
			VModelElement group = (VModelElement) e.argument1();
			VModelPeerElement lmnt = (VModelPeerElement) element.peer();
			VModelPeerElement grp = (VModelPeerElement) group.peer();
			if (selectedModel().modelElement() != group) {
				element.set("EXTENDED", "TRUE");
				group.set("SKINNED", "TRUE");
				group.set("HAS-EXTENDED-ELEMENTS", "TRUE");
				if (grp != null) {
					grp.displayMode(BOX_MODE);
					grp.setSize(grp.getPreferredSize().width, grp.getPreferredSize().height);
				} // end if grp
				((VModelPeerModel) selectedModel().modelElement().peer()).validate();
			} // end if selectedModel
		} else if ((e.eventID() == DISCONNECT) && (selectedModel() != null)) {
			VModelElement relationship = (VModelElement) e.argument1();
			VModelPeerRelationship relationshipPeer = (VModelPeerRelationship) relationship.peer();
			((VModelPeerModel) relationshipPeer.model().modelElement().peer()).cadPane().markerize(relationshipPeer);
			grammarCheckAux();
		} else if ((e.eventID() == DISCONNECT_INPUT) && (selectedModel() != null)) {
			VModelElement relationship = (VModelElement) e.argument1();
			VModelElement input = (VModelElement) e.argument2();
			VModelPeerRelationship relationshipPeer = (VModelPeerRelationship) relationship.peer();
//			if (relationship.typep("DESCRIBER")) {
//				relationshipPeer.model().removeFromGroup(input, relationship);
//				if (relationship.output() != null) relationshipPeer.model().removeFromGroup(input, relationship.output());
//			} // end if describer
			((VModelPeerModel) relationshipPeer.model().modelElement().peer()).cadPane().markerize(relationshipPeer);
			grammarCheckAux();
		} else if ((e.eventID() == DISCONNECT_OUTPUT) && (selectedModel() != null)) {
			VModelElement relationship = (VModelElement) e.argument1();
			VModelElement output = (VModelElement) e.argument2();
			VModelPeerRelationship relationshipPeer = (VModelPeerRelationship) relationship.peer();
			((VModelPeerModel) relationshipPeer.model().modelElement().peer()).cadPane().markerize(relationshipPeer);
			grammarCheckAux();
		} else if ((e.eventID() == CONNECT) && (selectedModel() != null)) {
			grammarCheckAux();
		} else if ((e.eventID() == CONNECT_INPUT) && (selectedModel() != null)) {
			grammarCheckAux();
		} else if ((e.eventID() == CONNECT_OUTPUT) && (selectedModel() != null)) {
			grammarCheckAux();
		} else if ((e.eventID() == REMOVE_OBJECT) && (selectedModel() != null)) {
			VModelElement object = (VModelElement) e.argument1();
			VModelPeerElement objectPeer = (VModelPeerElement) object.peer();
			if (objectPeer != null) {
				if (objectPeer.getParent() != null) objectPeer.getParent().remove(objectPeer);
			} // end if objectPeer
			QRGutils.debug("VModelGUI","event event=REMOVE_OBJECT");
			grammarCheckAux();
		} else if ((e.eventID() == REMOVE_GROUP) && (selectedModel() != null)) {
			VModelElement group = (VModelElement) e.argument1();
			VModelPeerElement groupPeer = (VModelPeerElement) group.peer();
			if (groupPeer != null) {
				if (groupPeer.getParent() != null) groupPeer.getParent().remove(groupPeer);
			} // end if groupPeer
			QRGutils.debug("VModelGUI","event event=REMOVE_GROUP");
			grammarCheckAux();
		} else if ((e.eventID() == REMOVE_ATTRIBUTE) && (selectedModel() != null)) {
			VModelElement attribute = (VModelElement) e.argument1();
			VModelPeerElement attributePeer = (VModelPeerElement) attribute.peer();
			if (attributePeer != null) {
				if (attributePeer.getParent() != null) attributePeer.getParent().remove(attributePeer);
			} // end if attributePeer
			QRGutils.debug("VModelGUI","event event=REMOVE_ATTRIBUTE");
			grammarCheckAux();
		} else if ((e.eventID() == REMOVE_RELATIONSHIP) && (selectedModel() != null)) {
			VModelElement relationship = (VModelElement) e.argument1();
			VModelPeerRelationship relationshipPeer = (VModelPeerRelationship) relationship.peer();
			if (relationshipPeer != null) {
				if ((relationshipPeer.inputMarker() != null) && (relationshipPeer.inputMarker().getParent() != null))
					relationshipPeer.inputMarker().getParent().remove(relationshipPeer.inputMarker());
				if ((relationshipPeer.outputMarker() != null) && (relationshipPeer.outputMarker().getParent() != null))
					relationshipPeer.outputMarker().getParent().remove(relationshipPeer.outputMarker());
				if (relationshipPeer.getParent() != null) relationshipPeer.getParent().remove(relationshipPeer);
			} // end if relationshipPeer
			grammarCheckAux();
		} // end if event
		return(true); 
	} // method event
	
	public void initFrame ( ) {
	} // method initFrame

	// WindowListener methods
	// -----------------------------------------------------------------------
    public void windowOpened(WindowEvent e) {}
    public void windowClosing(WindowEvent e) {close();}
    public void windowClosed(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}

	// KeyListener methods
	// -----------------------------------------------------------------------
	public void keyTyped(KeyEvent e) {
	} // method keyTyped
	
	public void keyPressed(KeyEvent e) {
		int kcode = e.getKeyCode();
		int kmod = e.getModifiers();
//		if ((kcode == 157) && (kmod == VKM_COMMAND)) { 
//			QRGutils.beep();
//			system.save();
//		} // end if

		// file operations
		if ((kcode == KeyEvent.VK_N) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			makeModel();
		if ((kcode == KeyEvent.VK_O) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			loadModel();
		if ((kcode == KeyEvent.VK_W) && (selectedModel() != null) &&
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			closeModel(selectedModel());
		if ((kcode == KeyEvent.VK_W) && 
			((kmod == (VKM_COMMAND | VKM_SHIFT)) || (kmod == (VKM_CONTROL | VKM_SHIFT)))) 
			closeAllModels();
		if ((kcode == KeyEvent.VK_S) && (selectedModel() != null) &&
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			save();		
		if ((kcode == KeyEvent.VK_P) && 
			((kmod == (VKM_COMMAND | VKM_SHIFT)) || (kmod == (VKM_CONTROL | VKM_SHIFT)))) 
			printPreview().show();
		if ((kcode == KeyEvent.VK_P) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			printModel();
		if ((kcode == KeyEvent.VK_Q) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) // never called on Macs
			close();
		
		// edit operations
		if ((kcode == KeyEvent.VK_BACK_SPACE) || (kcode == KeyEvent.VK_DELETE))
					if (selectedModel() != null) delete(); 
		if ((kcode == KeyEvent.VK_X) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
					if (selectedModel() != null) cut(); 
		if ((kcode == KeyEvent.VK_C) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
					if (selectedModel() != null) copy(); 
		if ((kcode == KeyEvent.VK_V) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
					if (selectedModel() != null) paste(); 
			
		if ((kcode == KeyEvent.VK_Z) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			QRGutils.debug("KEYPRESSED", "Z + " + e.getKeyModifiersText(kmod));
		if ((kcode == KeyEvent.VK_R) && 
			((kmod == VKM_COMMAND) || (kmod == VKM_CONTROL))) 
			QRGutils.debug("KEYPRESSED", "R + " + e.getKeyModifiersText(kmod));
		if ((kcode == KeyEvent.VK_Z) &&
			((kmod == (VKM_COMMAND | VKM_SHIFT)) || (kmod == (VKM_CONTROL | VKM_SHIFT)))) 
			QRGutils.debug("KEYPRESSED", "Z + " + e.getKeyModifiersText(kmod));

		if (kcode == KeyEvent.VK_ESCAPE) {
				VModelPeerOntology.selectedTree(null);
				VModelPeerOntology.selectedOntology(null);
		} // end if escape

		if ((kcode == KeyEvent.VK_A) &&
			((kmod == (VKM_COMMAND | VKM_SHIFT)) || (kmod == (VKM_CONTROL | VKM_SHIFT))) &&
			(selectedModel() != null)) 
			VModelPeerElement.selectAll(selectedModel());
		if ((kcode == KeyEvent.VK_A) &&
			((kmod == (VKM_COMMAND)) || (kmod == (VKM_CONTROL))) &&
			(selectedModel() != null)) 
			VModelPeerElement.selectAll(selectedModel());

		if ((kcode == KeyEvent.VK_1) &&
			((kmod == (VKM_COMMAND)) || (kmod == (VKM_CONTROL))) &&
			(selectedModel() != null)) 
			problemMode().doClick();
		if ((kcode == KeyEvent.VK_2) &&
			((kmod == (VKM_COMMAND)) || (kmod == (VKM_CONTROL))) &&
			(selectedModel() != null)) 
			buildMode().doClick();

		// model operations
		if ((kcode == KeyEvent.VK_COMMA) && (kmod == (VKM_OPTION | VKM_SHIFT)))
			//cycleSelectModel(BACKWARD);
			QRGutils.debug("KEYPRESSED", "',' + " + e.getKeyModifiersText(kmod));
		if ((kcode == KeyEvent.VK_PERIOD) && (kmod == (VKM_OPTION | VKM_SHIFT)))
			//cycleSelectModel(FORWARD);
			QRGutils.debug("KEYPRESSED", "'.' + " + e.getKeyModifiersText(kmod));
		
		if ((kcode == KeyEvent.VK_G) && (kmod == VKM_OPTION)) 
			QRGutils.debug("KEYPRESSED", "G + " + e.getKeyModifiersText(kmod));
			
		e.consume();
	} // Method keyPressed
	
	public void keyReleased(KeyEvent e) {
	} // Method keyReleased

	// InnerClasses and Interfaces
	// --------------------------------------------------------------------------
    public class BackgroundPanel extends JPanel {
    	// This needs to be split out as an independent class. 
    	public BackgroundPanel ( ) { super(); }
	    public BackgroundPanel (LayoutManager l ) { super(l); }
	    public void paint (Graphics g) {
		    super.paint(g);
		    if (backgroundImage() != null) {
			    int width = backgroundImage().getIconWidth();
			    int height = backgroundImage().getIconHeight();
			    if ((width >= 0) && (height >= 0)) {
				    for(int x = 0; x < getSize().width; x = x + width)
				    	for(int y = 0; y < getSize().height; y = y + height)
				    		backgroundImage().paintIcon(this, g, x, y);
			    } // if width && height
		    } // if backgroundImage
					paintChildren(g);
	    } // method paint
    } // innerclass BackgroundPanel

    public class ModelsDesktopPane extends JDesktopPane {
    	public ModelsDesktopPane ( ) { super(); }
	    public void paint (Graphics g) {
		    super.paint(g);
		    if (backgroundImage() != null) {
			    int width = backgroundImage().getIconWidth();
			    int height = backgroundImage().getIconHeight();
			    if ((width >= 0) && (height >= 0)) {
				    for(int x = 0; x < getSize().width; x = x + width)
				    	for(int y = 0; y < getSize().height; y = y + height)
				    		backgroundImage().paintIcon(this, g, x, y);
			    } // if width && height
		    } // if backgroundImage
					paintChildren(g);
	    } // method paint
    } // innerclass ModelsDesktopPane

	// Constructors
	// -------------------------------------------------------------------------
	public VModelGUI ( VModel system ) { 
		int x = 0, y = 0, width = 0, height = 0;
		String title = "";
		system(system);
		system().gui(this);
System.getProperties().list(System.out);

QRGutils.debug("VModelGUI","VModelGUI path=" + (new File(System.getProperty("java.home"))).getParent());
		
		if (QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER")) frame(system());
		else frame(new JFrame(PROJECT + " v" + VERSION + 
					 		  " Copyright " + COPYRIGHT + " " + 
							  COPYRIGHTATTRIBUTION + "  " +
							  Runtime.getRuntime().totalMemory() + "/" +
							  Runtime.getRuntime().freeMemory()));
		getContentPane().setBackground(SPLASH);
		getContentPane().setLayout(new BorderLayout());
		showSplash(true);
		loadImages();
		VModelEvent.addListener(this);
		
		new VModelLogin(system());
		
		frameContainment(preferences().getBoolean("GUI", "FRAME-CONTAINMENT"));
		if (!(QRGutils.isApplet() && preferences().getBoolean("GUI", "APPEAR-IN-BROWSER"))) {
			title = (String) preferences().get("GUI", "TITLE");
			if (title == null) {
				title = PROJECT + " v" + VERSION +
					    ", Logged In: " + (system().superUser() ? "[" : "") + 
					    preferences().getString("NAME") + (system().superUser() ? "]" : "");
				set("GUI", "TITLE", title);
			} // if title
			((JFrame) frame()).setTitle(title);
			
			x = preferences().getInt("GUI", "X");
			y = preferences().getInt("GUI", "Y");
			width = preferences().getInt("GUI", "WIDTH");
			height = preferences().getInt("GUI", "HEIGHT");
			if ((x < 0) || (x > QRGutils.screenDimensions().width)) {
				x = 0;
				set("GUI", "X", x);
			} // if x
			if ((y < 0) || (y > QRGutils.screenDimensions().height)) {
				y = 0;
				set("GUI", "Y", y);
			} // if y
			if ((width <= 50) || (x + width > QRGutils.screenDimensions().width)) {
			    width = (int) QRGutils.screenDimensions().width - x;
				set("GUI", "WIDTH", width);
			} // if width
			if ((height <= 50) || (y + height > QRGutils.screenDimensions().height)) {
			    height = (int) QRGutils.screenDimensions().height - y;
				set("GUI", "HEIGHT", height);
			} // if height
			frame().setLocation(x,y);
			frame().setSize(width, height);
			frame().addKeyListener(this);
			((JFrame) frame()).addWindowListener(this);
			((JFrame) frame()).setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
			((JFrame) frame()).setIconImage(icon);
			((JFrame) frame()).getContentPane().add(backgroundPane(), BorderLayout.CENTER);
			if (!QRGutils.isApplet()) fileDialog().setAccessory(new JLabel(getImage("wizard.gif")));
		} else {
			((JApplet) frame()).getContentPane().add(backgroundPane(), BorderLayout.CENTER);
		} // end if isApplet


		// load Grammar here?
//		coach(new VModelCoach(this));
//		gui(new VModelGUI(this));

		system().ontology(new VModelOntology(system()));
		makeOntologyPeers();
		
		makeToolbars();
		
		outsidePanel().setOpaque(false);
		backgroundPane().add(outsidePanel(), BorderLayout.CENTER);
	
		insidePanel().setOpaque(false);
		outsidePanel().add(insidePanel(), BorderLayout.CENTER);
			
		VModelPeerOntology.toolbarTopOntologies().setLayout(new GridLayout(1,VModelPeerOntology.toolbarTopOntologies().getComponentCount()));
		VModelPeerOntology.toolbarTopOntologies().validate();
		JPanel toolbarPane = new JPanel(new BorderLayout());
		JPanel vmodeltoolsPane = new JPanel(new BorderLayout());
		vmodeltoolsPane.add(modeToolbar(), BorderLayout.WEST);
		vmodeltoolsPane.add(VModelPeerOntology.toolbarTopOntologies(), BorderLayout.EAST);
		VModelPeerOntology.toolbarTopOntologies().setVisible(!preferences().getBoolean("GUI", "EXPANDED-ONTOLOGY-TOOLBAR"));
		toolbarPane.add(vmodeltoolsPane, BorderLayout.WEST);
		toolbarPane.add(editToolbar(), BorderLayout.CENTER);
		toolbarPane.add(coachToolbar(), BorderLayout.EAST);
		outsidePanel.add(toolbarPane, BorderLayout.NORTH);
		
		VModelPeerOntology.toolbarOntologies().setLayout(new GridLayout(1,VModelPeerOntology.toolbarOntologies().getComponentCount()));
		VModelPeerOntology.toolbarOntologies().validate();
		insidePanel.add(VModelPeerOntology.toolbarOntologies(), BorderLayout.NORTH);
		VModelPeerOntology.toolbarOntologies().setVisible(preferences().getBoolean("GUI", "EXPANDED-ONTOLOGY-TOOLBAR"));

		modelsDesktop().setOpaque(false);
		if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
			splitpane(new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
						   VModelPeerOntology.tabpane(), //treepane,
						   modelsDesktop()));
			splitpane().setOpaque(false);
	//		desktop().setOpaque(false);
			splitpane().setOneTouchExpandable(true);
			splitpane().setDividerSize(10);
			splitpane().setDividerLocation(preferences().getInt("GUI", "TREE-WIDTH"));
			insidePanel().add(splitpane(), BorderLayout.CENTER);
		} else {
			ontologyFrame(new JFrame("VModel Ontology"));
			ontologyFrame().getContentPane().add(VModelPeerOntology.tabpane());
			ontologyFrame().addKeyListener(this);
		} // end if frame containment



//		VModelTest bar = new VModelTest(system());
//		VModelTest.buildTrixieModel(system());
//		VModelTest.printOntologies(system());
		
		makeMenubar();

		if (frame() instanceof JFrame) ((JFrame) frame()).setJMenuBar(menubar());
		else ((JApplet) frame()).setJMenuBar(menubar());

		statusbar();

		System.gc();
		modeChange(null);
		showFrame(true);
		
	if (frameContainment() || (QRGutils.isApplet() && (preferences().getBoolean("GUI","APPEAR-IN-BROWSER")))) {
	} else {
		if ((preferences().get("GUI","TREE-X") == null) || (preferences().get("GUI","TREE-Y") == null))
			ontologyFrame().setLocation(0, frame().getLocation().y + frame().getPreferredSize().height + 33);
		else
			ontologyFrame().setLocation(preferences().getInt("GUI", "TREE-X"), preferences().getInt("GUI", "TREE-Y"));
		if (preferences().get("GUI","TREE-X") == null)
				ontologyFrame().setSize(preferences().getInt("GUI", "TREE-WIDTH"), QRGutils.screenDimensions().height - 33 - frame().getLocation().y - frame().getPreferredSize().height);
			else
				ontologyFrame().setSize(preferences().getInt("GUI", "TREE-WIDTH"), preferences().getInt("GUI", "TREE-HEIGHT"));
		ontologyFrame().setVisible(true);
		if (frame() instanceof JFrame) {
			//((JFrame) frame()).setSize(frame().getSize().width, ((JFrame) frame()).getPreferredSize().height);
			((JFrame) frame()).setSize(QRGutils.screenDimensions().width, ((JFrame) frame()).getPreferredSize().height);
			((JFrame) frame()).setResizable(false);
		} // end if JFrame
	} // end if frame containment
	
	showModelLibrary(preferences().getBoolean("GUI", "SHOW-MODEL-LIBRARY"));
	menuWindowLibrary().setState(preferences().getBoolean("GUI", "SHOW-MODEL-LIBRARY"));
	
	printPreview(new PrintPreviewDialog(this));
	modelOverview(new ModelOverviewDialog(this));
		
	if (!preferences().getBoolean("GUI", "ALLOW-EMPTY-DESKTOP")) makeModel();
	//else enableWidgets(-1);
		if (frame() instanceof JFrame) {
   		filedlg = new FileDialog(((JFrame) frame()), "Save Your Model as a JPEG Image", FileDialog.SAVE);
   		filedlg.setDirectory(QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH);
		} // end if JFrame
		
		showSplash(false);
	} // constructor

} // class VModelGUI
    
// -----------------------------------------------------------------------------
// End of File: VModelGUI.java                  (c) 2001 Northwestern University
