package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelLogin.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: VModel student login facility.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.colorchooser.*;

// -----------------------------------------------------------------------------
// Notes:
// * Should the file IO routines be included in this class?
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelLogin
// Description: VModel student login facility.  
// -----------------------------------------------------------------------------
public class VModelLogin extends JDialog implements VModelConstants {
	// InnerClasses and Interfaces
	// --------------------------------------------------------------------------

	// Properties and Accessors
	// --------------------------------------------------------------------------
	protected VModel system = null;
	public VModel system ( ) { return(system); }
	public VModel system ( VModel s ) { return(system = s); }

	protected VModelElement student = null;
	public VModelElement student( ) { return( student ); }
	public VModelElement student( VModelElement s ) { return( student = s ); }
	
	protected String userID = "";
	public String userID( ) { return( userID ); }
	public String userID( String s ) { return( userID = s ); }
	
	protected String name = "";
	public String name( ) { return( name ); }
	public String name( String s ) { return( name = s ); }
	
	protected String email = "";
	public String email( ) { return( email ); }
	public String email( String s ) { return( email = s ); }
	
	protected String age = "";
	public String age( ) { return( age ); }
	public String age( String s ) { return( age = s ); }
	
	protected int color = BACKGROUND_COLOR.getRGB();
	public int color( ) { return( color ); }
	public int color( int i ) { return( color = i ); }
		
	protected LoginPane loginPane = null;
	public LoginPane loginPane( ) { return( loginPane ); } // reader loginPane
	public LoginPane loginPane( LoginPane l ) { return( loginPane = l ); }
	public LoginPane loginPane( VModelLogin l ) {
		setTitle("VModel Login"); 
		validate();
		if (loginPane() == null) loginPane(new LoginPane(l));
		else loginPane().setVisible(true);
		return( loginPane() ); 
	} // method loginPane
		
	protected PasswdPane passwdPane = null;
	public PasswdPane passwdPane( ) { return( passwdPane ); } // reader passwdPane
	public PasswdPane passwdPane( PasswdPane l ) { return( passwdPane = l ); }
	public PasswdPane passwdPane( VModelLogin l ) { 
		validate();
		if (passwdPane() == null) passwdPane(new PasswdPane(l));
		else passwdPane().setVisible(true);
		return( passwdPane() ); 
	} // method passwdPane
		
	protected InfoPane infoPane = null;
	public InfoPane infoPane( ) { return( infoPane ); } // reader infoPane
	public InfoPane infoPane( InfoPane l ) { return( infoPane = l ); }
	public InfoPane infoPane( VModelLogin l ) { 
		validate();
		if (infoPane() == null) infoPane(new InfoPane(l));
		else infoPane().setVisible(true);
		return( infoPane() ); 
	} // method InfoPane
		
	// Methods.
	// --------------------------------------------------------------------------
    public void load (String id) {
		VModelElement result = student();
		String path = null;
		String fullpath = null;
		String fullfilepath = null;
		String filename = null;
		File file = null;
		String name = id;
		String email = "";
		String age = "";
		int color = 0;
		Color clr = null;
		id = id.trim();
		id = id.replace(' ', '-');
		if (!id.equals("")) {
		    filename = id + ".ini";
		    path = USERPATH + id + "/";
		    fullpath = QRGutils.QRGroot() + path;
			result = VModelElement.load(fullpath + filename);
		    if (result == null) {
		    	setTitle("VModel Login: new userID = " + id);
		    	infoPane(this);
		    } else {
		    	student(result);
				result.set("FULLPATH", fullpath);
				result.set("FULLFILEPATH", fullpath + filename);
		    	system().preferences().localPreferences(result);
		   		QRGutils.QRGuserpath(path);
		    	hide();
		    } // end if result
		} // end if
    } // method login

	// Inner Classes
	// --------------------------------------------------------------------------
    public class LoginPane extends JPanel implements ActionListener {	
    	VModelLogin parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, buttonPanel = null;
    	JTextField text = null;
    	JButton ok = null, cancel = null;
    	
    	public void setVisible ( boolean b ) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed ( ActionEvent e ) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
    			userID(text.getText());
				userID(userID().trim());
				userID(userID().replace(' ', '-'));
				if (userID().equals("")) loginPane(parent);
    			else if (userID().equalsIgnoreCase("DEVELOPER")) passwdPane(parent);
    			else load(userID());
    		} else if (e.getSource() == cancel) parent.hide(); //System.exit(-1);
    	} // method actionPerformed
    	
    	public LoginPane ( VModelLogin parent ) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		image = system().gui().getImage("VModelLogin.gif");
    		imageLabel = new JLabel(image);
    		this.add(imageLabel, BorderLayout.NORTH);
			JPanel foo = new JPanel(new BorderLayout());    		
    		textPanel = new JPanel(new GridLayout(2,1));
       		label = new JLabel("Enter UserID:");
    		textPanel.add(label);
    		text = new JTextField("", 26);
    		textPanel.add(text);
    		foo.add(textPanel, BorderLayout.NORTH);
    		foo.add(new JLabel(" "), BorderLayout.SOUTH);
    		this.add(foo, BorderLayout.CENTER);
    		textPanel.setVisible(true);
    		
    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		if (!QRGutils.isApplet()) buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor LoginPane
    } // innerclass LoginPane

    public class PasswdPane extends JPanel implements ActionListener {	
    	VModelLogin parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, buttonPanel = null;
    	JPasswordField text = null;
    	JButton back = null, ok = null, cancel = null;
    	
    	public void setVisible ( boolean b ) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed ( ActionEvent e ) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
    			if (text.getText().equalsIgnoreCase("XYZZY")) {
	    			load("DEVELOPER");
		    	} else {
		    		Toolkit.getDefaultToolkit().beep();
		    		loginPane(parent);
		    	} // end if passwd
    		} else if (e.getSource() == cancel) parent.hide(); //System.exit(0);
    		else if (e.getSource() == back) loginPane(parent);
    	} // method actionPerformed
    	
    	public PasswdPane ( VModelLogin parent ) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		image = system().gui().getImage("VModelLogin.gif");
    		imageLabel = new JLabel(image);
    		this.add(imageLabel, BorderLayout.NORTH);
    		
    		textPanel = new JPanel(new BorderLayout());
       		label = new JLabel("Enter Password for DEVELOPER:");
    		textPanel.add(label, BorderLayout.NORTH);
    		text = new JPasswordField("", 26);
    		textPanel.add(text, BorderLayout.SOUTH);
    		this.add(textPanel, BorderLayout.CENTER);
    		textPanel.setVisible(true);
    		
    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		back = new JButton("Back");
    		back.addActionListener(this);
    		buttonPanel.add(back);
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		if (!QRGutils.isApplet()) buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor PasswdPane
    } // innerclass PasswdPane

    public class InfoPane extends JPanel implements ActionListener {	
    	VModelLogin parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, textPanel1 = null, textPanel2 = null, textPanel3 = null, buttonPanel = null;
    	JTextField text = null, text1 = null, text2 = null, text3 = null;
    	JButton back = null, ok = null, cancel = null;
    	JColorChooser clrChooser = null;
    	
    	public void setVisible ( boolean b ) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed ( ActionEvent e ) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
				name(text.getText());
				email(text2.getText());
				age(text3.getText());
				color(clrChooser.getColor().getRGB());
				VModelElement result = new VModelElement("STUDENT");
			    String filename = userID() + ".ini";
			    String path = USERPATH + userID() + "/";
			    String fullpath = QRGutils.QRGroot() + path;
			    result.set("NAME", name());
			    result.set("USERID", userID());
			    result.set("EMAIL", email());
			    result.set("AGE", ""+age());
			    result.set("COLOR", ""+color());
			    result.set("FULLPATH", fullpath);
			    result.set("PATH", path);
			    result.set("FILEPATH", path + filename);
			    result.set("FULLFILEPATH", fullpath + filename);
			    result.set("FILENAME", filename);
			    result.set("GROUPSPATH", path + "groups/");
			    result.set("MODELSPATH", path + "models/");
				student(result);
				system().preferences().localPreferences(result);
				if (!QRGutils.isApplet()) {
				    try {
		    			File file = new File(fullpath + filename);
	                    new File(file.getParent()).mkdirs();
	                    new File(file.getParent()+"/models/").mkdirs();
					    new File(file.getParent()+"/groups/").mkdirs();
					    new File(file.getParent()+"/objects/").mkdirs();
						result.save(fullpath + filename);
		            } catch (Exception ex) {
						JOptionPane.showMessageDialog(null, "Unable To Create New User", "alert", JOptionPane.ERROR_MESSAGE);
					} // end try - catch
				} // end if is applet
				load(userID());
				parent.hide();
    		} else if (e.getSource() == cancel) parent.hide(); //System.exit(-1);
    		else if (e.getSource() == back) loginPane(parent);
    	} // method actionPerformed
    	
    	public InfoPane ( VModelLogin parent ) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		textPanel = new JPanel(new BorderLayout());
    		//label = new JLabel("UserID '" + userID() + "' not found.");
    		//textPanel.add(label);
       		label = new JLabel("Enter your name:");
    		textPanel.add(label, BorderLayout.NORTH);
    		text = new JTextField("", 26);
    		textPanel.add(text, BorderLayout.CENTER);
			JPanel foo = new JPanel(new GridLayout(1,2));
			JPanel bar = new JPanel(new BorderLayout());
			JPanel baz = new JPanel(new BorderLayout());
       		label = new JLabel("Enter your eMail:");
    		bar.add(label, BorderLayout.NORTH);
    		text2 = new JTextField("");
    		bar.add(text2, BorderLayout.SOUTH);
    		foo.add(bar, BorderLayout.WEST);
       		label = new JLabel("Enter your age:");
    		baz.add(label, BorderLayout.NORTH);
    		text3 = new JTextField("");
    		baz.add(text3, BorderLayout.SOUTH);
    		foo.add(baz, BorderLayout.EAST);
    		textPanel.add(foo, BorderLayout.SOUTH);
    		this.add(textPanel, BorderLayout.NORTH);
    		
    		
			clrChooser = new JColorChooser();
			AbstractColorChooserPanel[] panels = clrChooser.getChooserPanels();
 			//for(int i = panels.length-1 ; i > 0; i--)
			//for(int i = 0; i < panels.length - 1 ; i++)
				//clrChooser.removeChooserPanel(panels[i]);
				clrChooser.removeChooserPanel(panels[2]);
				clrChooser.removeChooserPanel(panels[1]);
			foo = new JPanel(new BorderLayout());
    		foo.add(new JLabel("Select your favorite color:"), BorderLayout.NORTH);
    		foo.add(clrChooser, BorderLayout.CENTER);
    		this.add(foo, BorderLayout.CENTER);
    		

    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		back = new JButton("Back");
    		back.addActionListener(this);
    		buttonPanel.add(back);
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		if (!QRGutils.isApplet()) buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor InfoPane
    } // innerclass InfoPane

	// Constructor
	// --------------------------------------------------------------------------
	public VModelLogin( VModel system ) {
		super((Frame) null, "VModel Login");
    	setSize(430,382);
    	setModal(true);
		system(system);
		if (DEVELOPER) load("DEVELOPER");
		if ((student() == null) && system().preferences().getBoolean("STUDENT","FORCE-LOGIN")) {
			loginPane(this);
			show(); 
			if ((!QRGutils.isApplet()) && (student() == null)) System.exit(0);
		} // end if forceLogin
		if (student() == null) {
			student(new VModelElement("STUDENT"));
			student().set("NAME", (QRGutils.isApplet() ? "Web" : PLATFORM_NAMES[QRGutils.detectPlatform()]) + " VModel User");
			student().set("USERID", "student");
			student().set("EMAIL", "vmodel@cs.northwestern.edu");
			student().set("AGE", "12");
			student().set("COLOR", BACKGROUND_COLOR.getRGB());
			student().set("FULLPATH", QRGutils.QRGroot()+USERPATH+"student/");
			student().set("FULLFILEPATH", QRGutils.QRGroot()+USERPATH+"student/student.ini");
			student().set("PATH", USERPATH+"student/");
			student().set("FILEPATH", USERPATH+"student/student.ini");
			student().set("FILENAME", "student.ini");
			//student().set("GROUPSPATH", USERPATH+"student/groups/");
			//student().set("MODELSPATH", USERPATH+"student/models/");
			//student().set("OBJECTSPATH", USERPATH+"student/objects/");
			system().preferences().localPreferences(student());
		} // end if student
	} // constructor VModelLogin

} // class VModelLogin

// -----------------------------------------------------------------------------
// End of File: VModelLogin.java                (c) 2002 Northwestern University
