package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;
import javax.swing.plaf.metal.*;

// -----------------------------------------------------------------------------
// Class: VModelPeerElement
// -----------------------------------------------------------------------------
public class VModelPeerGroup extends VModelPeerElement implements VModelConstants {
	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected ImageIcon image = null;
	public ImageIcon image ( ) {
		if (image == null) image(gui().getImage("question.gif")); 
		return(image); 
	} // reader image
	public ImageIcon image ( ImageIcon i ) { return(image = i); }

	protected JLabel imageLabel = null;
	public JLabel imageLabel ( ) {
		if (imageLabel == null) imageLabel(new JLabel(image)); 
		return(imageLabel); 
	} // reader imageLabel
	public JLabel imageLabel ( JLabel l ) { return(imageLabel = l); }

	protected VModelPanel groupPane = null;
	public VModelPanel groupPane ( ) {
		if (groupPane == null) {
			labela = new JTextField(peer().getString("LABEL"));
			JLabel typelabel = new JLabel(peer().getString("TYPE"));
			VModelPanel lpanel = makeLinksPanel(gui());
			groupPane(new VModelPanel(gui()));
			typelabel.setForeground(WHITE);
			lpanel.setBackground(peer().getColor("COLOR"));
			lpanel.setSize(typelabel.getPreferredSize().width+lpanel.getPreferredSize().width, 18);
			lpanel.add(typelabel, 0);
			lpanel.revalidate();
			labela.setBorder(new LineBorder(peer().getColor("COLOR"), 2));
			labela.addFocusListener(this);
			labela.addKeyListener(new TextKeyAdapter());
			groupPane.setBackground(peer().getColor("COLOR"));
			groupPane.setBorder(new CompoundBorder(new EtchedBorder(),new EmptyBorder(1,1,1,1)));
			groupPane.add(labela, BorderLayout.CENTER);
			groupPane.add(lpanel, BorderLayout.SOUTH);
			groupPane.revalidate();
			groupPane.validate();
			groupPane.setLocation(peer().getInt("XOFFSET"), peer().getInt("YOFFSET"));
			groupPane.setSize(lpanel.getPreferredSize().width, groupPane.getPreferredSize().height);
			//groupPane.setPreferredSize(getSize());
			groupPane.revalidate();
			groupPane.validate();
		} // end if result
		return(groupPane);
	} // reader groupPane
	public VModelPanel groupPane ( VModelPanel p ) { return(groupPane = p); }

	protected VModelPanel boxPane = null;
	public VModelPanel boxPane ( ) {
		if (boxPane == null) {
			labelb = new JTextField(peer().getString("LABEL"));
			JLabel typelabel = new JLabel(peer().getString("TYPE"));
			VModelPanel lpanel = makeLinksPanel(gui());
			boxPane(new BoxPane(gui(), gui().getImage("box.gif")));
			typelabel.setForeground(WHITE);
			typelabel.setOpaque(false);
			lpanel.setOpaque(false);
			lpanel.setSize(lpanel.getPreferredSize().width, 18);
			lpanel.setSize(typelabel.getPreferredSize().width+lpanel.getPreferredSize().width, 18);
			lpanel.add(typelabel, 0);
			lpanel.revalidate();
			lpanel.validate();
			labelb.setBorder(new EmptyBorder(1,1,1,1));
			labelb.addFocusListener(this);
			labelb.addKeyListener(new TextKeyAdapter());
			boxPane.add(new JLabel(gui().getImage("spacer5x5.gif")), BorderLayout.NORTH);
			boxPane.add(new JLabel(gui().getImage("spacer.gif")), BorderLayout.EAST);
			JLabel baz = new JLabel(gui().getImage("spacer5x5.gif"));
			baz.setSize(2,2);
			baz.setPreferredSize(baz.getSize());
			boxPane.add(baz, BorderLayout.WEST);
			VModelPanel foobar = new VModelPanel(gui());
			//foobar.setOpaque(false);
			foobar.setBackground(peer().getColor("COLOR"));
			foobar.add(labelb, BorderLayout.CENTER);
			foobar.add(lpanel, BorderLayout.SOUTH);
			boxPane.add(foobar, BorderLayout.CENTER);
			boxPane.setOpaque(true);
			boxPane.revalidate();
			boxPane.validate();
			boxPane.setLocation(peer().getInt("XOFFSET"), peer().getInt("YOFFSET"));
			boxPane.setSize(Math.max(lpanel.getPreferredSize().width, lpanel.getPreferredSize().width), boxPane.getPreferredSize().height);
			boxPane.revalidate();
			boxPane.validate();
		} // end if result
		return( boxPane );
	} // reader boxPane
	public VModelPanel boxPane ( VModelPanel p ) { return(boxPane = p); }

	// VModelPeerElement Methods
	// --------------------------------------------------------------------------
	protected JMenuItem menuitemSubtype = null;
	public JMenuItem menuitemSubtype ( ) {
		if (menuitemSubtype == null) {
			menuitemSubtype(new JMenuItem("Add To Library"));
			menuitemSubtype.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run ( ) {
QRGutils.debug("VModelPeerGroup", "menuitemSubtype");
							peer().save("leotest.vmf");
							model().savePrep();
							model().addToLibrary(peer());
							groupPane(null);
							boxPane(null);
							groupPane(null);
							displayMode();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemSubtype
		return(menuitemSubtype);
	} // reader menuitemSubtype
	public JMenuItem menuitemSubtype ( JMenuItem m ) { return( menuitemSubtype = m ); }
	
	protected JMenuItem menuitemUnGroup = null;
	public JMenuItem menuitemUnGroup ( ) {
		if (menuitemUnGroup == null) {
			menuitemUnGroup(new JMenuItem("UnGroup"));
			menuitemUnGroup.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ev) {
				final ActionEvent e = ev;
				try {
					Thread t = new Thread() {
						public void run ( ) {
							VModelElement mumbleFrotz = null;
							expandOne(peer());
							for(int j = peer().elements().size()-1; j >= 0; j--) {
								mumbleFrotz = (VModelElement) peer().elements().elementAt(j);
								model().removeFromGroup(peer(), mumbleFrotz);
							} // for j
							selectOne();
							gui().delete();
							((JComponent) model().peer()).repaint();
						} // method run
					}; // Anonymous Class Thread
					t.start();
				} catch (Exception err) {}
			} // method actionPerformed
			}); // actionListener
		} // end if menuitemUnGroup
		return(menuitemUnGroup);
	} // reader menuitemUnGroup
	public JMenuItem menuitemUnGroup ( JMenuItem m ) { return( menuitemUnGroup = m ); }
	
	public void makePopupMenu ( ) {
		super.makePopupMenu();
		menu().addSeparator();
		menu().add(menuitemSubtype());
		if (!peer().getBoolean("VARIABLE")) menu().add(menuitemVariablize());
		else menu().add(menuitemUnVariablize());
		if (peer().getBoolean("BOUND")) menu().add(menuitemUnBind());
		menu().addSeparator();
		if (!peer().getBoolean("SKINNED")) menu().add(menuitemSkin());
		else menu().add(menuitemUnSkin());
		menu().add(menuitemSkinColor());
		if (!peer().elements().isEmpty()) {
			menu().addSeparator();
			menu().add(menuitemUnGroup());
			menu().addSeparator();
			menu().add(menuitemSelectGrouped());
			menu().addSeparator();
			menu().add(menuitemExtendOne());
			menu().add(menuitemExtendAll());
			menu().add(menuitemContractAll());
		} // end if elements
		if (!peer().connections().isEmpty()) {
			menu().addSeparator();
			menu().add(menuitemDisconnectAll());
			menu().add(menuitemDisconnectConnections());
		} // end if connections
	} // method makePopupMenu
	
	public void showPopupMenu (int x, int y ) {
		super.showPopupMenu(x, y); 
	} // method showPopupMenu
		
	public int displayMode ( int m ) {
		peer().set("DISPLAY_MODE", BOX_MODE);
		removeAll();
//		if (peer().getBoolean("DISPLAY-IMAGE")) {
			if (peer().get("IMAGE") != null) image(gui().getImage(peer().getString("IMAGE")));
			add(imageLabel(), BorderLayout.NORTH);
			imageLabel().setVisible(true);
//		} // end if displayImage
		switch(m) {
			case BOX_MODE: {
				add(boxPane(), BorderLayout.CENTER);
				boxPane().setVisible(true);
				label(labelb);
				break;
			} // case BOX_MODE
			case GROUP_MODE: {
				add(groupPane(), BorderLayout.CENTER);
				groupPane().setVisible(true);
				label(labela);
				break;
			} // case OBJECT_MODE
			default: {
				if (peer().elements().isEmpty()) displayMode(GROUP_MODE);
				else displayMode(BOX_MODE);
			} // case OBJECT_MODE
		} // end switch
		return(peer().getInt("DISPLAY_MODE"));
	} // method displayMode

	// Constructors
	// --------------------------------------------------------------------------
	public VModelPeerGroup (VModelGUI gui, VModelModel model, VModelElement peer ) {
		super(gui, model, peer);
//		makePopupMenu();
		displayMode();
		if (peer().getColor("GROUPCOLOR") == BLACK) peer().set("GROUPCOLOR", gui().groupColor().getRGB());
		setSize(getPreferredSize().width, getPreferredSize().width);
//		if (peer() != model().modelElement()) {
//			 if (peer().getInt("DISPLAY_MODE") == GROUP_MODE) {
//			setBorder(new CompoundBorder(new EtchedBorder(), getBorder()));
//			setOpaque(false);
//			setSize(200,200);
//			validate();
//			}
//		} // end if peer != model
	} // constructor	
} // class VModelPeerGroup

// -----------------------------------------------------------------------------
// End of File: VModelPeerGroup.java        (c) 2001 Northwestern University
