package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelGUIModelFrame.java
//    System: VModel
//   Version: 4.0
//  Abstract: VModel is a visual representation system developed to provide 
//            computer support to students learning how to create, articulate,
//            and reason with scientific models.  There is a special emphasis on
//            supporting the reuse and integration of previously modeled
//            material in the course of making new models. 
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModelGUIModelFrame represents the top-level VModel window.  
//            The event driven nature of this system gives this class a great 
//            deal of control over the flow and interpretation of data.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
// Modified: Friday, June 22, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;
import javax.swing.plaf.metal.*;

// -----------------------------------------------------------------------------
// Class: VModelPeerElement
// -----------------------------------------------------------------------------
public class VModelPeerMarker extends VModelPeerElement implements VModelConstants {
	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected static ImageIcon image = null;
	public ImageIcon image ( ) {
		if (image == null) image(gui().getImage("marker2.gif")); 
		return(image); 
	} // reader image
	public ImageIcon image ( ImageIcon i ) { return(image = i); }

	protected VModelPeerRelationship relationship = null;
	public VModelPeerRelationship relationship ( ) { return(relationship); } 
	public VModelPeerRelationship relationship ( VModelPeerRelationship r ) { return(relationship = r); }

	// VModelPeerElement Methods
	// --------------------------------------------------------------------------
	public void makePopupMenu ( ) {
	} // method makePopupMenu
	
	public void showPopupMenu (int x, int y ) {
	} // method showPopupMenu
		
	// Methods
	// --------------------------------------------------------------------------
	public void paint( Graphics g ) {
		super.paint(g);
		g.drawImage(image().getImage(),3,2,null);
	} // method paint

	// Constructors
	// --------------------------------------------------------------------------
	public VModelPeerMarker (VModelGUI gui, VModelModel model, VModelElement peer, VModelPeerRelationship relationship, int x, int y ) {
		super(gui, model, peer);
		//super(gui, model, peer);
		relationship(relationship);
		peer.peer(relationship);
		setLocation(x,y);
		setSize(25,25);
	} // constructor
	
} // class VModelPeerDescriber

// -----------------------------------------------------------------------------
// End of File: VModelPeerGroup.java        (c) 2001 Northwestern University
