package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelPeerOntology.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: The VModel main window.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.awt.*;
import javax.swing.*;
import java.util.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.UIManager.*;
import java.io.*;
import javax.swing.filechooser.*;
import edu.qrg.vmodel.controllers.common.*;

// -----------------------------------------------------------------------------
// Class: VModelPeerOntology
// Description: Peer class for ontology elements. 
// -----------------------------------------------------------------------------
public class VModelPeerOntology implements VModelConstants, MouseListener, ActionListener {
	// Properties & Accessors 
	// -------------------------------------------------------------------------
	protected VModel system = null;
	public VModel system ( ) { return( system ); }
	public VModel system ( VModel s ) { return( system = s ); }

	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return( gui ); }
	public VModelGUI gui ( VModelGUI g ) { return( gui = g ); }

	protected VModelElement peer = null;
	public VModelElement peer ( ) { return( peer ); }
	public VModelElement peer ( VModelElement p ) { return( peer = p ); }
	
	protected JPopupMenu ontologyRightClickMenu = null;
	public JPopupMenu ontologyRightClickMenu ( ) { return( ontologyRightClickMenu ); }
	public JPopupMenu ontologyRightClickMenu ( JPopupMenu m ) { return( ontologyRightClickMenu = m ); }
	
	protected String label = null;
	public String label ( ) {
		if (label == null) {
			if (peer() != null) {
				label = peer().getString("ALIAS");
				if ((label == null) || label.equals("")) {
					label = (String) peer().get("LABEL");
					if ((label != null) && (label.equalsIgnoreCase("???"))) label = null;
				} // end if label
				if ((label == null) || label.equals("")) label = peer().getString("TYPE");
			} else label("???");
		} // end if label
		return( label );
	} // reader label
	public String label ( String l ) { return( label = l ); }

	protected ImageIcon image = null;
	public ImageIcon image ( ) { return( image ); }
	public ImageIcon image ( ImageIcon i ) { return( image = i ); }

	protected PeerButton button = null;
	public PeerButton button ( ) { return( button ); }
	public PeerButton button ( PeerButton b ) { return( button = b ); }
	
	protected JMenuItem menuitem = null;
	public JMenuItem menuitem ( ) { return( menuitem ); }
	public JMenuItem menuitem ( JMenuItem m ) { return( menuitem = m ); }
	
	protected PeerTreeNode treenode = null;
	public PeerTreeNode treenode ( ) { return( treenode ); }
	public PeerTreeNode treenode ( PeerTreeNode n ) { return( treenode = n ); }
	
	protected VModelPeerOntology parent = null;
	public VModelPeerOntology parent ( ) { return( parent ); }
	public VModelPeerOntology parent ( VModelPeerOntology p ) { return( parent = p ); }
	
	protected Vector children = null;
	public Vector children ( ) {
		if (children == null) children(new Vector());
		return(children);
	} // reader children
	public Vector children ( Vector c ) { return( children = c ); }
	
	protected static Vector allPeerOntologies = null;
	public static Vector allPeerOntologies ( ) {
		if (allPeerOntologies == null) allPeerOntologies(new Vector());
		return(allPeerOntologies);
	} // reader allPeerOntologies
	public static Vector allPeerOntologies ( Vector a ) { return( allPeerOntologies = a ); }
	
	protected JTree tree = null;
	public JTree tree ( ) { return( tree ); }
	public JTree tree ( JTree t ) { return( tree = t ); }

	protected DefaultTreeModel treemodel = null;
	public DefaultTreeModel treemodel ( ) { return( treemodel ); }
	public DefaultTreeModel treemodel ( DefaultTreeModel t ) { return( treemodel = t ); }

	protected TreePath treepath = null;
	public TreePath treepath ( ) { return( treepath ); }
	public TreePath treepath ( TreePath t ) { return( treepath = t ); }

	protected JScrollPane treepane = null;
	public JScrollPane treepane ( ) { return( treepane ); }
	public JScrollPane treepane ( JScrollPane t ) { return( treepane = t ); }

	protected int tabindex = -1;
	public int tabindex ( ) { return( tabindex ); }
	public int tabindex ( int t ) { return( tabindex = t ); }

	protected static JTabbedPane tabpane = null;
	public static JTabbedPane tabpane ( ) { 
		if (tabpane == null) tabpane(new JTabbedPane());
		return( tabpane ); 
	} // reader tabpane
	public static JTabbedPane tabpane ( JTabbedPane t ) { return( tabpane = t ); }

	protected static VModelElement selectedOntology = null;
	public static VModelElement selectedOntology ( ) { return( selectedOntology ); }
	public static VModelElement selectedOntology ( VModelElement o ) { return( selectedOntology = o ); }

	protected static VModelPeerOntology selectedPeer = null;
	public static VModelPeerOntology selectedPeer ( ) { return( selectedPeer ); }
	public static VModelPeerOntology selectedPeer ( VModelPeerOntology p ) {
		if ((p !=  null) && (selectedPeer != p)) {
			VModelElement e = p.peer();
			VModelElement t = p.peer();
			if (e.typep("FILE")) {
				VModelElement ontology = VModelOntology.find("OBJECTS-ONTOLOGY-LIBRARY");
				if (ontology != null) e = VModelOntology.find(ontology, t.tag(), t.getString("LABEL"));
				if (e == null) {
					ontology = VModelOntology.find("GROUPS-ONTOLOGY-LIBRARY");
					if (ontology != null) e = VModelOntology.find(ontology, t.tag(), t.getString("LABEL"));
				} // end if e
				if (e == null) {
					ontology = VModelOntology.find("MODELS-ONTOLOGY-LIBRARY");
					if (ontology != null) e = VModelOntology.find(ontology, t.tag(), t.getString("LABEL"));
				} // end if e
			} // end if FILE
			selectedOntology(e);
		} // end if p
		if (p ==  null) selectedOntology(null);
		return( selectedPeer = p ); 
	} // writer selectedPeer

	protected static JTree selectedTree = null;
	public static JTree selectedTree ( ) { return( selectedTree ); }
	public static JTree selectedTree ( JTree t ) { 
		if ((t != null) && (t.getLastSelectedPathComponent() != null)) selectedPeer(((PeerTreeNode) t.getLastSelectedPathComponent()).data());
		if (t == null) selectedPeer(null);
		if ((selectedTree != null) && (selectedTree != t)) selectedTree.clearSelection();
		return( selectedTree = t ); 
	} // writer selectedTree

	protected static JToolBar toolbarOntologies = null;
	public static JToolBar toolbarOntologies ( ) { 
		if (toolbarOntologies == null) toolbarOntologies(new JToolBar());
		return( toolbarOntologies ); 
	} // reader toolbarOntologies
	public static JToolBar toolbarOntologies ( JToolBar t ) { return( toolbarOntologies = t ); }
	
	protected static JToolBar toolbarTopOntologies = null;
	public static JToolBar toolbarTopOntologies ( ) { 
		if (toolbarTopOntologies == null) toolbarTopOntologies(new JToolBar());
		return( toolbarTopOntologies ); 
	} // reader toolbarTopOntologies
	public static JToolBar toolbarTopOntologies ( JToolBar t ) { return( toolbarTopOntologies = t ); }
	
	// Inner Classes 
	// -------------------------------------------------------------------------
	public class PeerButton extends JButton {
		protected VModelPeerOntology data = null;
		public VModelPeerOntology data ( ) { return( data ); }
		public VModelPeerOntology data ( VModelPeerOntology d ) { return( data = d ); }
		public PeerButton( VModelPeerOntology data ) {
			super(label(), image());
			data(data);
			addKeyListener(system().gui());
		} // constructor PeerButton
	} // class PeerButton
    
	public class PeerMenu extends JMenu {
		protected VModelPeerOntology data = null;
		public VModelPeerOntology data ( ) { return( data ); }
		public VModelPeerOntology data ( VModelPeerOntology d ) { return( data = d ); }
		public PeerMenu( VModelPeerOntology data ) {
			super(label());
			//super(label(), image());
			data(data);
			setIcon(image());
		} // constructor PeerMenu
	} // class PeerMenu
    
	public class PeerMenuItem extends JMenuItem {
		protected VModelPeerOntology data = null;
		public VModelPeerOntology data ( ) { return( data ); }
		public VModelPeerOntology data ( VModelPeerOntology d ) { return( data = d ); }
		public PeerMenuItem( VModelPeerOntology data ) {
			super(label(), image());
			data(data);
		} // constructor PeerMenuItem
	} // class PeerMenuItem
    
	public class PeerTreeNode extends DefaultMutableTreeNode {
		protected VModelPeerOntology data = null;
		public VModelPeerOntology data ( ) { return( data ); }
		public VModelPeerOntology data ( VModelPeerOntology d ) { return( data = d ); }
		public PeerTreeNode( VModelPeerOntology data ) {
			super(label());
			data(data);
		} // constructor PeerTreeNode
	} // class PeerTreeNode
    
	public class PeerTreeRenderer extends DefaultTreeCellRenderer {
		public Component getTreeCellRendererComponent(JTree tree,
										Object value, boolean selected, 
										boolean expanded, boolean leaf,
										int row, boolean hasFocus) {
			super.getTreeCellRendererComponent(tree, value, selected,
										expanded, leaf, row, hasFocus);
			PeerTreeNode node = (PeerTreeNode) value;
			String tag = node.data().peer().tag;
			ImageIcon graphicIcon = node.data().image();
			setToolTipText(node.data().peer().getString("TYPE"));
			if (graphicIcon != null) {
				setIcon(graphicIcon);
			} else {
				setIcon(system().gui().getImage("vmodel2.gif"));
				//setToolTipText(null);
			} // end if graphicIcon
			return this;
		} // method getTreeCellRendererComponent
	} // innerclass PeerTreeRenderer
    
		
	// Methods
	// -------------------------------------------------------------------------
	public void modeChange ( String mode ) {
		boolean flag = isMode(mode);
		if (tabindex > -1) tabpane().setEnabledAt(tabindex() , flag);
		if (button() != null) {
			button().setEnabled(flag); 
			button().setVisible(flag);
			if (parent() == null) {
				if (flag) toolbarTopOntologies().add(button()); 
				else toolbarTopOntologies().remove(button()); 
			} else if (peer().typep("ONTOLOGY")) {
				if (flag) toolbarOntologies().add(button()); 
				else toolbarOntologies().remove(button()); 
			} 
		} // end if button
		if (menuitem() != null) menuitem().setEnabled(flag); 
		if (tree() != null) tree().setEnabled(flag); 
		if (this == selectedPeer()) selectedTree(null);
		for(int i = 0; i < children().size(); i++) 
			((VModelPeerOntology) children().elementAt(i)).modeChange(mode);
		if (parent() == null) {
			toolbarOntologies().invalidate();
			toolbarOntologies().validate();
			toolbarTopOntologies().invalidate();
			toolbarTopOntologies().validate();
		} // end if parent
	} // method modeChange

	public void add ( VModelPeerOntology child ) {
		children().addElement(child);
		if (treenode() != null) treenode().add(child.treenode());
		if (treepath() != null) child.treepath(treepath().pathByAddingChild(child.treenode()));
	} // method add
	
	public boolean isMode ( String mode ) {
		boolean result = false;
		String modes = peer().getString("MODE");
		result = ((modes.indexOf(mode) > -1) || (modes.indexOf("ALL") > -1));
		return(result);
	} // predicate isMode

/*
	public void removeAllChildren () {
		for(int i = peer().elements().size() - 1; i >= 0; i--) {
			peer().remove((VModelElement) peer().elements().elementAt(i));
		} // for i
		children(new Vector());
		//	menuitem.add(child.menuitem);
		treenode().removeAllChildren();
	} // method add
*/

/*
	public VModelOntology addToOntology (VModelElement element) {
		VModelOntology result = new VModelOntology(element);
/*		VModelOntology parent = null;
		DefaultTreeModel parentTree = null;
		if (element.getString("TYPE").equalsIgnoreCase("GROUP")) {
			parent = modelLibraryGroupsOntology;
			parentTree = modelLibraryGroupsModel;
		} else if (element.getString("TYPE").equalsIgnoreCase("MODEL")) {
			parent = modelLibraryModelsOntology;
			parentTree = modelLibraryModelsModel;
		} else {
			parent = modelLibraryObjectsOntology;
			parentTree = modelLibraryObjectsModel;
		} // end if type
		parent.add(result);
		parentTree.reload();
		((DefaultTreeModel)tree.getModel()).reload();
		expandTree(tree);
		//tree.setSelectionPath(result.treepath);
//*		return(result);
	} // method makeOntology
*/

/*	public void refreshFILEOntologies ( ) {
		VModelOntology grumble = null;
		VModelElement element = null;
		for(int j = fileOntologies.size() - 1; j >= 0; j--) {
			grumble = (VModelOntology)fileOntologies.elementAt(j);
			//grumble.removeAllChildren();
			element = grumble.entity;
			String path = QRGutils.QRGroot() + getString("PATH") + element.getString("PATH");
			File dir = new File(path);
			String files[] = dir.list(new vmfFileFilter());
			VModelElement mumble = null;
			for(int i = 0; i < files.length; i++) {
				mumble = new VModelElement(element.getString("TAG"));
				mumble.set("LABEL", files[i]);
				mumble.set("PATH", path);
				element.add(mumble);
				addToOntology(element);
				//makeOntology(element, grumble);
			} // for i
			//((DefaultTreeModel)tree.getModel()).reload();
			//expandTree(tree);
			//tree.setSelectionPath(grumble.treepath);
		} // for j
	} // method refreshFILEOntologies
*/
    // Notes: To what level? (Should specify?)
    public void expandTree (JTree tree) {
		if (tree != null) {
		    int level = 0;
		    int rows = tree.getRowCount();
		    int i = 0;
		    while(level < rows) {
			for(i = level; i < rows; i++) {
			    tree.expandRow(i);
			} // end for i
			level = rows;
			rows = tree.getRowCount();
		    } // end while
		} // if tree
    } // method expandTree

    public void expandNode (JTree tree, PeerTreeNode node) {
		if (tree != null) {
			tree.expandPath(node.data().treepath());
			for(int i = 0; i < node.data().children().size(); i++) {
				tree.expandPath(((VModelPeerOntology) node.data().children().elementAt(i)).treepath());
			} // for i
		} // if tree
    } // method expandTree
    
    public JMenuItem makeMenu ( ) {
		for(int i = 0; i < children().size(); i++) {
			menuitem().add(((VModelPeerOntology) children().elementAt(i)).makeMenu());
			} // for i
		return(menuitem());
    } // method makeMenuItem
    
    public void popupMenu ( ) {
    	try {
    		Thread t = new Thread( ) {
    			public void run ( ) {
    				JPopupMenu menu = new JPopupMenu( label() );
    				for(int i = 0; i < children().size(); i++) {
    					menu.add(((VModelPeerOntology) children().elementAt(i)).makeMenu());
    				} // for i
    				menu.show(button(), 0,0);
    			} // method run
    		}; // anonymouse class Thread
    		t.start();
    	} catch (Exception e) {
			QRGutils.debug("VModelPeerOntology","popupMenu e=" + e);
    		e.printStackTrace();
    	} // end try-catch
    } // method popupMenu


	// ActionListener Methods
	// -------------------------------------------------------------------------
	public void actionPerformed(ActionEvent ev) {
		final ActionEvent e = ev;
		try {
			Thread t = new Thread() {
				public void run ( ) {
					if (e.getSource() instanceof PeerButton) {
						((PeerButton) e.getSource()).data().popupMenu();
					} else if (e.getSource() instanceof PeerMenuItem) {
						PeerMenuItem node = (PeerMenuItem) e.getSource();
if (node.data() != null) QRGutils.debug("VModelPeerOntology", "actionPerformed e=" + node.data().peer().tag());
						if (node != null) {
							if ((node.data() != null) && node.data().peer().tag().equalsIgnoreCase("MODEL")) {
								int choice = JOptionPane.showConfirmDialog(system().gui().frame(), "Do you want to open "+node.data().label()+"?");
								if (choice == JOptionPane.YES_OPTION) {
									system().gui().loadModel(node.data().peer());
								} // end if choice
							} // end if data
							if ((node.data() != null) && (!node.data().peer().tag().equalsIgnoreCase("ONTOLOGY"))) {
								if (node.data().selectedTree() != null) node.data().selectedTree().clearSelection();
								//node.data().selectedTree(node.data().tree());
								//node.data().tree().expandPath(node.data().treepath());
								//node.data().tree().setSelectionPath(node.data().treepath());
								//node.data().selectedTree(node.data().tree());
								node.data().selectedPeer(node.data());
								system().gui().statusbar(node.data().label() + ": " + node.data().peer().get("DESCRIPTION"));
							} // end else
						} // end if node
					} // end if source
				} // method run
			}; // Anonymous Class Thread
			t.start();
		} catch (Exception ex) {
			QRGutils.debug("VModelPeerOntology","popupMenu e=" + ex);
    		ex.printStackTrace();
    	} // end try-catch
	} // method actionPerformed

	// MouseListener Methods
	// -------------------------------------------------------------------------
	public void mousePressed(MouseEvent e) {
		int selRow = tree.getRowForLocation(e.getX(), e.getY());
		TreePath selPath = tree.getPathForLocation(e.getX(), e.getY());
		JTree tree = (JTree) e.getSource();
		tree.setSelectionPath(selPath);
		PeerTreeNode node = (PeerTreeNode) ((JTree) e.getSource()).getLastSelectedPathComponent();
		if(selRow != -1) {
			if(e.getClickCount() == 1) {
				if (node != null) {
					if (QRGutils.isRightClick(e)) {
					QRGutils.debug("VModelPeerOntology","peer=" + node.data().peer());
						node.data().ontologyRightClickMenu().show(tree,e.getX(), e.getY());
					/*
						if ((node.data() != null) && node.data().peer().tag().equalsIgnoreCase("MODEL")) {
							int choice = JOptionPane.showConfirmDialog(system().gui().frame(), "Do you want to open "+node.data().label()+"?");
							if (choice == JOptionPane.YES_OPTION) {
								system().gui().loadModel(node.data().peer());
							} else {
								selectedTree((JTree) e.getSource());
								((JTree) e.getSource()).expandPath(selPath);
								system().gui().statusbar(node.data().label() + ": " + node.data().peer().get("DESCRIPTION"));
							} // end if option
						}
						*/
					} 
					if (!node.data().peer().tag().equalsIgnoreCase("ONTOLOGY")) {
						////gui.mode((String)node.data.entity.get("MODE"));
						selectedTree((JTree) e.getSource());
						((JTree) e.getSource()).expandPath(selPath);
						system().gui().statusbar(node.data().label() + ": " + node.data().peer().get("DESCRIPTION"));
					} else {
						////gui.mode(system.DESCRIBE);
						//system().gui().selectedFrame().selectedontology(null);
						if (((JTree) e.getSource()).isCollapsed(selRow)) expandNode((JTree) e.getSource(), node);
						else ((JTree) e.getSource()).collapsePath(selPath);
						system().gui().statusbar(node.data().label() + ": " + node.data().peer().get("DESCRIPTION"));
						((JTree) e.getSource()).clearSelection();
					} // end else
					////gui.selectedFrame().selectedontology().selectionpath = getSelectionPath();
					if (node.data().treepath() == null) node.data().treepath(tree().getSelectionPath());
				} // end if node
			} else if(e.getClickCount() == 2) {
			/*
				if (node != null) {
					//if (node.data() != system().gui().selectedModel().selectedontology()) {
						if (node.data().peer().tag().equalsIgnoreCase("ONTOLOGY")) {
							////gui.mode(system.DESCRIBE);
							//system().gui().selectedFrame().selectedontology(null);
							if (((JTree) e.getSource()).isCollapsed(selRow)) expandNode((JTree) e.getSource(), node);
							else ((JTree) e.getSource()).collapsePath(selPath);
							system().gui().statusbar(node.data().peer().getString("DESCRIPTION"));
							((JTree) e.getSource()).clearSelection();
							system().gui().browser().setTitle("VModel Help");
							system().gui().browser().setSize(700,300);
							system().gui().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, node.data().peer().getString("HELP-LINK"));
						} else {
							system().gui().browser().setTitle("VModel Help: " + node.data().label());
							system().gui().browser().setSize(700,300);
							system().gui().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, node.data().peer().getString("HELP-LINK"));
						} // end else
						////gui.selectedFrame().selectedontology().selectionpath = getSelectionPath();
					//} // end if node.data
				} // end if node
				*/
			} else if(e.getClickCount() == 3) {
				//QRGutils.debug("VModelPeerOntology", "mouseTripleClicked selPath=" + selPath + " mod=" + KeyEvent.getKeyModifiersText(e.getModifiers()));
			} // end if clickCount
		} // end if selRow
	} // method mouseClicked
	public void mouseEntered(MouseEvent e) { }
	public void mouseExited(MouseEvent e) { }
	public void mouseClicked(MouseEvent e) { }
	public void mouseReleased(MouseEvent e) { }

	// Constructors
	// -------------------------------------------------------------------------
	public VModelPeerOntology ( VModel system, VModelGUI gui ) {
		system(system);
		gui(gui);
		allPeerOntologies().addElement(this);
	} // constructor VModelPeerOntology

	public VModelPeerOntology ( VModel system, VModelGUI gui, VModelElement peer ) {
		this(system, gui, peer, null);
		
		treemodel(new DefaultTreeModel(treenode(), true));
		tree(new JTree(treemodel()));
		tree().setCellRenderer(new PeerTreeRenderer());
		tree().getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);

		treepane(new JScrollPane(tree()));
		treepane().addKeyListener(system().gui());
		treepane().setOpaque(false);
		tree().addMouseListener(this);
		tree().addKeyListener(system().gui());
		tree().setRootVisible(false);

		//expandTree(tree());
		
		if (image() == null)
			tabpane().add(peer().getString("LABEL"), treepane());
		else
			tabpane().addTab(peer().getString("LABEL"), image(), treepane());
		tabpane().addKeyListener(system().gui());
		tabindex(tabpane().indexOfComponent(treepane()));
		if (label().equalsIgnoreCase("MY LIBRARY")) {
			if (system().preferences().get("COLOR") != null) {
				button().setBackground(system().preferences().getColor("COLOR"));
				//tabpane().setBackgroundAt(tabindex(), system().preferences().getColor("COLOR"));
				tabpane().setForegroundAt(tabindex(), system().preferences().getColor("COLOR"));
				//tree().setBackground(system().preferences().getColor("COLOR"));
			} else {
				button().setBackground(BLUE);
				//tabpane().setBackgroundAt(tabindex(), BLUE);
				tabpane().setForegroundAt(tabindex(), BLUE);
				//tree().setBackground(BLUE);
			} // color
		} // end if label
		button().setText(null);
		button().setToolTipText(label());
		button().setSize(30, button().getPreferredSize().height);
		button().setPreferredSize(button().getSize());
		toolbarTopOntologies().add(button());
	} // constructor VModelPeerOntology

	public VModelPeerOntology ( VModel system, VModelGUI gui, VModelElement peer, VModelPeerOntology parent ) {
		this(system, gui);
		peer(peer);
		peer().peer(this);
		parent(parent);
		if (parent() != null) parent().children().addElement(this);
		if (peer() != null) {
			if (peer().get("GRAPHIC") != null) image(system().gui().getImage(peer().getString("GRAPHIC")));
			else image(system().gui().getImage("vmodel2.gif"));
			button(new PeerButton(this));
			button().addActionListener(this);
			treenode(new PeerTreeNode(this));
			if (parent() == null) {
				treepath(new TreePath(treenode()));
			} else {
				parent().add(this);
				tree(parent().tree());
				if (peer().typep("ONTOLOGY")) {
					button().setText(null);
					button().setToolTipText(label());
					button().setSize(30, button().getPreferredSize().height);
					button().setPreferredSize(button().getSize());
					if (label().equalsIgnoreCase("MY OBJECTS") || 
						 label().equalsIgnoreCase("MY GROUPS") ||
						 label().equalsIgnoreCase("MY MODELS")) {
						if (system().preferences().get("COLOR") != null)
							button().setBackground(system().preferences().getColor("COLOR"));
						else
							button().setBackground(BLUE);
					} // end if label
					toolbarOntologies().add(button());
				} // end if typep
			} // end if parent
			for(int i = 0; i < peer().elements().size(); i++) {
				new VModelPeerOntology(system(), gui(),(VModelElement) peer().elements().elementAt(i), this);
			} // for i
			if (children().size() != 0) menuitem(new PeerMenu(this));
			else menuitem(new PeerMenuItem(this)).addActionListener(this);
			ontologyRightClickMenu(new JPopupMenu(label()));
			if (peer().typep("MODEL") || peer().typep("GROUP")) {
				JMenuItem loadMenuItem = new JMenuItem("Open as Model");
				loadMenuItem.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent ev) {
						final ActionEvent e = ev;
						try {
							Thread t = new Thread() {
								public void run ( ) {
									gui().loadModel(peer());
								} // method run
							}; // Anonymous Class Thread
							t.start();
						} catch (Exception err) {}
					} // method actionPerformed
				}); // actionListener
				ontologyRightClickMenu().add(loadMenuItem);
			}
			JMenuItem help = new JMenuItem("Help");
			help.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent ev) {
					final ActionEvent e = ev;
					try {
						Thread t = new Thread() {
							public void run ( ) {
								gui().browser().setTitle("VModel Help: " + label());
								gui().browser().setSize(700,300);
								gui().browser().gotoPage(QRGutils.QRGroot() + HELPPATH, peer().getString("HELP-LINK"));
							} // method run
						}; // Anonymous Class Thread
						t.start();
					} catch (Exception err) {}
				} // method actionPerformed
			}); // actionListener
			ontologyRightClickMenu().add(help);
		} // end if peer
	} // constructor VModelPeerOntology

} // class VModelPeerOntology
    
// -----------------------------------------------------------------------------
// End of File: VModelPeerOntology.java         (c) 2001 Northwestern University
