package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelElement.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: A named object having attributes and possibly containing other 
//            elements.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.lang.*;
import java.util.*;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.net.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;

// -----------------------------------------------------------------------------
// Notes:
// * 
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelPeerPanel 
// -----------------------------------------------------------------------------
public class VModelPeerPanel extends VModelPanel implements VModelConstants {
	// Constants
	// --------------------------------------------------------------------------
	public int RECTANGLE = 1;
	public int ROUND = 2;
	public int DIAMOND = 4;
	public int BOX = 8;

	public int ROUND_WIDTH_CONSTANT = 30;
	public int DIAMOND_WIDTH_CONSTANT = 30;
//	public int DIAMOND_WIDTH_CONSTANT = 30;

	// Properties & Accessors
	// --------------------------------------------------------------------------
	protected VModelPeer controller = null; 
	public VModelPeer controller ( ) { return( controller ); }
	public VModelPeer controller ( VModelPeer c ) { 
		return(controller = c); 
	} // writer controller
		
	// Methods
	// --------------------------------------------------------------------------

	// Compontent Methods
	// --------------------------------------------------------------------------

	// InnerClasses
	// --------------------------------------------------------------------------
	public class SelectablePanel extends VModelPanel implements VModelConstants {
		// Constants
		// -----------------------------------------------------------------------

		// Properties & Accessors
		// -----------------------------------------------------------------------
		
		// Methods
		// -----------------------------------------------------------------------

		// Compontent Methods
		// -----------------------------------------------------------------------
		public Dimension getPreferredSize() {
			Dimension result = super.getPreferredSize();
			if ((shape() & DIAMOND) != 0) {
				result.setWidth(result.getWidth() + DIAMOND_WIDTH_CONSTANT);
				result.setHeight(result.getHeight() + DIAMOND_HEIGHT_CONSTANT);
			} else if (shape() == ROUND) 
				result.setWidth(result.getWidth() + ROUND_WIDTH_CONSTANT);
			return(result);
		} // end getPreferredSize

		public void paint (Graphics g) {
			if ((shape() & ROUND) != 0) {
				if (active()) setColor(roundColor());
				else setColor(inactiveRoundColor());
				g.fillRoundRect(4, 4, getSize().width - 8, getSize().height - 8, 40, 40);
				if selected() {
					g.setColor(RED);
					g.drawRoundRect(0, 0, getSize().width, getSize().height, 40, 40);
					g.drawRoundRect(1, 1, getSize().width - 2, getSize().height - 2, 40, 40);
				} // end if selected
			} // end if ROUND
			if ((shape() & RECTANGLE) != 0) {
				if (active()) setColor(rectangleColor());
				else setColor(inactiveRectangleColor());
				g.fillRect(4, 4, getSize().width - 8, getSize().height - 8);
				if selected() {
					g.setColor(RED);
					g.drawRect(0, 0, getSize().width, getSize().height, 40, 40);
					g.drawRect(1, 1, getSize().width - 2, getSize().height - 2, 40, 40);
				} // end if selected
			} // end if RECTANGLE 
			if ((shape() & DIAMOND) != 0) {
				if (active()) setColor(diamondColor());
				else setColor(inactiveDiamondColor());
				g.fillPolygon(4, 4, getSize().width - 8, getSize().height - 8);
				if selected() {
					g.setColor(RED);
					g.drawPolygon(0, 0, getSize().width, getSize().height, 40, 40);
					g.drawPolygon(1, 1, getSize().width - 2, getSize().height - 2, 40, 40);
				} // end if selected
			} // end if RECTANGLE 
		} // end method

		// InnerClasses
		// -----------------------------------------------------------------------

		// Constructors
		// -----------------------------------------------------------------------
	
	} // innerclass SelectablePanel

	// Constructors
	// --------------------------------------------------------------------------
	

} // class VModelPeerPanel

// -----------------------------------------------------------------------------
// End of File: VModelPeerPanel.java            (c) 2001 Northwestern University
