package edu.qrg.vmodel.controllers.classic;
// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelPreferencesDialog.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: VModel student login facility.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.colorchooser.*;

// -----------------------------------------------------------------------------
// Notes:
// * Should the file IO routines be included in this class?
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelPreferencesDialog
// Description: VModel student login facility.  
// -----------------------------------------------------------------------------
public class VModelPreferencesDialog extends JDialog implements VModelConstants {
	// InnerClasses and Interfaces
	// --------------------------------------------------------------------------

	// Properties and Accessors
	// --------------------------------------------------------------------------
	protected VModelGUI gui = null;
	public VModelGUI gui ( ) { return(gui); }
	public VModelGUI gui ( VModelGUI g ) { return(gui = g); }

	protected InfoPane infoPane = null;
	public InfoPane infoPane( ) { return( infoPane ); } // reader infoPane
	public InfoPane infoPane( InfoPane l ) { return( infoPane = l ); }
	public InfoPane infoPane( VModelPreferencesDialog l ) { 
		validate();
		if (infoPane() == null) infoPane(new InfoPane(l));
		else infoPane().setVisible(true);
		return( infoPane() ); 
	} // method InfoPane
	
	JCheckBox FRAME_CONTAINMENT = new JCheckBox("FRAME-CONTAINMENT");
	JCheckBox SHOW_MODEL_LIBRARY = new JCheckBox("SHOW-MODEL-LIBRARY");
	JCheckBox MAXIMIZE_NEW_MODELS = new JCheckBox("MAXIMIZE-NEW-MODELS");
	JCheckBox ALLOW_EMPTY_DESKTOP = new JCheckBox("ALLOW-EMPTY-DESKTOP");
	JCheckBox EXPANDED_ONTOLOGY_TOOLBAR = new JCheckBox("EXPANDED-ONTOLOGY-TOOLBAR");
//	JCheckBox TOOLBARLABELS = new JCheckBox("TOOLBARLABELS");
//	JCheckBox MAXIMIZENEWMODELS = new JCheckBox("MAXIMIZENEWMODELS");
//	JCheckBox ALLOWEMPTYDESKTOP = new JCheckBox("ALLOWEMPTYDESKTOP");
		
	// Methods.
	// --------------------------------------------------------------------------
    public void show ( ) {
    	FRAME_CONTAINMENT.setSelected(gui().preferences().getBoolean("GUI","FRAME-CONTAINMENT"));
    	SHOW_MODEL_LIBRARY.setSelected(gui().preferences().getBoolean("GUI","SHOW-MODEL-LIBRARY"));
    	MAXIMIZE_NEW_MODELS.setSelected(gui().preferences().getBoolean("GUI","MAXIMIZE-NEW-MODELS"));
    	ALLOW_EMPTY_DESKTOP.setSelected(gui().preferences().getBoolean("GUI","ALLOW-EMPTY-DESKTOP"));
    	EXPANDED_ONTOLOGY_TOOLBAR.setSelected(gui().preferences().getBoolean("GUI","EXPANDED-ONTOLOGY-TOOLBAR"));
    	//TOOLBARLABELS.setSelected(gui().preferences().getBoolean("GUI","TOOLBARLABELS"));
    	//MAXIMIZENEWMODELS.setSelected(gui().preferences().getBoolean("GUI","MAXIMIZENEWMODELS"));
    	//ALLOWEMPTYDESKTOP.setSelected(gui().preferences().getBoolean("GUI","ALLOWEMPTYDESKTOP"));
    	infoPane(this);
    	super.show();
    } // method show

	// Inner Classes
	// --------------------------------------------------------------------------
    public class InfoPane extends JPanel implements ActionListener {	
    	VModelPreferencesDialog parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, textPanel1 = null, textPanel2 = null, textPanel3 = null, buttonPanel = null;
    	JButton back = null, ok = null, cancel = null;
    	JColorChooser clrChooser = null;
    	
    	public void setVisible ( boolean b ) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed ( ActionEvent e ) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
		    	gui().preferences().set("GUI","FRAME-CONTAINMENT",FRAME_CONTAINMENT.isSelected());
		    	gui().preferences().set("GUI","SHOW-MODEL-LIBRARY",SHOW_MODEL_LIBRARY.isSelected());
				gui().showModelLibrary(SHOW_MODEL_LIBRARY.isSelected());
				gui().menuWindowLibrary().setState(SHOW_MODEL_LIBRARY.isSelected());    	
				gui().preferences().set("GUI","MAXIMIZE-NEW-MODELS",MAXIMIZE_NEW_MODELS.isSelected());
		    	gui().preferences().set("GUI","ALLOW-EMPTY-DESKTOP",ALLOW_EMPTY_DESKTOP.isSelected());
		    	gui().preferences().set("GUI","EXPANDED-ONTOLOGY-TOOLBAR",EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
				VModelPeerOntology.toolbarTopOntologies().setVisible(!EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
		    	VModelPeerOntology.toolbarOntologies().setVisible(EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
		    	//gui().preferences().set("GUI","TOOLBARLABELS",TOOLBARLABELS.isSelected());
		    	//gui().preferences().set("GUI","MAXIMIZENEWMODELS",MAXIMIZENEWMODELS.isSelected());
		    	//gui().preferences().set("GUI","ALLOWEMPTYDESKTOP",ALLOWEMPTYDESKTOP.isSelected());
		    	gui().preferences().save();
				parent.hide();
    		} else if (e.getSource() == cancel) parent.hide(); //System.exit(-1);
    	} // method actionPerformed
    	
    	public InfoPane ( VModelPreferencesDialog parent ) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		textPanel = new JPanel(new GridLayout(8, 1));
    		textPanel.add(FRAME_CONTAINMENT);
    		textPanel.add(SHOW_MODEL_LIBRARY);
    		textPanel.add(MAXIMIZE_NEW_MODELS);
    		textPanel.add(ALLOW_EMPTY_DESKTOP);
    		textPanel.add(EXPANDED_ONTOLOGY_TOOLBAR);
 //   		textPanel.add(TOOLBARLABELS);
 //   		textPanel.add(MAXIMIZENEWMODELS);
 //   		textPanel.add(ALLOWEMPTYDESKTOP);
    		this.add(textPanel, BorderLayout.NORTH);

    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor InfoPane
    } // innerclass InfoPane

	// Constructor
	// --------------------------------------------------------------------------
	public VModelPreferencesDialog( VModelGUI gui ) {
		super((Frame) null, "VModel Preferences");
    	setSize(430,375);
    	setModal(true);
		gui(gui);
		infoPane(this);
	} // constructor VModelPreferencesDialog

} // class VModelPreferencesDialog

// -----------------------------------------------------------------------------
// End of File: VModelPreferencesDialog.java    (c) 2002 Northwestern University
