package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import edu.qrg.vmodel.controllers.common.*;

public class VModelMenuBar extends JMenuBar implements VModelConstants {
	// Constructors
	// -----------------------------------------------------------------------
	public VModelMenuBar () {
		super();
		makeMenuBar();
	} // constructor VModelMenuBar

	// Properties & Accessors
	// -----------------------------------------------------------------------
  	protected JMenu menuFile = null;
  	public JMenu menuFile () {
  		if (menuFile == null) menuFile = new JMenu("File");
  		return(menuFile);
  	} // reader menuFile
  	public JMenu menuFile (JMenu m) { return(menuFile = m); }

  	protected JMenuItem menuFileNew = null;
  	public JMenuItem menuFileNew () {
  		if (menuFileNew == null) {
  			menuFileNew = new JMenuItem("New Model", ImageCache.getImage("new.gif"));
  			menuFileNew.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().makeModel();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileNew
  		return(menuFileNew);
  	} // reader menuFileNew
  	public JMenuItem menuFileNew (JMenuItem m) { return(menuFileNew = m); }

  	protected JMenuItem menuFileOpen = null;
  	public JMenuItem menuFileOpen () {
  		if (menuFileOpen == null) {
  			menuFileOpen = new JMenuItem("Open Model File", ImageCache.getImage("open.gif"));
  			menuFileOpen.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							((MacClassroom) controller()).load();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileOpen
  		return(menuFileOpen);
  	} // reader menuFileOpen
  	public JMenuItem menuFileOpen (JMenuItem m) { return(menuFileOpen = m); }

  	protected JMenuItem menuFileSave = null;
  	public JMenuItem menuFileSave () {
  		if (menuFileSave == null) {
  			menuFileSave = new JMenuItem("Save Model File", ImageCache.getImage("save.gif"));
  			menuFileSave.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							((MacClassroom) controller()).save();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileSave
  		} // end if menuFileSave
  		return(menuFileSave);
  	} // reader menuFileSave
  	public JMenuItem menuFileSave (JMenuItem m) { return(menuFileSave = m); }

  	protected JMenuItem menuFileSaveAs = null;
  	public JMenuItem menuFileSaveAs () {
  		if (menuFileSaveAs == null) {
  			menuFileSaveAs = new JMenuItem("Save Model File As", ImageCache.getImage("saveas.gif"));
  			menuFileSaveAs.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							((MacClassroom) controller()).save(false);
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileSaveAs
  		} // end if menuFileSaveAs
  		return(menuFileSaveAs);
  	} // reader menuFileSaveAs
  	public JMenuItem menuFileSaveAs (JMenuItem m) { return(menuFileSaveAs = m); }

  	protected JMenu menuFileImport = null;
  	public JMenu menuFileImport () {
  		if (menuFileImport == null) menuFileImport = new JMenu("Import");
  		return(menuFileImport);
  	} // reader menuFileImport
  	public JMenu menuFileImport (JMenu m) { return(menuFileImport = m); }

  	protected JMenuItem menuFileImportXML = null;
  	public JMenuItem menuFileImportXML () {
  		if (menuFileImportXML == null) {
  			menuFileImportXML = new JMenuItem("Import from XML");
  			menuFileImportXML.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().loadXML();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileImportXML
  		} // end if menuFileImportXML
  		return(menuFileImportXML);
  	} // reader menuFileImportXML
  	public JMenuItem menuFileImportXML (JMenuItem m) { return(menuFileImportXML = m); }

  	protected JMenuItem menuFileImportVMF = null;
  	public JMenuItem menuFileImportVMF () {
  		if (menuFileImportVMF == null) {
  			menuFileImportVMF = new JMenuItem("Import from VMF");
  			menuFileImportVMF.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().loadVMF();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileImportVMF
  		} // end if menuFileImportVMF
  		return(menuFileImportVMF);
  	} // reader menuFileImportVMF
  	public JMenuItem menuFileImportVMF (JMenuItem m) { return(menuFileImportVMF = m); }

  	protected JMenu menuFileExport = null;
  	public JMenu menuFileExport () {
  		if (menuFileExport == null) menuFileExport = new JMenu("Export");
  		return(menuFileExport);
  	} // reader menuFileExport
  	public JMenu menuFileExport (JMenu m) { return(menuFileExport = m); }

  	protected JMenuItem menuFileExportJPG = null;
  	public JMenuItem menuFileExportJPG () {
  		if (menuFileExportJPG == null) {
  			menuFileExportJPG = new JMenuItem("Export to JPEG");
  			menuFileExportJPG.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().saveImage(IMAGE_JPEG);
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileExportJPG
  		} // end if menuFileExportJPG
  		return(menuFileExportJPG);
  	} // reader menuFileExportJPG
  	public JMenuItem menuFileExportJPG (JMenuItem m) { return(menuFileExportJPG = m); }

  	protected JMenuItem menuFileExportBMP = null;
  	public JMenuItem menuFileExportBMP () {
  		if (menuFileExportBMP == null) {
  			menuFileExportBMP = new JMenuItem("Export to BMP");
  			menuFileExportBMP.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().saveImage(IMAGE_BMP);
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileExportBMP
  		} // end if menuFileExportBMP
  		return(menuFileExportBMP);
  	} // reader menuFileExportBMP
  	public JMenuItem menuFileExportBMP (JMenuItem m) { return(menuFileExportBMP = m); }

  	protected JMenuItem menuFileExportTIF = null;
  	public JMenuItem menuFileExportTIF () {
  		if (menuFileExportTIF == null) {
  			menuFileExportTIF = new JMenuItem("Export to TIFF");
  			menuFileExportTIF.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().saveImage(IMAGE_TIFF);
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileExportTIF
  		} // end if menuFileExportTIF
  		return(menuFileExportTIF);
  	} // reader menuFileExportTIF
  	public JMenuItem menuFileExportTIF (JMenuItem m) { return(menuFileExportTIF = m); }

  	protected JMenuItem menuFileExportPNM = null;
  	public JMenuItem menuFileExportPNM () {
  		if (menuFileExportPNM == null) {
  			menuFileExportPNM = new JMenuItem("Export to PPM");
  			menuFileExportPNM.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().saveImage(IMAGE_PNM);
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileExportPNM
  		} // end if menuFileExportPNM
  		return(menuFileExportPNM);
  	} // reader menuFileExportPNM
  	public JMenuItem menuFileExportPNM (JMenuItem m) { return(menuFileExportPNM = m); }

  	protected JMenuItem menuFileExportHTML = null;
  	public JMenuItem menuFileExportHTML () {
  		if (menuFileExportHTML == null) {
  			menuFileExportHTML = new JMenuItem("Export to HTML");
  			menuFileExportHTML.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().saveHTML();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // menuFileExportHTML
  		} // end if menuFileExportHTML
  		return(menuFileExportHTML);
  	} // reader menuFileExportHTML
  	public JMenuItem menuFileExportHTML (JMenuItem m) { return(menuFileExportHTML = m); }

  	protected JMenuItem menuFileClose = null;
  	public JMenuItem menuFileClose () {
  		if (menuFileClose == null) {
  			menuFileClose = new JMenuItem("Close");
  			menuFileClose.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().closeModel();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuFileClose);
  	} // reader menuFileClose
  	public JMenuItem menuFileClose (JMenuItem m) { return(menuFileClose = m); }

  	protected JMenuItem menuFileCloseAll = null;
  	public JMenuItem menuFileCloseAll () {
  		if (menuFileCloseAll == null) {
  			menuFileCloseAll = new JMenuItem("Close All");
  			menuFileCloseAll.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().closeAllModels();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileCloseAll
  		return(menuFileCloseAll);
  	} // reader menuFileCloseAll
  	public JMenuItem menuFileCloseAll (JMenuItem m) { return(menuFileCloseAll = m); }

  	protected JMenuItem menuFilePrintPreview = null;
  	public JMenuItem menuFilePrintPreview () {
  		if (menuFilePrintPreview == null) {
  			menuFilePrintPreview = new JMenuItem("Print Preview", ImageCache.getImage("printpreview.gif"));
  			menuFilePrintPreview.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().modelOverview().showPreview();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFilePrintPreview
  		return(menuFilePrintPreview);
  	} // reader menuFilePrintPreview
  	public JMenuItem menuFilePrintPreview (JMenuItem m) { return(menuFilePrintPreview = m); }

  	protected JMenuItem menuFilePrint = null;
  	public JMenuItem menuFilePrint () {
  		if (menuFilePrint == null) {
  			menuFilePrint = new JMenuItem("Print", ImageCache.getImage("print.gif"));
  			menuFilePrint.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							try {
								Thread t = new Thread() {
									public void run () {
										((MacClassroom)controller()).printModel();
									} // method run
								}; // Anonymous Class Thread
								t.start();
							} catch (Exception err) {}
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFilePrint
  		return(menuFilePrint);
  	} // reader menuFilePrint
  	public JMenuItem menuFilePrint (JMenuItem m) { return(menuFilePrint = m); }

  	protected JMenuItem menuFileExit = null;
  	public JMenuItem menuFileExit () {
  		if (menuFileExit == null) {
  			menuFileExit = new JMenuItem("Exit");
  			menuFileExit.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().quit();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuFileExit);
  	} // reader menuFileExit
  	public JMenuItem menuFileExit (JMenuItem m) { return(menuFileExit = m); }

  	protected JMenu menuEdit = null;
  	public JMenu menuEdit () {
  		if (menuEdit == null) menuEdit = new JMenu("Edit");
  		return(menuEdit);
  	} // reader menuEdit
  	public JMenu menuEdit (JMenu m) { return(menuEdit = m); }

  	protected JMenuItem menuEditAddToLibrary = null;
  	public JMenuItem menuEditAddToLibrary () {
  		if (menuEditAddToLibrary == null) {
  			menuEditAddToLibrary = new JMenuItem("Add To Library", ImageCache.getImage("addToLibrary.gif"));
  			//menuEditAddToLibrary = new JMenuItem("Close");
  			menuEditAddToLibrary.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().addToLibraryButton().doClick();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuEditAddToLibrary);
  	} // reader menuEditAddToLibrary
  	public JMenuItem menuEditAddToLibrary (JMenuItem m) { return(menuEditAddToLibrary = m); }

  	protected JMenuItem menuEditAddGroupToLibrary = null;
  	public JMenuItem menuEditAddGroupToLibrary () {
  		if (menuEditAddGroupToLibrary == null) {
  			menuEditAddGroupToLibrary = new JMenuItem("Add Group To Library", ImageCache.getImage("addGroupToLibrary.gif"));
  			//menuEditAddGroupToLibrary = new JMenuItem("Close");
  			menuEditAddGroupToLibrary.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().addGroupToLibraryButton().doClick();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuEditAddGroupToLibrary);
  	} // reader menuEditAddGroupToLibrary
  	public JMenuItem menuEditAddGroupToLibrary (JMenuItem m) { return(menuEditAddGroupToLibrary = m); }

  	protected JMenuItem menuEditSelectAll = null;
  	public JMenuItem menuEditSelectAll () {
  		if (menuEditSelectAll == null) {
  			menuEditSelectAll = new JMenuItem("Select All");
  			//menuEditSelectAll = new JMenuItem("Close");
  			menuEditSelectAll.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								if (controller().selectedModel() != null) controller().selectedWindow().modelPane().selectAll();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuEditSelectAll);
  	} // reader menuEditSelectAll
  	public JMenuItem menuEditSelectAll (JMenuItem m) { return(menuEditSelectAll = m); }

  	protected JMenuItem menuEditDeSelectAll = null;
  	public JMenuItem menuEditDeSelectAll () {
  		if (menuEditDeSelectAll == null) {
  			menuEditDeSelectAll = new JMenuItem("Deselect All");
  			//menuEditDeSelectAll = new JMenuItem("Close");
  			menuEditDeSelectAll.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								if (controller().selectedModel() != null) controller().selectedWindow().modelPane().deselectAll();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuFileClose
  		return(menuEditDeSelectAll);
  	} // reader menuEditDeSelectAll
  	public JMenuItem menuEditDeSelectAll (JMenuItem m) { return(menuEditDeSelectAll = m); }

  	protected JMenuItem menuEditCut = null;
  	public JMenuItem menuEditCut () {
  		if (menuEditCut == null) {
  			menuEditCut = new JMenuItem("Cut", ImageCache.getImage("cut.gif"));
  			menuEditCut.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
					if (controller().currentModel( ) != null) controller().cut(); 
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditCut
  		return(menuEditCut);
  	} // reader menuEditCut
  	public JMenuItem menuEditCut (JMenuItem m) { return(menuEditCut = m); }

  	protected JMenuItem menuEditCopy = null;
  	public JMenuItem menuEditCopy () {
  		if (menuEditCopy == null) {
  			menuEditCopy = new JMenuItem("Copy", ImageCache.getImage("copy.gif"));
  			menuEditCopy.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
					if (controller().selectedModel() != null) controller().copy(); 
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditCopy
  		return(menuEditCopy);
  	} // reader menuEditCopy
  	public JMenuItem menuEditCopy (JMenuItem m) { return(menuEditCopy = m); }

  	protected JMenuItem menuEditPaste = null;
  	public JMenuItem menuEditPaste () {
  		if (menuEditPaste == null) {
  			menuEditPaste = new JMenuItem("Paste", ImageCache.getImage("paste.gif"));
  			menuEditPaste.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
					if (controller().selectedModel() != null) controller().paste(); 
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditPaste
  		return(menuEditPaste);
  	} // reader menuEditPaste
  	public JMenuItem menuEditPaste (JMenuItem m) { return(menuEditPaste = m); }

/*
  	protected JMenuItem menuEditGroup = null;
  	public JMenuItem menuEditGroup () {
  		if (menuEditGroup == null) {
  			menuEditGroup = new JMenuItem("Group", ImageCache.getImage("group.gif"));
  			menuEditGroup.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
//					((VModelInstanceModel) selectedModel().modelElement().reference()).groupSelected();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditGroup
  		return(menuEditGroup);
  	} // reader menuEditGroup
  	public JMenuItem menuEditGroup (JMenuItem m) { return(menuEditGroup = m); }
*/

  	protected JMenuItem menuEditPreferences = null;
  	public JMenuItem menuEditPreferences () {
  		if (menuEditPreferences == null) {
  			menuEditPreferences = new JMenuItem("Preferences");
  			menuEditPreferences.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().preferencesDialog().show();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEditPreferences
  		return(menuEditPreferences);
  	} // reader menuEditPreferences
  	public JMenuItem menuEditPreferences (JMenuItem m) { return(menuEditPreferences = m); }

  	protected JMenu menuView = null;
  	public JMenu menuView () {
  		if (menuView == null) menuView = new JMenu("View");
  		return(menuView);
  	} // reader menuView
  	public JMenu menuView (JMenu m) { return(menuView = m); }

  	protected JMenuItem menuViewCascade = null;
  	public JMenuItem menuViewCascade () {
  		if (menuViewCascade == null) {
  			menuViewCascade = new JMenuItem("Cascade Model Windows");
  			menuViewCascade.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().cascadeModelFrames();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewCascade
  		return(menuViewCascade);
  	} // reader menuViewCascade
  	public JMenuItem menuViewCascade (JMenuItem m) { return(menuViewCascade = m); }

  	protected JMenuItem menuViewTile = null;
  	public JMenuItem menuViewTile () {
  		if (menuViewTile == null) {
  			menuViewTile = new JMenuItem("Tile Model Windows");
  			menuViewTile.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().tileModelFrames();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewTile
  		return(menuViewTile);
  	} // reader menuViewTile
  	public JMenuItem menuViewTile (JMenuItem m) { return(menuViewTile = m); }

  	protected JCheckBoxMenuItem menuViewProblem = null;
  	public JCheckBoxMenuItem menuViewProblem () {
  		if (menuViewProblem == null) {
  			menuViewProblem = new JCheckBoxMenuItem("Show Problem Statement");
  			menuViewProblem.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					final ActionEvent evnt = e;
					Runnable doStart = new Runnable() {
						public void run () {
//								((VModelFrame) selectedModel().reference()).showProblemStatement(((JCheckBoxMenuItem) evnt.getSource()).getState());
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewProblem
  		return(menuViewProblem);
  	} // reader menuViewProblem
  	public JCheckBoxMenuItem menuViewProblem (JCheckBoxMenuItem m) { return(menuViewProblem = m); }

  	protected JCheckBoxMenuItem menuViewRulers = null;
  	public JCheckBoxMenuItem menuViewRulers () {
  		if (menuViewRulers == null) {
  			menuViewRulers = new JCheckBoxMenuItem("Show Rulers");
  			menuViewRulers.setSelected(true);
  			menuViewRulers.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
  					final ActionEvent evnt = e;
					Runnable doStart = new Runnable() {
						public void run () {
							controller().selectedWindow().modelPane().showRulers(menuViewRulers().isSelected());
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuViewRulers
  		return(menuViewRulers);
  	} // reader menuViewRulers
  	public JCheckBoxMenuItem menuViewRulers (JCheckBoxMenuItem m) { return(menuViewRulers = m); }

  	protected JRadioButtonMenuItem menuViewAll = null;
  	public JRadioButtonMenuItem menuViewAll () {
  		if (menuViewAll == null) menuViewAll = new JRadioButtonMenuItem("View All Maps");
  		return(menuViewAll);
  	} // reader menuViewAll
  	public JRadioButtonMenuItem menuViewAll (JRadioButtonMenuItem m) { return(menuViewAll = m); }

  	protected JRadioButtonMenuItem menuViewCausal = null;
  	public JRadioButtonMenuItem menuViewCausal () {
  		if (menuViewCausal == null) menuViewCausal = new JRadioButtonMenuItem("Highlight Causes");
  		return(menuViewCausal);
  	} // reader menuViewCausal
  	public JRadioButtonMenuItem menuViewCausal (JRadioButtonMenuItem m) { return(menuViewCausal = m); }

  	protected JRadioButtonMenuItem menuViewSituation = null;
  	public JRadioButtonMenuItem menuViewSituation () {
  		if (menuViewSituation == null) menuViewSituation = new JRadioButtonMenuItem("Highlight Objects & Describers");
  		return(menuViewSituation);
  	} // reader menuViewSituation
  	public JRadioButtonMenuItem menuViewSituation (JRadioButtonMenuItem m) { return(menuViewSituation = m); }

  	protected JRadioButtonMenuItem menuViewEvidence = null;
  	public JRadioButtonMenuItem menuViewEvidence () {
  		if (menuViewEvidence == null) menuViewEvidence = new JRadioButtonMenuItem("Highlight Justify Map");
  		return(menuViewEvidence);
  	} // reader menuViewEvidence
  	public JRadioButtonMenuItem menuViewEvidence (JRadioButtonMenuItem m) { return(menuViewEvidence = m); }

  	protected JRadioButtonMenuItem menuViewButJustify = null;
  	public JRadioButtonMenuItem menuViewButJustify () {
  		if (menuViewButJustify == null) menuViewButJustify = new JRadioButtonMenuItem("Hide Justify Map");
  		return(menuViewButJustify);
  	} // reader menuViewButJustify
  	public JRadioButtonMenuItem menuViewButJustify (JRadioButtonMenuItem m) { return(menuViewButJustify = m); }

  	protected JMenu menuWindow = null;
  	public JMenu menuWindow () {
  		if (menuWindow == null) menuWindow = new JMenu("Window");
  		return(menuWindow);
  	} // reader menuWindow
  	public JMenu menuWindow (JMenu m) { return(menuWindow = m); }

  	protected static JMenu menuWindowModels = null;
  	public static JMenu menuWindowModels () {
  		if (menuWindowModels == null) menuWindowModels = new JMenu("Models");
  		return(menuWindowModels);
  	} // reader menuWindowModels
  	public JMenu menuWindowModels (JMenu m) { return(menuWindowModels = m); }

  	protected ButtonGroup menuWindowModelsGroup = null;
  	public ButtonGroup menuWindowModelsGroup () {
  		if (menuWindowModelsGroup == null) menuWindowModelsGroup(new ButtonGroup());
  		return(menuWindowModelsGroup);
  	} // reader menuWindowModelsGroup
  	public ButtonGroup menuWindowModelsGroup (ButtonGroup m) { return(menuWindowModelsGroup = m); }

  	protected JCheckBoxMenuItem menuWindowOntology = null;
  	public JCheckBoxMenuItem menuWindowOntology () {
  		if (menuWindowOntology == null) {
  			menuWindowOntology = new JCheckBoxMenuItem("Show Side Panel");
  			menuWindowOntology.setSelected(true);
  			menuWindowOntology.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								VModelSidePanel.self().setVisible(menuWindowOntology().getState());
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuWindowOntology
  		return(menuWindowOntology);
  	} // reader menuWindowOntology
  	public JCheckBoxMenuItem menuWindowOntology (JCheckBoxMenuItem m) { return(menuWindowOntology = m); }

  	protected JMenuItem menuWindowModelOverview = null;
  	public JMenuItem menuWindowModelOverview () {
  		if (menuWindowModelOverview == null) {
  			menuWindowModelOverview = new JMenuItem("Model Overview", ImageCache.getImage("preview.gif"));
  			menuWindowModelOverview.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
								controller().modelOverview().showOverview();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuWindowModelOverview
  		return(menuWindowModelOverview);
  	} // reader menuWindowModelOverview
  	public JMenuItem menuWindowModelOverview (JMenuItem m) { return(menuWindowModelOverview = m); }

  	protected JMenu menuHelp = null;
  	public JMenu menuHelp () {
  		if (menuHelp == null) menuHelp = new JMenu("Help");
  		return(menuHelp);
  	} // reader menuHelp
  	public JMenu menuHelp (JMenu m) { return(menuHelp = m); }

  	protected JMenuItem menuHelpIndex = null;
  	public JMenuItem menuHelpIndex () {
  		if (menuHelpIndex == null) {
  			menuHelpIndex = new JMenuItem("Index");
  			menuHelpIndex.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().help();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuHelpIndex
  		return(menuHelpIndex);
  	} // reader menuHelpIndex
  	public JMenuItem menuHelpIndex (JMenuItem m) { return(menuHelpIndex = m); }

  	protected JMenuItem menuHelpKeys = null;
  	public JMenuItem menuHelpKeys () {
  		if (menuHelpKeys == null) {
  			menuHelpKeys = new JMenuItem("Keyboard Help");
  			menuHelpKeys.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().shortcutHelp();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuHelpKeys
  		return(menuHelpKeys);
  	} // reader menuHelpKeys
  	public JMenuItem menuHelpKeys (JMenuItem m) { return(menuHelpKeys = m); }

  	protected JMenuItem menuEMailCoach = null;
  	public JMenuItem menuEMailCoach () {
  		if (menuEMailCoach == null) {
  			menuEMailCoach = new JMenuItem("eMail Doctor V.");
  			menuEMailCoach.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().sidepanel().coachButton().doClick();
							controller().sidepanel().coachPanel().setSelectedComponent(controller().sidepanel().coachEmailPanel());
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuEMailCoach
  		return(menuEMailCoach);
  	} // reader menuEMailCoach
  	public JMenuItem menuEMailCoach (JMenuItem m) { return(menuEMailCoach = m); }

  	protected JMenuItem menuGrammarCoach = null;
  	public JMenuItem menuGrammarCoach () {
  		if (menuGrammarCoach == null) {
  			menuGrammarCoach = new JMenuItem("VModel Coach");
  			menuGrammarCoach.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							Model model = controller().currentModel();
							if (model != null) {
								controller().checkModel(model, Model.CHECKALL, true);
								controller().selectedWindow().modelPane().updateContextHelp();
								controller().sidepanel().coachButton().doClick();
								controller().sidepanel().coachPanel().setSelectedComponent(controller().coachAskPanel());
							} // end if
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuGrammarCoach
  		return(menuGrammarCoach);
  	} // reader menuGrammarCoach
  	public JMenuItem menuGrammarCoach (JMenuItem m) { return(menuGrammarCoach = m); }

  	protected JMenuItem menuHelpAbout = null;
  	public JMenuItem menuHelpAbout () {
  		if (menuHelpAbout == null) {
  			menuHelpAbout = new JMenuItem("About");
  			menuHelpAbout.addActionListener(new ActionListener() {
  				public void actionPerformed(ActionEvent e) {
					Runnable doStart = new Runnable() {
						public void run () {
							controller().about();
						} };
					SwingUtilities.invokeLater(doStart);
  				} // method actionPerformed
  			}); // ActionListener
  		} // end if menuHelpAbout
  		return(menuHelpAbout);
  	} // reader menuHelpAbout
  	public JMenuItem menuHelpAbout (JMenuItem m) { return(menuHelpAbout = m); }

// Methods
	public void makeMenuBar () {
		boolean flag = QRGutils.isApplet();
		add(menuFile());
  		menuFile().add(menuFileNew());
  		if (!flag) {
  			menuFile().add(menuFileOpen());
			menuFile().addSeparator();
  			menuFile().add(menuFileSave());
  			menuFile().add(menuFileSaveAs());
  			if (true) {  			
  				menuFile().add(menuFileImport());
	  			menuFileImport().add(menuFileImportXML());
  				menuFileImport().add(menuFileImportVMF());
  			} // end if
  			menuFile().add(menuFileExport());
  			menuFileExport().add(menuFileExportHTML());
  			menuFileExport().addSeparator();
  			menuFileExport().add(menuFileExportJPG());
  			menuFileExport().add(menuFileExportTIF());
  			menuFileExport().add(menuFileExportBMP());
  			if (controller().userIsDeveloper()) {
  				menuFileExport().addSeparator();
  				menuFileExport().add(menuFileExportPNM());
  			} // endif
  		} // end if flag
		menuFile().addSeparator();
  		menuFile().add(menuFileClose());
  		menuFile().add(menuFileCloseAll());
		if (!flag) {
			menuFile().addSeparator();
  			menuFile().add(menuFilePrintPreview());
  			menuFile().add(menuFilePrint());
  		} // end if flag
		menuFile().addSeparator();
  		menuFile().add(menuFileExit());
		add(menuEdit());
		menuEdit().add(menuEditCut());
		menuEdit().add(menuEditCopy());
		menuEdit().add(menuEditPaste());
		menuEdit().addSeparator();
		menuEdit().add(menuEditSelectAll());
		menuEdit().add(menuEditDeSelectAll());
		menuEdit().addSeparator();
		menuEdit().add(menuEditAddToLibrary());
		menuEdit().add(menuEditAddGroupToLibrary());
//		menuEdit().add(menuEditGroup());
		if (!flag) {
			menuEdit().addSeparator();
			menuEdit().add(menuEditPreferences());
		} // end if flag
		add(menuView());
//		menuView().add(menuViewProblem());
		menuView().add(menuWindowModelOverview());
  		menuView().addSeparator();
		menuView().add(menuViewRulers());
/*
  		menuView().addSeparator();
		ButtonGroup mapsGroup = new ButtonGroup();
		mapsGroup.add(menuViewAll());
		mapsGroup.add(menuViewCausal());
		mapsGroup.add(menuViewSituation());
		mapsGroup.add(menuViewEvidence());
		mapsGroup.add(menuViewButJustify());
		menuView().add(menuViewAll());
		menuView().add(menuViewCausal());
		menuView().add(menuViewSituation());
		menuView().add(menuViewEvidence());
		menuView().add(menuViewButJustify());
*/
		add(menuWindow());
//		ButtonGroup tileGroup = new ButtonGroup();
//		tileGroup.add(menuViewCascade());
//		tileGroup.add(menuViewTile());
		menuWindow().add(menuViewCascade());
		menuWindow().add(menuViewTile());
  		menuWindow().addSeparator();
		menuWindow().add(menuWindowOntology());
  		menuWindow().addSeparator();
		menuWindow().add(menuWindowModels());
		add(menuHelp());
		menuHelp().add(menuHelpIndex());
		menuHelp().add(menuHelpKeys());
		menuHelp().add(menuGrammarCoach());
  		menuHelp().addSeparator();
		menuHelp().add(menuEMailCoach());
  		menuHelp().addSeparator();
		menuHelp().add(menuHelpAbout());
		
  /*
  JMenuItem menuFileOpenAssignment = new JMenuItem("Open Assignment");
  JMenuItem menuFileLoadOntology = new JMenuItem("Load Ontology");
  JMenuItem menuFileExportCML = new JMenuItem("Export to CML");
 */
	} // method makeMenubar

	public void updateWidgets () {
		boolean modelexists = controller().currentModel() != null;
		boolean selectedItems = (controller().selectedWindow() != null) && (! controller().selectedWindow().modelPane().selectedComponents().isEmpty());
		menuFile().setEnabled(true);
		menuFileNew().setEnabled(true);
		menuFileOpen().setEnabled(true);
		menuFileSave().setEnabled(modelexists);
		menuFileSaveAs().setEnabled(modelexists);
		menuFileExport().setEnabled(modelexists);
		menuFileClose().setEnabled(modelexists);
		menuFileCloseAll().setEnabled(modelexists);
		menuFilePrintPreview().setEnabled(modelexists);
		menuFilePrint().setEnabled(modelexists);
		menuFileExit().setEnabled(true);
		
		menuEditCopy().setEnabled(modelexists && selectedItems);
		menuEditCut().setEnabled(modelexists && selectedItems);
		menuEditPaste().setEnabled(modelexists && (controller().clipboard != null));
		menuEditSelectAll().setEnabled(modelexists && (!controller().currentModel().instances().isEmpty()));
		menuEditDeSelectAll().setEnabled(modelexists && selectedItems);
		menuEditAddToLibrary().setEnabled(modelexists && (((ModelFrame) controller().selectedWindow()).modelPane().selectedComponents().size() == 1));
		menuEditAddGroupToLibrary().setEnabled(modelexists && selectedItems);
		
		menuView().setEnabled(modelexists);
		menuWindowModelOverview().setEnabled(modelexists); 
		menuViewRulers().setEnabled(modelexists); 
		if (modelexists) menuViewRulers().setSelected(controller().currentModel().getBoolean("SHOWRULERS"));
		
		menuViewCascade().setEnabled(menuWindowModels().getItemCount() > 0); 
		menuViewTile().setEnabled(menuWindowModels().getItemCount() > 0); 
		menuWindowOntology().setEnabled(true); 
		menuWindowModels().setEnabled(menuWindowModels().getItemCount() > 0); 
		
		menuGrammarCoach().setEnabled(modelexists);
		
	} // method

	public MacClassroom controller () {
		MacClassroom result = (MacClassroom) VModel.controller();
		return(result);
	} // method

} // class VModelMenuBar