package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Window;
import java.io.IOException;
import java.lang.Cloneable;
import java.lang.Object;
import java.lang.String;
import java.net.URL;
import javax.swing.JFrame;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: HTMLbrowser.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: HTMLbrowser
* Purpose: Simple Browser Frame
* ----------------------------------------------------------------------------
* Notes:
* * Very simple to suit the task in VModel.
* * Need to add a toolbar with forward/backward
* -----------------------------------------------------------------------------
* </PRE> */
public class HTMLbrowser extends JFrame implements VModelConstants {
	// Constructors
	// -------------------------------------------------------------------------
	public HTMLbrowser () { 
		super();
		getContentPane().add(panel(), BorderLayout.CENTER);
	} // constructor
	
	public HTMLbrowser (String base, String page) { 
		this();
		gotoPage(base, page);
	} // constructor
	
	public HTMLbrowser (String page) { 
		this(QRGutils.QRGroot() + HELPPATH, page); 
	} // constructor
	
	// Properties & Accessors 
	// -------------------------------------------------------------------------
	protected HTMLpanel panel = null;
	public HTMLpanel panel () {
		if (panel == null) panel = new HTMLpanel();
		return(panel);
	} // reader	
	
	// Methods
	// -------------------------------------------------------------------------
	public void gotoPage (String base, String page) {
		panel().gotoPage(base, page);
		setVisible(true);
		toFront();
	} // method

	public void setPage (String address) {
		panel().setPage(address);
	} // method

	public void setPage (URL address) throws IOException {
		try { 
			panel().setPage(address);
		} catch(IOException e) {
//			e.printStackTrace();
			throw(e);
		} // end try - catch
	} // setPage

	public void setBase (String address) {
		panel().setBase(address);
	} // setBase

	public void setBase (URL address) {
		panel().setBase(address);
	} // setBase
	
	public static HTMLbrowser popupBrowser = null;
	public static HTMLbrowser popupBrowser(String title, String url, Dimension size) {
		if (popupBrowser == null) popupBrowser = new HTMLbrowser(url);
		popupBrowser.setTitle(title);
		popupBrowser.setSize(size);
		popupBrowser.setVisible(true);
		return(popupBrowser);
	} // method

} // class
    
// ---------------------------------------------------------------------------
// End of File: HTMLbrowser.java              (c) 2001 Northwestern University
