package edu.qrg.vmodel.controllers.macclassroom;

// Sun Java 1.3.1 -Sourcepath QRG/VModel/v4/code/src
// -----------------------------------------------------------------------------
// File name: VModelPreferencesDialog.java
//    System: VModel
//   Version: 4.0
//    Author: Leo C. Ureel II
//   Created: March 7, 1999 18:52:54
//   Purpose: VModel student login facility.
// -----------------------------------------------------------------------------
// (c)2001 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
// -----------------------------------------------------------------------------
//  Modified: Thursday, June 21, 2001 at 12:10:52 by ureel
// -----------------------------------------------------------------------------
import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.util.*;
import javax.swing.*;
import java.io.*;
import java.lang.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.colorchooser.*;

// -----------------------------------------------------------------------------
// Notes:
// * Should the file IO routines be included in this class?
// -----------------------------------------------------------------------------

// -----------------------------------------------------------------------------
// Class: VModelPreferencesDialog
// Description: VModel student login facility.  
// -----------------------------------------------------------------------------
public class VModelPreferencesDialog extends JDialog implements VModelConstants {
	// InnerClasses and Interfaces
	// --------------------------------------------------------------------------

	// Properties and Accessors
	// --------------------------------------------------------------------------
	public Controller gui () { return((Controller) VModel.controller()); }

	protected InfoPane infoPane = null;
	public InfoPane infoPane() { return(infoPane); } // reader infoPane
	public InfoPane infoPane(InfoPane l) { return(infoPane = l); }
	public InfoPane infoPane(VModelPreferencesDialog l) { 
		validate();
		if (infoPane() == null) infoPane(new InfoPane(l));
		else infoPane().setVisible(true);
		return(infoPane()); 
	} // method InfoPane
	
	JCheckBox SYSTEM_LOOK = new JCheckBox("Use System Look & Feel");
	JCheckBox FRAME_CONTAINMENT = new JCheckBox("FRAME-CONTAINMENT");
	JCheckBox SHOW_MODEL_LIBRARY = new JCheckBox("Show Model Library");
	JCheckBox MAXIMIZE_NEW_MODELS = new JCheckBox("Maximize New Models");
	JCheckBox ALLOW_EMPTY_DESKTOP = new JCheckBox("Allow Empty Desktop");
	JCheckBox EXPANDED_ONTOLOGY_TOOLBAR = new JCheckBox("EXPANDED-ONTOLOGY-TOOLBAR");
//	JCheckBox TOOLBARLABELS = new JCheckBox("TOOLBARLABELS");
//	JCheckBox MAXIMIZENEWMODELS = new JCheckBox("MAXIMIZENEWMODELS");
//	JCheckBox ALLOWEMPTYDESKTOP = new JCheckBox("ALLOWEMPTYDESKTOP");
		
	// Methods.
	// --------------------------------------------------------------------------
    public void show () {
    	SYSTEM_LOOK.setSelected(VModel.preferences().getBoolean("SYSTEMLOOK"));
    	FRAME_CONTAINMENT.setSelected(VModel.preferences().getBoolean("FRAME-CONTAINMENT"));
    	SHOW_MODEL_LIBRARY.setSelected(VModel.preferences().getBoolean("SHOW-MODEL-LIBRARY"));
    	MAXIMIZE_NEW_MODELS.setSelected(VModel.preferences().getBoolean("MAXIMIZE-NEW-MODELS"));
    	ALLOW_EMPTY_DESKTOP.setSelected(VModel.preferences().getBoolean("ALLOW-EMPTY-DESKTOP"));
    	EXPANDED_ONTOLOGY_TOOLBAR.setSelected(VModel.preferences().getBoolean("EXPANDED-ONTOLOGY-TOOLBAR"));
    	//TOOLBARLABELS.setSelected(VModel.preferences().getBoolean("TOOLBARLABELS"));
    	//MAXIMIZENEWMODELS.setSelected(VModel.preferences().getBoolean("MAXIMIZENEWMODELS"));
    	//ALLOWEMPTYDESKTOP.setSelected(VModel.preferences().getBoolean("ALLOWEMPTYDESKTOP"));
    	infoPane(this);
    	super.show();
    } // method show

	// Inner Classes
	// --------------------------------------------------------------------------
    public class InfoPane extends JPanel implements ActionListener {	
    	VModelPreferencesDialog parent = null;
    	String iconPath = IMAGEPATH;
		ImageIcon image = null;
    	JLabel imageLabel = null, label = null;
    	JPanel textPanel = null, textPanel1 = null, textPanel2 = null, textPanel3 = null, buttonPanel = null;
    	JButton back = null, ok = null, cancel = null;
    	JColorChooser clrChooser = null;
    	
    	public void setVisible (boolean b) {
    		if (b) parent.getRootPane().setDefaultButton(ok);
    		super.setVisible(b);
    		validate();
    	} // method setVisible
    	
    	public void actionPerformed (ActionEvent e) {
	    	setVisible(false);
    		if (e.getSource() == ok) {
		    	VModel.preferences().set("SYSTEMLOOK",SYSTEM_LOOK.isSelected());
//		    	VModel.preferences().set("FRAME-CONTAINMENT",FRAME_CONTAINMENT.isSelected());
		    	VModel.preferences().set("SHOW-MODEL-LIBRARY",SHOW_MODEL_LIBRARY.isSelected());
//				gui().showModelOntology(SHOW_MODEL_LIBRARY.isSelected());
//				gui().menuWindowOntology().setState(SHOW_MODEL_LIBRARY.isSelected());    	
				VModel.preferences().set("MAXIMIZE-NEW-MODELS",MAXIMIZE_NEW_MODELS.isSelected());
		    	VModel.preferences().set("ALLOW-EMPTY-DESKTOP",ALLOW_EMPTY_DESKTOP.isSelected());
//		    	VModel.preferences().set("EXPANDED-ONTOLOGY-TOOLBAR",EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
//				VModelPeerOntology.toolbarTopOntologies().setVisible(!EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
//		    	VModelPeerOntology.toolbarOntologies().setVisible(EXPANDED_ONTOLOGY_TOOLBAR.isSelected());
		    	//VModel.preferences().set("TOOLBARLABELS",TOOLBARLABELS.isSelected());
		    	//VModel.preferences().set("MAXIMIZENEWMODELS",MAXIMIZENEWMODELS.isSelected());
		    	//VModel.preferences().set("ALLOWEMPTYDESKTOP",ALLOWEMPTYDESKTOP.isSelected());
		    	VModel.preferences().save();
				parent.setVisible(false);
				if (VModel.preferences().getBoolean("SYSTEMLOOK")) {
					try {
						UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
					} catch(Exception e2) { QRGutils.debugStackTrace(e2); }
				} // end if
    		} else if (e.getSource() == cancel) parent.setVisible(false); //System.exit(-1);
    	} // method actionPerformed
    	
    	public InfoPane (VModelPreferencesDialog parent) {
    		super(new BorderLayout());
    		this.parent = parent;
    		setOpaque(false);
    		textPanel = new JPanel(new GridLayout(8, 1));
    		textPanel.add(SYSTEM_LOOK);
//    		textPanel.add(FRAME_CONTAINMENT);
    		textPanel.add(SHOW_MODEL_LIBRARY);
    		textPanel.add(MAXIMIZE_NEW_MODELS);
    		textPanel.add(ALLOW_EMPTY_DESKTOP);
//    		textPanel.add(EXPANDED_ONTOLOGY_TOOLBAR);
 //   		textPanel.add(TOOLBARLABELS);
 //   		textPanel.add(MAXIMIZENEWMODELS);
 //   		textPanel.add(ALLOWEMPTYDESKTOP);
    		this.add(textPanel, BorderLayout.NORTH);

    		buttonPanel = new JPanel(new GridLayout(1,2));
    		this.add(buttonPanel, BorderLayout.SOUTH);
    		
    		ok = new JButton("Ok");
    		ok.addActionListener(this);
    		buttonPanel.add(ok);
    		cancel = new JButton("Cancel");
    		cancel.addActionListener(this);
    		buttonPanel.add(cancel);
    		buttonPanel.setVisible(true);
    		
    		parent.getContentPane().add(this, BorderLayout.CENTER);
    		setVisible(true);
    	} // constructor InfoPane
    } // innerclass InfoPane

	// Constructor
	// --------------------------------------------------------------------------
	public VModelPreferencesDialog() {
		super((Frame) null, "VModel Preferences");
    	setSize(430,375);
    	setModal(true);
		infoPane(this);
	} // constructor VModelPreferencesDialog

} // class VModelPreferencesDialog

// -----------------------------------------------------------------------------
// End of File: VModelPreferencesDialog.java    (c) 2002 Northwestern University
