package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.vmodel.controllers.common.*;
import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
//import Definition;
import java.awt.*;
import java.io.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*; //EtchedBorder
import java.util.*;
import javax.swing.tree.*;
import java.awt.image.*;
import java.beans.*;
import java.awt.event.*;
import java.net.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: ModelPane.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: ModelPane
* Purpose: Displays a model.
* ----------------------------------------------------------------------------
* </PRE> */
public class ModelPane extends QRGpanel implements QRGconstants, VModelConstants {
	// Constructors
	//-------------------------------------------------------------------------
	public ModelPane () {
		setLayout(new BorderLayout());
		setOpaque(false);
		add(scrollpane(), BorderLayout.CENTER);
	} // default constructor

	public ModelPane (Model m) {
		this();
		reference(m.id());
		model(m);
	} // default constructor

	public String updateContextHelp() {
		Model model = model();
		int mode = model.getInt(MODE);
		String coachImage = "";
		String text = "<HTML><HEAD><TITLE>Ask Doc V.</TITLE></HEAD><BODY>";
		text += controller().updateContextHelp();
		text+="</BODY></HTML>";
//		controller().coachAskPanel().viewPane().setContentType("text/html");
//		controller().coachAskPanel().viewPane().setText(text);
		controller().coachAskPanel().setText(text);
		return(text);
	} // method

	// InnerClasses
	// -----------------------------------------------------------------------
		public static int clickX = 0;
		public static int clickY = 0;
		public static int dragX = 0;
		public static int dragY = 0;
		public boolean dragging = false;
		
	protected PaneMouseMotionAdapter paneMouseAdapter = null;
	public PaneMouseMotionAdapter paneMouseAdapter () { 
		if (paneMouseAdapter == null) paneMouseAdapter = new PaneMouseMotionAdapter();
		return(paneMouseAdapter); 
	} // reader
		
	public class PaneMouseMotionAdapter implements MouseListener, MouseMotionListener {
		public void mouseEntered(MouseEvent e) {
		} // method mouseEntered

		public void mouseExited(MouseEvent e) {
		} // method mouseExited

		public void mouseClicked(MouseEvent e) {
		} // method MouseClicked

		public void mouseReleased(MouseEvent e) {
			if (dragging) {
				Rectangle dragRec = dragRectangle();
				Component [ ] components = componentpane().getComponents();
				Component candidate = null;
				for(int i = 0; i < components.length; i++) {
					candidate = components[ i ];
					if (dragRec.intersects(new Rectangle(
														candidate.getLocation().x,
													 	candidate.getLocation().y,
													 	candidate.getSize().width,
													 	candidate.getSize().height)))
						select((PeerElement) candidate, true);
				} // method
				dragging = false;
				glasspane().repaint();
				updateContextHelp();
				controller().updateWidgets();
			} // end if
			e.consume();
		} // method mouseReleased

		public void mousePressed(MouseEvent e) {
			getParent().requestFocus();
			clickX = dragX = e.getX();
			clickY = dragY = e.getY();
			if (! (componentpane().getComponentAt(clickX, clickY) instanceof PeerElement.Interface)) {
				if (controller().selectedDefinition() != null) {
					controller().addDefinition(model(), controller().selectedDefinition(), clickX, clickY, !e.isControlDown(), true);
					viewpane().repaint();
				} else {
					dragging = true;
					if (! e.isShiftDown()) deselectAll();
					if (model().getInt("MODE") < 2 ) model().checkModel(Model.CHECKDESIGN, true);
					else {
						// ? why so many checks here?
						model().checkModel(Model.CHECKALL, true);
						model().checkModel(Model.CHECKABIGUITY, false);
						model().checkModel(Model.CHECKSTATE, false);
						model().checkModel(Model.CHECKPREDICTIONSVALID, false);
					} // end if
					glasspane().repaint();
					updateContextHelp();
					controller().updateWidgets();
				} // end if else
				e.consume();
			} // end if
		} // method mouseClicked

		public void mouseMoved(MouseEvent e) {
		} // method mouseMoved

		public void mouseDragged(MouseEvent e) {
			if (dragging) {
				dragX = e.getX();
				dragY = e.getY();
				Rectangle dragRec = dragRectangle();
				scrollpane().getViewport().scrollRectToVisible(dragRectangle());
				glasspane().repaint();
				e.consume();
			} // end if
		} // method mouseDragged
	} // innerclass PaneMouseMotionAdapter
	
		public void stretch(Graphics g) {
			int x1,x2,y1,y2;
			x1 = (int) Math.min(clickX,dragX);
			x2 = (int) Math.max(clickX,dragX);
			y1 = (int) Math.min(clickY,dragY);
			y2 = (int) Math.max(clickY,dragY);
			g.setColor(Color.red);
			boolean o = isOpaque();
			if (!o) setOpaque(true);
			g.setXORMode(getBackground());
			g.drawRect(x1, y1, x2 - x1, y2 - y1);
			setOpaque(o);
		} // method stretch
		
		public Rectangle dragRectangle() {
			int x1,x2,y1,y2;
			x1 = (int) Math.min(clickX,dragX);
			x2 = (int) Math.max(clickX,dragX);
			y1 = (int) Math.min(clickY,dragY);
			y2 = (int) Math.max(clickY,dragY);
			return(new Rectangle(x1, y1, x2 - x1, y2 - y1));
		} // method dragRectangle
		
	protected InstanceMouseMotionAdapter peerMouseAdapter = null;
	public InstanceMouseMotionAdapter peerMouseAdapter () { 
		if (peerMouseAdapter == null) peerMouseAdapter = new InstanceMouseMotionAdapter();
		return(peerMouseAdapter); 
	} // reader
		
	public class InstanceMouseMotionAdapter implements MouseListener, MouseMotionListener {
		public void mouseEntered(MouseEvent e) {
		} // method mouseEntered

		public void mouseExited(MouseEvent e) {
		} // method mouseExited

		public void mouseClicked(MouseEvent e) {
			PeerElement component = (PeerElement) e.getSource();
			if(component.active() && 
					(! (component.instance().typep(RELATIONSHIP))) && 
					(e.getClickCount() == 2)) {
				component.editLabel(true);
			} // end if
		} // method MouseClicked

		protected boolean dragged = false;
		public boolean dragged () { return(dragged); }
		public boolean dragged (boolean b) { return(dragged = b); }

		public void mouseReleased(MouseEvent e) {
		
			if(dragged()) {
				int x = e.getX();
				int y = e.getY();
				int dx = x - clickX;
				int dy = y - clickY;
				PeerElement candidate = null;
				PeerElement target = null;
				int oldx, newx, oldy, newy;
				Vector selectionVector = new Vector();
				boolean dropflag = false;
				if (selectedComponents().size() == 1) {
					candidate = (PeerElement) selectedComponents().elementAt(0);
					for(Enumeration instances = model().instances().elements(); instances.hasMoreElements();) {
						target = (PeerElement) ((Instance) instances.nextElement()).peer();
						if ((candidate != target) && target.getBounds().intersects(candidate.getBounds()) &&
								((candidate.typep(ATTRIBUTE) && target.typep(ATTRIBUTE) && target.getBoolean("VARIABLE")) || 
								(candidate.typep(ATTRIBUTE)  && target.typep(ENTITY) && candidate.instance().parentInstances().isEmpty())// ||
								//(candidate.typep(ENTITY) && target.typep(PROCESS)) 
								)) {
							dropflag = true;
							break;
						} // end if
					} // end for
				} // end if
				if (dropflag) {
					oldx = candidate.getInt("X-OFFSET");
					oldy = candidate.getInt("Y-OFFSET");
					candidate.setPosition(oldx, oldy);
					int x1 = candidate.getLocation().x;
					int y1 = candidate.getLocation().y;
					int x2 = target.getLocation().x;
					int y2 = target.getLocation().y;
					int orientation = 0;
					if (Math.abs(y2 - y1) > Math.abs(x2 - x1)) {
						if (y2 > y1) orientation = SOUTH2NORTH;
						else orientation = NORTH2SOUTH;
					} else {
						if (x2 > x1) orientation = EAST2WEST;
						else orientation = WEST2EAST;
					} // end if magnitude
					Instance bar = ((MacClassroom) controller()).connect(model(), BaseOntology.hasAttribute, target.instance(), candidate.instance(), (int) Math.floor(x + ((x1 - x2) / 2)), (int) Math.floor(y + ((y1 - y2) / 2)), orientation, true);
					((PeerElement) bar.peer()).hidden(true);
					((PeerElement) bar.peer()).setVisible(false);
				} else {
					for (Enumeration enum = selectedComponents().elements() ; enum.hasMoreElements() ;) {
						candidate = (PeerElement) enum.nextElement();
						oldx = candidate.getInt("X-OFFSET");
						oldy = candidate.getInt("Y-OFFSET");
						newx = candidate.getLocation().x + dx;
						newy = candidate.getLocation().y + dy;
						selectionVector.addElement(candidate);
						selectionVector.addElement(new Integer(oldx));
						selectionVector.addElement(new Integer(oldy));
						selectionVector.addElement(new Integer(newx));
						selectionVector.addElement(new Integer(newy));
						candidate.movePeer2(dx, dy);
					} // end for
				} // end if
				doAction(Action.MOVE, selectionVector);
				dragged(false);
			} // end if
			reView();
//			glasspane().repaint();
			e.consume();
		} // method mouseReleased

		public void mousePressed(MouseEvent e) {
			getParent().requestFocus();
			PeerElement component = (PeerElement) e.getSource();
			clickX = e.getX();
			clickY = e.getY();
			if(component.active()) {
				if (!QRGutils.isRightClick(e)) {
					if (e.isControlDown()) 
						select(component, ! component.selected());
					else if (e.isShiftDown()) 
						select(component, true);
					else if (! component.selected()) {
						if ((selectedComponents().size() == 1) && 
								(controller().selectedDefinition() != null) &&
								(controller().selectedDefinition().typep(RELATIONSHIP))) {
							PeerElement source = (PeerElement) selectedComponents().elementAt(0);
							int cx = component.getLocation().x;
							int cy = component.getLocation().y;
							int sx = source.getLocation().x;
							int sy = source.getLocation().y;
							int x = (sx + cx) / 2; 
							int y = (sy + cy) / 2;
							int orientation = WEST2EAST;

							if (Math.abs(sy - cy) > Math.abs(sx - cx)) {
								if (sy > cy) orientation = SOUTH2NORTH;
								else orientation = NORTH2SOUTH;
							} else {
								if (sx > cx) orientation = EAST2WEST;
								else orientation = WEST2EAST;
							} // end if magnitude

							Instance relationship = (Instance) controller().connect(model(), (Definition) controller().selectedDefinition(), source.instance(), component.instance(), x, y, orientation, true);
							
//							selectOne((PeerElement) relationship.peer());
							deselectAll();
//							selectOne((PeerElement) relationship.peer());
							
						} else selectOne(component);
					} // end if
				} else {
					deselectAll();
					component.showPopupMenu(clickX, clickY);
				} // end if rightClick
//				glasspane().repaint();
				component.repaint();
				updateContextHelp();
				controller().updateWidgets();
			} // if active
			e.consume();
		} // method mouseClicked

		public void mouseMoved(MouseEvent e) {
		} // method mouseMoved

		public void mouseDragged(MouseEvent e) {
			PeerElement component = (PeerElement) e.getSource();
			
			if (component.active() && component.selected() && (! (model().getInt(MODE) == 2))) {
			
				int x = e.getX();
				int y = e.getY();
				int dx = x - clickX;
				int dy = y - clickY;
				
				dragged(true);
				
				PeerElement candidate = null;
				for (Enumeration enum = selectedComponents().elements() ; enum.hasMoreElements() ;) {
					candidate = (PeerElement) enum.nextElement();
					candidate.movePeer(dx, dy);
				} // end for
				
				x = component.getLocation().x;
				y = component.getLocation().y;
				Point vp = new Point(scrollpane().getViewport().getViewPosition());
				if (x < vp.x) vp.x = x;
				if (y < vp.y) vp.y = y;
				if (vp.x < 0) vp.x = 0;
				if (vp.y < 0) vp.y = 0;
				
				x += component.getSize().width;
				y += component.getSize().height;
				Dimension vs = scrollpane.getViewport().getSize();
				if (x > vp.x + vs.width) vp.x = vp.x + x - (vp.x + vs.width);
				if (y > vp.y + vs.height) vp.y = vp.y + y - (vp.y + vs.height);
				if (vp.x > componentpane().getSize().width - vs.width) 
					vp.x = scrollpane().getViewport().getViewPosition().x;
				if (vp.y > componentpane().getSize().height - vs.height) 
					vp.y = scrollpane().getViewport().getViewPosition().y;

				scrollpane.getViewport().setViewPosition(vp);
				scrollpane().doLayout();
				scrollpane().invalidate();
//				componentpane().repaint();
//				drawpane().repaint();
				viewpane().repaint();
			} // if active && selected
			e.consume();
		} // method mouseDragged
	} // innerclass InstanceMouseMotionAdapter
	
	protected MarkerMouseMotionAdapter markerMouseAdapter = null;
	public MarkerMouseMotionAdapter markerMouseAdapter () { 
		if (markerMouseAdapter == null) markerMouseAdapter = new MarkerMouseMotionAdapter();
		return(markerMouseAdapter); 
	} // reader
		
	public class MarkerMouseMotionAdapter implements MouseListener, MouseMotionListener {
		public void mouseEntered(MouseEvent e) {
		} // method mouseEntered

		public void mouseExited(MouseEvent e) {
		} // method mouseExited

		public void mouseClicked(MouseEvent e) {
//			glasspane().repaint();
		} // method MouseClicked

		protected boolean dragged = false;
		public boolean dragged () { return(dragged); }
		public boolean dragged (boolean b) { return(dragged = b); }

		public void mouseReleased(MouseEvent e) {
			if(dragged()) {
				PeerElement.Marker marker = (PeerElement.Marker) e.getSource();
				PeerElement component = marker.peerElement;
				Instance relationship = component.instance();
				int x = e.getX();
				int y = e.getY();
				Point p = SwingUtilities.convertPoint(marker, x, y, componentpane());
				glasspane().remove(marker);
				PeerElement target = null;
				Vector connectionVector = new Vector();
		Component [ ] components = componentpane().getComponents();
		for(int i = 0; i < components.length; i++) {
			if (components[i].getBounds().contains(p)) {
				target = (PeerElement) components[i];
				break;
			} // end if
		} // end for
				if ((target != null) && (target != component)) {
					if (marker == component.independentMarker()) {
						controller().connect(model, component.instance(), target.instance(), model().findInstance(component.output()));
						connectionVector.addElement(relationship);
						connectionVector.addElement(target.instance());
						connectionVector.addElement(model().findInstance(relationship.output()));
						connectionVector.addElement("INPUT");
						doAction(Action.CONNECT, connectionVector);
					} else {
						controller().connect(model, component.instance(), model.findInstance(component.input()), target.instance());
						connectionVector.addElement(relationship);
						connectionVector.addElement(model().findInstance(relationship.input()));
						connectionVector.addElement(target.instance());
						connectionVector.addElement("OUTPUT");
						doAction(Action.CONNECT, connectionVector);
					} // end if else
				} // end if
				component.addMarkers();
				component.scrollRectToVisible(component.getBounds());
				dragged(false);
			} // end if
			
			reView();
//			glasspane().repaint();
			e.consume();
		} // method mouseReleased

		public void mousePressed(MouseEvent e) {
			PeerElement.Marker marker = (PeerElement.Marker) e.getSource();
			PeerElement component = marker.peerElement;
			clickX = e.getX();
			clickY = e.getY();
			if(component.active()) {
				deselectAll();
				selectOne(component);
				Point newloc = SwingUtilities.convertPoint(marker.getParent(), marker.getLocation(), glasspane()); 
				marker.getParent().remove(marker);
				glasspane().add(marker);
				marker.setLocation(newloc);
				updateContextHelp();
				controller().updateWidgets();
				component.repaint();
//				glasspane().repaint();
			} // if active
			e.consume();
		} // method mouseClicked

		public void mouseMoved(MouseEvent e) {
		} // method mouseMoved

		public void mouseDragged(MouseEvent e) {
			PeerElement.Marker marker = (PeerElement.Marker) e.getSource();
			PeerElement component = marker.peerElement;
			
			if (component.active()) {
			
				int x = e.getX();
				int y = e.getY();
				int dx = x - clickX;
				int dy = y - clickY;
				
				dragged(true);
				
				marker.setLocation(marker.getLocation().x + dx,
										  marker.getLocation().y + dy);
				
				x = marker.getLocation().x;
				y = marker.getLocation().y;
				Point vp = new Point(scrollpane().getViewport().getViewPosition());
				if (x < vp.x) vp.x = x;
				if (y < vp.y) vp.y = y;
				if (vp.x < 0) vp.x = 0;
				if (vp.y < 0) vp.y = 0;
				
				x += component.getSize().width;
				y += component.getSize().height;
				Dimension vs = scrollpane.getViewport().getSize();
				if (x > vp.x + vs.width) vp.x = vp.x + x - (vp.x + vs.width);
				if (y > vp.y + vs.height) vp.y = vp.y + y - (vp.y + vs.height);
				if (vp.x > componentpane().getSize().width - vs.width) 
					vp.x = scrollpane().getViewport().getViewPosition().x;
				if (vp.y > componentpane().getSize().height - vs.height) 
					vp.y = scrollpane().getViewport().getViewPosition().y;

				scrollpane.getViewport().setViewPosition(vp);
				scrollpane().doLayout();
				scrollpane().invalidate();

//				drawpane().repaint();
				viewpane().repaint();
			} // if active && selected
			e.consume();
		} // method mouseDragged
	} // innerclass MarkerMouseMotionAdapter
	
	protected Vector selectedComponents = null;
	public Vector selectedComponents () { 
		if (selectedComponents == null) selectedComponents = new Vector();
		return(selectedComponents);
	} // reader
	
	public void deselectAll () {
		// Why does the for loop occassionally fail to remove all elements?
		while(selectedComponents().size() > 0)
			for (Enumeration e = selectedComponents().elements() ; e.hasMoreElements() ;) 
				select((PeerElement) e.nextElement(), false);
//		componentpane().repaint();
	} // method
	
	public void selectAll () {
		deselectAll();
		Component [ ] components = componentpane().getComponents();
		for(int i = 0; i < components.length; i++)
			select((PeerElement) components[ i ], true);
//		componentpane().repaint();
	} // method
	
	public void selectOne (PeerElement e) {
		deselectAll();
		select(e, true);
	} // method

	public void select (PeerElement e, boolean b) {
		if (e.selected() != b) {
			e.selected(b);
			if (b) {
				selectedComponents().addElement(e);
				componentpane().remove(e);
				glasspane().add(e);
				e.addMouseListener(peerMouseAdapter());
				e.addMouseMotionListener(peerMouseAdapter());
			} else {
				selectedComponents().removeElement(e);
				e.removeMouseListener(peerMouseAdapter());
				e.removeMouseMotionListener(peerMouseAdapter());
				glasspane().remove(e);
				componentpane().add(e);
			} // end if
			e.repaint();
		} // end if
	} // method
	
	public JScrollBar hbar () { return(scrollpane().getHorizontalScrollBar()); }
	public JScrollBar vbar () { return(scrollpane().getVerticalScrollBar()); }
	
	public void reView () {
	
		Object[] components = QRGutils.vectorToArray(model().instances());
		
		PeerElement jif = null;
		
		Point fpos = null;
		Dimension fsiz = null;
		double fsizW = 0.0;
		double fsizH = 0.0;
		
		Dimension vsiz = scrollpane().getViewport().getSize();
		double vsizW = vsiz.width;
		double vsizH = vsiz.height;
		
		Point vp = scrollpane().getViewport().getViewPosition();
		int minX = vp.x;
		int minY = vp.y;
		int maxX = (int) vsizW;
		int maxY = (int) vsizH;
		
		for(int i = 0; i < components.length; i++) {
			Object quux = components[i];
			jif = (PeerElement) ((Instance) quux).peer();
			if (jif.isVisible()) {
				fpos = jif.getLocation();
				fsiz = jif.getSize();
				fsizW = fsiz.width;
				fsizH = fsiz.height;
				minX = (int) Math.min(minX, fpos.x);
				minY = (int) Math.min(minY, fpos.y);
				maxX = (int) Math.max(maxX, fpos.x + fsizW);
				maxY = (int) Math.max(maxY, fpos.y + fsizH);
			} // end if
		} // end for
		
		int w = maxX - minX;
		int h = maxY - minY;

		hrulepane().setSize(w, 10);
		hrulepane().setPreferredSize(hrulepane().getSize());
		vrulepane().setSize(10, h);
		vrulepane().setPreferredSize(vrulepane().getSize());
		viewpane().setSize(w, h);
		viewpane().setPreferredSize(viewpane().getSize());
		viewpane().invalidate();
		
		for(int i = 0; i < components.length; i++) {
			jif = (PeerElement) ((Instance) components[i]).peer();
			fpos = jif.getLocation();
			jif.setPosition(fpos.x - minX, fpos.y);
		} // end for
		vp.translate(- minX, 0); 

		for(int i = 0; i < components.length; i++) {
			jif = (PeerElement) ((Instance) components[i]).peer();
			fpos = jif.getLocation();
			jif.setPosition(fpos.x, fpos.y - minY);
		} // end for
		vp.translate(0, - minY); 

		scrollpane().getViewport().setViewPosition(vp);
		scrollpane().getViewport().setAutoscrolls(true);

		viewpane().setAutoscrolls(true);
		componentpane().setAutoscrolls(true);
		scrollpane().doLayout();
		scrollpane().invalidate();

		componentpane().repaint();
		repaint();
	} // method

	// InnerClass InstanceMouseMotionAdapter
	// -----------------------------------------------------------------------
	public String reference = null;
	public String reference () { return(reference); }
	public String reference (String s) { return(reference = s); }
	
	protected Model model = null;
	public Model model () { return(model); }
	public Model model (Model m) {
		model = m;
		Instance mumble = null; 
		String grumble = null;
		Enumeration enum = null;
		PeerElement peer = null;
		for (enum = model.instances().elements() ; enum.hasMoreElements() ;) {
			mumble =  (Instance) enum.nextElement();
			if (mumble.peer() == null) {
				peer = new PeerElement(model, mumble);
				mumble.peer(peer);
			} // end if
			if (peer == null) peer = (PeerElement) mumble.peer();
			addVisibleElement(peer, peer.getInt("XOFFSET"), peer.getInt("YOFFSET"));
		} // end for
		return(model); 
	} // method
	
	public void addVisibleElement (PeerElement p, int x, int y) {
			componentpane().add((JComponent) p);
			p.setLocation(nextlocation(p));
			if (p.getInt("X-RELATIVE") != 0) {
				p.setLocation(x + p.getInt("X-RELATIVE"), y + p.getInt("Y-RELATIVE"));
			} // end if
			int newx = p.getLocation().x;
			int newy = p.getLocation().y;
	} // method

	protected int nextlocationx = -180;
	protected int nextlocationy = 10;
	public Point nextlocation(PeerElement element) {
		Point result = null;
		if ((element.get("X-OFFSET") != null) && 
			  (element.get("Y-OFFSET") != null)) {
			result = new Point(element.getInt("X-OFFSET"), element.getInt("Y-OFFSET"));
		} else {
			nextlocationx += 200;
			if (nextlocationx > PAGE_WIDTH) {
				nextlocationx = 10;
				nextlocationy += 50;
				if (nextlocationy > PAGE_HEIGHT) {
					nextlocationx = 10;
					nextlocationy = 10;
				} // end if
			} // end if
			element.set("X-OFFSET", nextlocationx);
			element.set("Y-OFFSET", nextlocationy);
			result = new Point(nextlocationx, nextlocationy);
		} // end if
		return(result);
	} // method

	protected double scale = 1.0;
	public double scale () { return(scale); }
	public double scale (double d) {
		int px = (int) Math.floor(d * (scrollpane().getViewport().getViewPosition().x / scale)); 
		int py = (int) Math.floor(d * (scrollpane().getViewport().getViewPosition().y / scale)); 
		scale = d;
		model().set("SCALE", d);
		int width = scrollpane().getViewport().getWidth();
		int height = scrollpane().getViewport().getHeight();
		int curwidth, curheight;
		Object[] components = QRGutils.vectorToArray(model().instances());
		PeerElement cur = null;
		curwidth = curheight = 0;
		for (int i = 0; i < components.length; i ++) {
			cur = (PeerElement) ((Instance) components[i]).peer();
			cur.scale(scale);
			curwidth = cur.getLocation().x + cur.getSize().width;
			curheight = cur.getLocation().y + cur.getSize().height;
			if (curwidth > width) width = curwidth;
			if (curheight > height) height = curheight;
		} // end for
		viewpane().setSize(width, height);
		viewpane().setPreferredSize(viewpane().getSize());
		scrollpane().doLayout();
		scrollpane().invalidate();
		scrollpane().getViewport().setViewPosition(new Point(px, py));
		repaint();
		return(scale); 
	} // writer

	protected int goggles = 0;
	public int goggles () { return(goggles); }
	public int goggles (int i) { return(goggles = i); }

//	protected boolean showRulers = false;
	public boolean showRulers () { return((model() != null) && model().getBoolean("SHOWRULERS")); }
	public boolean showRulers (boolean b) {
		if (b) {
			scrollpane().setColumnHeaderView(hrulepane());
			scrollpane().setRowHeaderView(vrulepane());
		} else {
			scrollpane().setColumnHeader(null);
			scrollpane().setRowHeader(null);
		} // end if
		model().set("SHOWRULERS", b);
		reView();
		return(b); 
	} // writer

	protected int hRuleIncrement = 10;
	public int hRuleIncrement () { return(hRuleIncrement); }
	public int hRuleIncrement (int i) { return(hRuleIncrement = i); }

	protected int vRuleIncrement = 10;
	public int vRuleIncrement () { return(vRuleIncrement); }
	public int vRuleIncrement (int i) { return(vRuleIncrement = i); }

	protected boolean showPageGuides = true;
	public boolean showPageGuides () { return(showPageGuides); }
	public boolean showPageGuides (boolean b) { return(showPageGuides = b); }

	protected Color pageGuideColor = LIGHTYELLOW;
	public Color pageGuideColor () { return(pageGuideColor); }
	public Color pageGuideColor (Color c) { return(pageGuideColor = c); }

	protected JScrollPane scrollpane = null;
	public JScrollPane scrollpane () {
		if (scrollpane == null) {
			scrollpane = new JScrollPane(viewpane());
			if (showRulers()) {
				scrollpane.setColumnHeaderView(hrulepane());
				scrollpane.setRowHeaderView(vrulepane());
			} // end if
			scrollpane.setOpaque(false);
			viewpane.setOpaque(true);
		} // end if
		return(scrollpane);
	} // reader

	protected QRGpanel viewpane = null;
	public QRGpanel viewpane () {
		if (viewpane == null) {
			viewpane = new QRGpanel();
			viewpane.setOpaque(true);
			viewpane.addComponentListener(new ComponentAdapter () {
					public void componentResized(ComponentEvent e) {
						super.componentResized(e);
						layeredpane().setSize(viewpane().getSize());
						componentpane().setSize(viewpane().getSize());
						pageguidepane().setSize(viewpane().getSize());
						drawpane().setSize(viewpane().getSize());
						glasspane().setSize(viewpane().getSize());
					} // method
				}); // ComponentAdapter
			viewpane.add(layeredpane(), BorderLayout.CENTER);
		} // end if
		return(viewpane);
	} // reader

	protected QRGpanel glasspane = null;
	public QRGpanel glasspane () {
		if (glasspane == null) {
			glasspane = new QRGpanel() {
					public void paint (Graphics g) {
						super.paint(g);
						if (dragging) stretch(g);
					} // method
				}; // viewpane
			glasspane.setLayout(null);
			glasspane.setOpaque(false);
		} // end if
		return(glasspane);
	} // reader

	protected JLayeredPane layeredpane = null;
	public JLayeredPane layeredpane () {
		if (layeredpane == null) {
			layeredpane = new JLayeredPane();
			layeredpane.add(pageguidepane(), new Integer(20));
			layeredpane.add(drawpane(), new Integer(30));
			layeredpane.add(componentpane(), new Integer(50));
			layeredpane.add(glasspane(), new Integer(70));
			layeredpane.setOpaque(false);
		} // end if
		return(layeredpane);
	} // reader
	
	protected QRGpanel componentpane = null;
	public QRGpanel componentpane () {
		if (componentpane == null) {
			componentpane = new QRGpanel() {
				public Component add (Component component) {
					super.add(component);
					// It would be nice if there was a component interface,
					// Then we could specialize the method properly.
					if (component instanceof PeerElement.Interface) {
						PeerElement elementpeer = (PeerElement) component;
						component.addMouseListener(peerMouseAdapter());
						component.addMouseMotionListener(peerMouseAdapter());
						elementpeer.independentMarker().removeMouseListener(markerMouseAdapter());
						elementpeer.independentMarker().removeMouseMotionListener(markerMouseAdapter());
						elementpeer.independentMarker().addMouseListener(markerMouseAdapter());
						elementpeer.independentMarker().addMouseMotionListener(markerMouseAdapter());
						elementpeer.dependentMarker().removeMouseListener(markerMouseAdapter());
						elementpeer.dependentMarker().removeMouseMotionListener(markerMouseAdapter());
						elementpeer.dependentMarker().addMouseListener(markerMouseAdapter());
						elementpeer.dependentMarker().addMouseMotionListener(markerMouseAdapter());
						elementpeer.positionMarkers();
						elementpeer.set("VISIBLE", true);
						elementpeer.setVisible(true);
					} // end if
					return(component);
				} // method
				public void remove(Component component) {
					super.remove(component);
					if (component instanceof PeerElement.Interface) {
						PeerElement.Interface elementpeer = (PeerElement.Interface) component;
						component.removeMouseListener(peerMouseAdapter());
						component.removeMouseMotionListener(peerMouseAdapter());
						elementpeer.set("VISIBLE", false);
					} // end if
				} // method
			};
			componentpane.setLayout(null);
			componentpane.setOpaque(false);
			componentpane.addMouseListener(paneMouseAdapter());
			componentpane.addMouseMotionListener(paneMouseAdapter());
		} // end if
		return(componentpane);
	} // reader

	protected QRGpanel hrulepane = null;
	public QRGpanel hrulepane () {
		if (hrulepane == null) {
			hrulepane = new QRGpanel() {
					public void paint (Graphics g) {
						super.paint(g);
						Color c = g.getColor();
						g.setColor(BLACK);
						int w = getSize().width;
						int h = getSize().height;
						if (showRulers()) {
							for(int x = 0; x < w; x += hRuleIncrement()) {
								g.drawLine(x, 0, x, 5);
								if ((x % 100) == 0)
									g.drawLine(x, 0, x, 8);
							} // end for
						} // end if
						g.setColor(c);
					} // method
				};
			hrulepane.setOpaque(true);
		} // end if
		return(hrulepane);
	} // reader
	
	protected QRGpanel vrulepane = null;
	public QRGpanel vrulepane () {
		if (vrulepane == null) {
			vrulepane = new QRGpanel() {
					public void paint (Graphics g) {
						super.paint(g);
						Color c = g.getColor();
						g.setColor(BLACK);
						int w = getSize().width;
						int h = getSize().height;
						if (showRulers()) {
							for(int y = 0; y < h; y += vRuleIncrement()) {
								g.drawLine(0, y, 5, y);
								if ((y % 100) == 0)
									g.drawLine(0, y, 8, y);
							} // end for
						} // end if
						g.setColor(c);
					} // method
				};
			vrulepane.setOpaque(true);
		} // end if
		return(vrulepane);
	} // reader
	
	protected QRGpanel pageguidepane = null;
	public QRGpanel pageguidepane () {
		if (pageguidepane == null) {
			pageguidepane = new QRGpanel() {
					public void paint (Graphics g) {
						super.paint(g);
						Color c = g.getColor();
						g.setColor(pageGuideColor());
						int w = getSize().width;
						int h = getSize().height;
						int page = 0;
						if (showPageGuides()) {
							for(int x = 0; x < w; x += PAGE_WIDTH)
								g.drawLine(x, 0, x, h);
							for(int y = 0; y < h; y += PAGE_HEIGHT)
								g.drawLine(0, y, w, y);
							for(int x = 0; x < w; x += PAGE_WIDTH)
								for(int y = 0; y < h; y += PAGE_HEIGHT)
									g.drawString("Page " + (page++), x + 10, y + 20);
						} // end if
						g.setColor(c);
					} // method
				};
			pageguidepane.setOpaque(false);
		} // end if
		return(pageguidepane);
	} // reader
	
	protected QRGpanel drawpane = null;
	public QRGpanel drawpane () {
		if (drawpane == null) {
			drawpane = new QRGpanel() {
				public void paint (Graphics g) {
					super.paint(g);
					drawSkins(g);
					drawConnections(g);
				} // method
				public void print (Graphics g) {
					super.paint(g);
					drawSkins(g);
					drawConnections(g);
				} // method
			}; // jpanel
			drawpane.setOpaque(false);
		} // end if
		return(drawpane);
	} // reader
	
	public int view ( ) { return( model().getInt( "VIEW" ) ); }
	public int view ( int i  ) { 
		model().set( "VIEW", i );
		for( Enumeration items = model().instances().elements(); items.hasMoreElements(); )
			((PeerElement) ((Instance) items.nextElement( )).peer()).view( i );  
		return( i );
	} // method
	
	public void drawSkins (Graphics g) {
		if (model()!=null) {
			Instance instance = null;
			PeerElement peer = null;
			Instance skinstance = null;
			PeerElement skinpeer = null;
			Vector skins = null;
			int r = 0, w = 0, h = 0, x = 0, y = 0;
			int a = scaled(5), w1 = 0, h1 = 0, x1 = 0, y1 = 0;
			Color c = null;
			for(Enumeration i = model().instances().elements(); i.hasMoreElements();) {
				instance = (Instance) i.nextElement();
				peer = (PeerElement) instance.peer();
					h = peer.getHeight();
					w = peer.getWidth();
					x = peer.getX();
					y = peer.getY();
					skins = peer.skins();
					r = skins.size() * a;
					if (model().getBoolean("UNSKINNED") || (!instance.problems().isEmpty()) ) {
						skins = new Vector();
						r = 0;
					} // end if 
					if (instance.getBoolean("HIGHLIGHTED")) {
//					if (true) {
						r += a;
						c = YELLOW;
						x1 = x - r;
						y1 = y - r;
						h1 = h + (r * 2);
						w1 = w + (r * 2);
						g.setColor(c);
						// g.fillRect(x, y, w, h);
						if (peer.isVisible() && (!peer.getBoolean("HIDDEN")) ) {
							if (peer.typep(ATTRIBUTE) || peer.typep(CAUSES)) g.fillRoundRect(x1, y1, w1, h1, h1, h1);
							else g.fillRect(x1, y1, w1, h1);
						} // end if
						if (instance.typep(RELATIONSHIP)) drawConnections(g, instance, c, 2*r);
						r -= a;
					} // end for
					for(Enumeration s = skins.elements(); s.hasMoreElements();) {
						skinstance = (Instance) s.nextElement();
						skinpeer = (PeerElement) skinstance.peer();
						c = skinpeer.skinColor();
						x1 = x - r;
						y1 = y - r;
						h1 = h + (r * 2);
						w1 = w + (r * 2);
						g.setColor(c);
						// g.fillRect(x, y, w, h);
						if (peer.isVisible() && (!peer.getBoolean("HIDDEN")) ) {
							if (peer.typep(ATTRIBUTE) || peer.typep(CAUSES)) g.fillRoundRect(x1, y1, w1, h1, h1, h1);
							else g.fillRect(x1, y1, w1, h1);
						} // end if
						if (instance.typep(RELATIONSHIP)) drawConnections(g, instance, c, 2*r);
						r -= a;
					} // end for
			} // end for
		} // end for
	} // method
	
	public void drawConnections (Graphics g) {
		Graphics g2 = g;	// java 1.2
		g2.setColor(BLACK);
		int w = scaled( 3 );
		//g2.setStroke(new BasicStroke(scaled(3), BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
		Ontology o = model().localOntology();
		Definition r = null;
		Instance p = null;
		PeerElement ep = null;
		Point point1, point2, point3, point4;
		Vector drawn = new Vector();
		for (Enumeration enum = model().instances().elements() ; enum.hasMoreElements() ;) {
			p = (Instance) enum.nextElement();
			ep = (PeerElement) p.peer();
			if (ep.instance().typep(RELATIONSHIP)) {
				if (ep != null) {
					if (ep.hidden()) {
						if ((ep.input().equals("")) || (ep.input().equals(""))) {
						} else {
							Instance intarget = (Instance) model().findInstance(ep.input());
							Instance outtarget = (Instance) model().findInstance(ep.output());
							if ((intarget != null) && (outtarget != null)) {
								PeerElement ep2 = (PeerElement) intarget.peer();
								PeerElement ep3 = (PeerElement) outtarget.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = new Point(ep3.getLocation().x + (ep3.getWidth() / 2), ep3.getLocation().y + (ep3.getHeight() / 2));
								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);
								ep.setVisible(false);
							} else QRGutils.debug("ModelPane.drawConnections", "hidden relationship with disconnected terminal.");
						} // end if
					} else {
						if (ep.input().equals("")) {
							point1 = SwingUtilities.convertPoint(ep.independentMarker(), ep.independentMarker().getWidth() / 2, ep.independentMarker().getHeight() / 2, componentpane());
							point2 = SwingUtilities.convertPoint(ep.independentPort(), ep.independentPort().connectPoint(), componentpane());
							g2.setColor(ep.getEntityColor2());
							drawThickLine(g2, point1, point2, w);
						} else {
							Instance target = (Instance) model().findInstance(ep.input());
							if (target != null) {
								if(p.typep(PARTICIPATESIN)) drawn.addElement(target);
								PeerElement ep2 = (PeerElement) target.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = SwingUtilities.convertPoint(ep.independentPort(), ep.independentPort().connectPoint(), componentpane());
								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);
							} else QRGutils.debug("ModelPane.drawConnections", "target=" + target);
						} // end if
						if (ep.output().equals("")) {
							point1 = SwingUtilities.convertPoint(ep.dependentMarker(), ep.dependentMarker().getWidth() / 2, ep.dependentMarker().getHeight() / 2, componentpane());
							point2 = SwingUtilities.convertPoint(ep.dependentPort(), ep.dependentPort().connectPoint(), componentpane());
							g2.setColor(ep.getEntityColor2());
							drawThickLine(g2, point1, point2, w);
						} else {
							Instance target = (Instance) model().findInstance(ep.output());
							if (target != null) {
								if(p.typep(HASATTRIBUTE) || p.typep(HASPARTICIPANT)) drawn.addElement(target);
								PeerElement ep2 = (PeerElement) target.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = SwingUtilities.convertPoint(ep.dependentPort(), ep.dependentPort().connectPoint(), componentpane());
								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);	// Java 1.2
							} // end if
						} // end if
					} // end if
				} else QRGutils.debug("ModelPane.drawConnections", "ep=null !!");
			} // end if
		} // end for
	} // method
	
	public void drawConnections (Graphics g, Instance p, Color c, int w) {
		Graphics g2 = g;
		g2.setColor(c);
		//g2.setStroke(new BasicStroke(w, BasicStroke.CAP_ROUND, BasicStroke.JOIN_ROUND));
//		Ontology o = model().localOntology();
//		Definition r = null;
//		Instance p = null;
		PeerElement ep = null;
		Point point1, point2, point3, point4;
		Vector drawn = new Vector();
//		for (Enumeration enum = model().instances().elements() ; enum.hasMoreElements() ;) {
//			p = (Instance) enum.nextElement();
			ep = (PeerElement) p.peer();
			if (ep.instance().typep(RELATIONSHIP)) {
				if (ep != null) {
					if (ep.hidden()) {
						if ((ep.input().equals("")) || (ep.input().equals(""))) {
						} else {
							Instance intarget = (Instance) model().findInstance(ep.input());
							Instance outtarget = (Instance) model().findInstance(ep.output());
							if ((intarget != null) && (outtarget != null)) {
								PeerElement ep2 = (PeerElement) intarget.peer();
								PeerElement ep3 = (PeerElement) outtarget.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = new Point(ep3.getLocation().x + (ep3.getWidth() / 2), ep3.getLocation().y + (ep3.getHeight() / 2));
//								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);	// java 1.2
								ep.setVisible(false);
							} else QRGutils.debug("ModelPane.drawConnections", "hidden relationship with disconnected terminal.");
						} // end if
					} else {
						if (ep.input().equals("")) {
							point1 = SwingUtilities.convertPoint(ep.independentMarker(), ep.independentMarker().getWidth() / 2, ep.independentMarker().getHeight() / 2, componentpane());
							point2 = SwingUtilities.convertPoint(ep.independentPort(), ep.independentPort().connectPoint(), componentpane());
//							g2.setColor(ep.getEntityColor2());
							drawThickLine(g2, point1, point2, w);	// java 1.2
						} else {
							Instance target = (Instance) model().findInstance(ep.input());
							if (target != null) {
								if(p.typep(PARTICIPATESIN)) drawn.addElement(target);
								PeerElement ep2 = (PeerElement) target.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = SwingUtilities.convertPoint(ep.independentPort(), ep.independentPort().connectPoint(), componentpane());
//								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);	// java 1.2
							} else QRGutils.debug("ModelPane.drawConnections", "target=" + target);
						} // end if
						if (ep.output().equals("")) {
							point1 = SwingUtilities.convertPoint(ep.dependentMarker(), ep.dependentMarker().getWidth() / 2, ep.dependentMarker().getHeight() / 2, componentpane());
							point2 = SwingUtilities.convertPoint(ep.dependentPort(), ep.dependentPort().connectPoint(), componentpane());
//							g2.setColor(ep.getEntityColor2());
							drawThickLine(g2, point1, point2, w);	// java 1.2
						} else {
							Instance target = (Instance) model().findInstance(ep.output());
							if (target != null) {
								if(p.typep(HASATTRIBUTE) || p.typep(HASPARTICIPANT)) drawn.addElement(target);
								PeerElement ep2 = (PeerElement) target.peer();
								point1 = new Point(ep2.getLocation().x + (ep2.getWidth() / 2), ep2.getLocation().y + (ep2.getHeight() / 2));
								point2 = SwingUtilities.convertPoint(ep.dependentPort(), ep.dependentPort().connectPoint(), componentpane());
//								g2.setColor(ep.getEntityColor2());
								drawThickLine(g2, point1, point2, w);	// java 1.2
							} // end if
						} // end if
					} // end if
				} else QRGutils.debug("ModelPane.drawConnections", "ep=null !!");
			} // end if
//		} // end for
	} // method

	// Added TRH
	// Switched from lines to polygons -ureel
	public void drawThickLine(Graphics g, Point point1, Point point2, int width) {
		int offset = (int) Math.floor( (width * 1.0) / 2.0 );
		int [] xp1 = { point1.x - offset, point1.x + offset, point2.x + offset, point2.x - offset }; 
		int [] yp1 = { point1.y, point1.y, point2.y, point2.y }; 
		int [] xp2 = { point1.x, point1.x, point2.x, point2.x }; 
		int [] yp2 = { point1.y - offset, point1.y + offset, point2.y + offset, point2.y - offset }; 
		Polygon poly1 = new Polygon( xp1, yp1, 4 );
		Polygon poly2 = new Polygon( xp2, yp2, 4 );
		g.fillPolygon(poly1);
		g.fillPolygon(poly2);
	}	

	// Love Affair (1939) -> An Affair to Remember -> Sleepless in Seattle
	// Notorious
	// The Year of Living Dangerously
	
	public int scaled (int i) { return((int) Math.floor(scale() * i)); }
	public int scaled (double d) { return((int) Math.floor(scale() * d)); }
	
	public Controller controller () {
		Controller result = (Controller) VModel.controller();
		return(result);
	} // method
	

	// Inner Classes
	// ------------------------------------------------------------------------
	public static class Action implements VModelConstants {
		public static final String NONE = "NONE";
		public static final String ADD = "addElement";
		public static final String REMOVE = "removeElement";
		public static final String MOVE = "move";
		public static final String LABEL = "label";
		public static final String CONNECT = "connect";
		public static final String DISCONNECT = "disconnect";
		public static final String TWIST = "twist";
		public static final String FLIP = "flip";
		public static final String REVERSE = "reverse";
		public static final String ADDCONNECT = "addConnect";
		public static final String PASTE = "paste";
	
		protected String action = NONE;
		public String action () { return(action); }
		public String action (String a) { return(action = a); }
		
		protected Vector arguments = null;
		public Vector arguments () { 
			if (arguments == null) arguments = new Vector();
			return(arguments); 
		} // method
		public Vector arguments (Vector v) { return(arguments = v); }
		
		protected Vector arguments2 = null;
		public Vector arguments2 () { 
			if (arguments2 == null) arguments2 = new Vector();
			return(arguments2); 
		} // method
		public Vector arguments2 (Vector v) { return(arguments2 = v); }
		
		protected Vector arguments3 = null;
		public Vector arguments3 () { 
			if (arguments3 == null) arguments3 = new Vector();
			return(arguments3); 
		} // method
		public Vector arguments3 (Vector v) { return(arguments3 = v); }
		
		protected Vector arguments4 = null;
		public Vector arguments4 () { 
			if (arguments4 == null) arguments4 = new Vector();
			return(arguments4); 
		} // method
		public Vector arguments4 (Vector v) { return(arguments4 = v); }
		
		public Action () { super(); }
		public Action (String action, Vector arguments) {
			this();
			action(action);
			arguments(arguments);
		} // constructor
		public Action (String action, Vector arguments, Vector arguments2) {
			this();
			action(action);
			arguments(arguments);
			arguments2(arguments2);
		} // constructor
		public Action (String action, Vector arguments, Vector arguments2, Vector arguments3) {
			this();
			action(action);
			arguments(arguments);
			arguments2(arguments2);
			arguments3(arguments3);
		} // constructor
		public Action (String action, Vector arguments, Vector arguments2, Vector arguments3, Vector arguments4) {
			this();
			action(action);
			arguments(arguments);
			arguments2(arguments2);
			arguments3(arguments3);
			arguments4(arguments4);
		} // constructor
	} // innerclass
	
	protected transient Stack undoStack = null;
	public Stack undoStack () {
		if (undoStack == null) undoStack = new Stack();
		return(undoStack);
	} // reader
	public Stack undoStack (Stack s) { return(undoStack = s); }
	
	protected transient Stack redoStack = null;
	public Stack redoStack () {
		if (redoStack == null) redoStack = new Stack();
		return(redoStack);
	} // reader
	public Stack redoStack (Stack s) { return(redoStack = s); }
	
	// UnDo / ReDo
	// -----------------------------------------------------------------------
	public void doAction (Action a) {
		redoStack(null);
		undoStack().push(a);
		controller().selectedWindow().dirty(true);
//		controller().checkModel(model());
//		controller().updatePeers(model());
		controller().updateWidgets();
	} // method
	
	public void doAction (String action, Vector arguments) {
		doAction(new Action(action, arguments));
	} // method
	
	public void doAction (String action, Vector arguments, Vector arguments2) {
		doAction(new Action(action, arguments, arguments2));
	} // method
	
	public void doAction (String action, Vector arguments, Vector arguments2, Vector arguments3) {
		doAction(new Action(action, arguments, arguments2, arguments3));
	} // method
	
	public void doAction (String action, Vector arguments, Vector arguments2, Vector arguments3, Vector arguments4) {
		doAction(new Action(action, arguments, arguments2, arguments3, arguments4));
	} // method
	
	public Action undoAction () {
		Action action = null;
		if (! undoStack().empty()) {
			try { action = (Action) undoStack().pop(); }
			catch(EmptyStackException e) { };
		} // end if
		if (action != null) redoStack().push(action);
		controller().selectedWindow().dirty(true);
		return(action);
	} // method
	
	public Action redoAction () {
		Action action = null;
		if (! redoStack().empty()) {
			try { action = (Action) redoStack().pop(); }
			catch(EmptyStackException e) { };
		} // end if
		if (action != null) undoStack().push(action);
		controller().selectedWindow().dirty(true);
		return(action);
	} // method

} // class


// -----------------------------------------------------------------------------
// End of File: ModelPane.java        (c) 2001 Northwestern University