package edu.qrg.vmodel.controllers.macclassroom;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import java.awt.Component;
import java.awt.Container;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.lang.Cloneable;
import java.lang.Object;
import java.util.EventListener;
import javax.swing.JComponent;
import javax.swing.JSplitPane;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/gui
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: VModelSplitPane.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: VModelSplitPane
* Purpose: Splitpane with preset sizes.
* ----------------------------------------------------------------------------
* </PRE> */
public class VModelSplitPane extends JSplitPane implements VModelConstants {
	public VModelSplitPane () {
		super();
		//setLeftComponent(new VModelSidePanel());
		//setRightComponent(new JPanel());
		setContinuousLayout(true);
		setOneTouchExpandable(true);
		setDividerLocation(0);
		addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				if (!recurse) {
					recurse = true;
					JSplitPane source = ((JSplitPane) e.getSource());
					int loc = source.getDividerLocation();
					int wid = source.getSize().width;
					int siz = source.getLeftComponent().getMinimumSize().width + source.getDividerSize(); // (int) Math.floor((wid / 4));
					int max =  source.getSize().width - source.getRightComponent().getMinimumSize().width - source.getDividerSize();
					if (VModel.controller() != null) VModel.preferences().set("DIVIDER-LOCATION", loc);
					if (wid > 10) {
						if (loc > (max)) {
							source.setDividerLocation(max);
						} else if ((!collapsed()) && (loc < siz)) {
							source.setDividerLocation(siz);
						} // end if
					} // end if
					recurse = false;
				} else {
					collapsed(true);
					recurse = false; 
				} // end if
			} });
	} // constructor
	
			public boolean recurse = false;

				public void updateshape( ) {
				if (!recurse) {
					recurse = true;
					JSplitPane source = this;
					int loc = source.getDividerLocation();
					int wid = source.getSize().width;
					int siz = source.getLeftComponent().getMinimumSize().width + source.getDividerSize(); // (int) Math.floor((wid / 4));
					int max =  source.getSize().width - source.getRightComponent().getMinimumSize().width - source.getDividerSize();
					if (VModel.controller() != null) VModel.preferences().set("DIVIDER-LOCATION", loc);
					if (wid > 10) {
						if (loc > (max)) {
							source.setDividerLocation(max);
						} else if ((!collapsed()) && (loc < siz)) {
							source.setDividerLocation(siz);
						} // end if
					} // end if
					recurse = false;
				} else {
					collapsed(true);
					recurse = false; 
				} // end if
			}

	// Properties & Accessors
	// -----------------------------------------------------------------------
	public boolean collapsed = false;
	public boolean collapsed () { return(collapsed); }
	public boolean collapsed (boolean b) { 
		boolean old = collapsed;
		collapsed = b;
		if (old != b) {
			setDividerLocation(0);
		} // end if
		return(collapsed);
	} // writer
} // class 

// -----------------------------------------------------------------------------
// End of File: VModelSplitPane.java       (c) 2001 Northwestern University