package edu.qrg.vmodel.controllers;

import edu.qrg.utils.*;
import edu.qrg.vmodel.*;
import edu.qrg.vmodel.VModel.*;
import edu.qrg.utils.KeyValuePair;
//import edu.qrg.utils.KeyValuePair.KVPinterface;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.Serializable;
import java.lang.Boolean;
import java.lang.Class;
import java.lang.ClassNotFoundException;
import java.lang.Cloneable;
import java.lang.Exception;
import java.lang.IllegalAccessException;
import java.lang.InstantiationException;
import java.lang.NoSuchMethodException;
import java.lang.Object;
import java.lang.String;
import java.lang.System;
import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.net.URL;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JApplet;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRootPane;
import javax.swing.JWindow;
import javax.swing.Timer;
import java.awt.*;
import javax.swing.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: TestController.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: TestController
* Purpose: TestController VModel Interface Controller
* ----------------------------------------------------------------------------
* NOTES:
* ----------------------------------------------------------------------------
* </PRE> */
public class TestController extends VModel implements VModel.VMController {
	// Constructors
	// -------------------------------------------------------------------------
	public TestController () {
		QRGutils.debug("TestController", "Wrong Constructor Called!!!!!!!!!");
	} // constructor
	
	public TestController (VModel v) {
		self(this);
		vmodel(v);
		init();
	} // constructor

	// VModel Methods
	// -------------------------------------------------------------------------
	// Start Controller
	public void go () { 
		try { Thread.sleep(5234); }
		catch (Exception e) { }
		QRGutils.debug("TestController.go", "Controller started.");
		ontology();
		Model model = makeModel(true);
		Instance mumble = null;
		Definition grumble = null;
		Instance thermalObject = (Instance) addDefinition(model, BaseOntology.entity).elementAt(0);
		Instance thermalHeat = (Instance) addDefinition(model, BaseOntology.amount).elementAt(0);
		Instance thermalTemperature = (Instance) addDefinition(model, BaseOntology.amount).elementAt(0);
		rename(model, thermalObject, "Thermal Object", true);
		rename(model, thermalHeat, "Heat", true);
		rename(model, thermalTemperature, "Temperature", true);
		connect(model, BaseOntology.hasAttribute, thermalObject, thermalHeat);
		connect(model, BaseOntology.hasAttribute, thermalObject, thermalTemperature);
		mumble = connect(model, BaseOntology.qpropPlus, thermalHeat, thermalTemperature);
		connect(model, BaseOntology.requires, thermalObject, mumble);
		Definition libraryThermalObject = (Definition) addToLibrary(model, thermalObject);

		Instance thermalSource = thermalObject;
		Instance thermalSourceHeat = thermalHeat;
		Instance thermalSourceTemperature = thermalTemperature;
		rename(model, thermalSource, "Thermal Source", true);

		Instance thermalSink = (Instance) addDefinition(model, libraryThermalObject).elementAt(0);
		rename(model, thermalSink, "Thermal Sink", true);
		Instance thermalSinkHeat = null;
		Instance thermalSinkTemperature = null;
		// This only works in code.
		for (Enumeration enum = thermalSink.children(); enum.hasMoreElements();) {
			mumble = (Instance) enum.nextElement();
			if (mumble.name().equals("Heat")) thermalSinkHeat = mumble;
			if (mumble.name().equals("Temperature")) thermalSinkTemperature = mumble;
		} // end for

//QRGutils.debug("TestController.go", "thermalSinkHeat=" + thermalSinkHeat);
//QRGutils.debug("TestController.go", "thermalSinkTemperature=" + thermalSinkTemperature);

		Instance heatXchange = (Instance) addDefinition(model, BaseOntology.process).elementAt(0);
		rename(model, heatXchange, "Heat Transfer", true);
		Instance rateOfHeatXchange = (Instance) addDefinition(model, BaseOntology.rate).elementAt(0);
		rename(model,rateOfHeatXchange, "Rate of Heat Exchange", true);
		connect(model, BaseOntology.hasParticipant, heatXchange, thermalSource);
		connect(model, BaseOntology.hasParticipant, heatXchange, thermalSink);
		mumble = connect(model, BaseOntology.touches, thermalSource, thermalSink);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		mumble = connect(model, BaseOntology.isGreaterThan, thermalSourceTemperature, thermalSinkTemperature);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		mumble = connect(model, BaseOntology.qpropPlus, thermalSourceTemperature, rateOfHeatXchange);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		mumble = connect(model, BaseOntology.qpropMinus, thermalSinkTemperature, rateOfHeatXchange);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		mumble = connect(model, BaseOntology.iMinus, rateOfHeatXchange, thermalSourceHeat);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		mumble = connect(model, BaseOntology.iPlus, rateOfHeatXchange, thermalSinkHeat);
		connect(model, BaseOntology.requires, heatXchange, mumble);
		rename(model, thermalSource, "Source", true);
		rename(model, thermalSink, "Sink", true);
		addToLibrary(model, heatXchange);


/*
		Instance coffee = addDefinition(model, null, libraryThermalObject);
		Instance coffeeHeat = null;
		Instance coffeeTemperature = null;
		for (Enumeration enum = coffee.children(); enum.hasMoreElements();) {
			mumble = (Instance) enum.nextElement();
			grumble = mumble.definition();
			if (grumble != null) {
				if (grumble.name().equals("Heat")) coffeeHeat = mumble;
				if (grumble.name().equals("Temperature")) coffeeTemperature = mumble;
			} // end if
		} // end for
		rename(model, coffee, "Coffee");
		Instance atmosphere = addDefinition(model, null, libraryThermalObject);
		Instance atmosphereHeat = null;
		Instance atmosphereTemperature = null;
		for (Enumeration enum = atmosphere.children(); enum.hasMoreElements();) {
			mumble = (Instance) enum.nextElement();
			grumble = mumble.definition();
			if (grumble != null) {
				if (grumble.name().equals("Heat")) atmosphereHeat = mumble;
				if (grumble.name().equals("Temperature")) atmosphereTemperature = mumble;
			} // end if
		} // end for
		rename(model, atmosphere, "Atmosphere");
		connect(model, BaseOntology.touches, coffee, atmosphere);
		connect(model, BaseOntology.isGreaterThan, coffeeTemperature, atmosphereTemperature);
		connect(model, BaseOntology.boundTo, thermalSinkHeat, atmosphereHeat);
		connect(model, BaseOntology.boundTo, thermalSourceHeat, coffeeHeat);
//QRGutils.debug("*TestController.go", "CML model=" + model.toCML());
//deleteDefinition(model, coffee);
//deleteDefinition(model, thermalSink);
//		QRGutils.debug("TestController.go", "CML model=" + model.toCML());
//		quit();
*/		
		simulate(model);
		QRGutils.debug("TestController.go", "CML model=" + model.toCML());
//		QRGutils.debug("TestController.go", "model.localLibrary=" + model.localLibrary().toCML());
		QRGutils.debug("TestController.go", "myLibrary=" + myLibrary().toCML());
//		QRGutils.debug("TestController.go", "XML model=" + model.xmlify());
		quit();
	} // method run
	
	// Quit Program
	public boolean quit () {
		preferences().saveLocalPrefs();
		myProcesses().save("myProcesses");
		myEntities().save("myEntities");
		myThings().save("myThings");
		myMultipleThings().save("myMultipleThings");
		mySubstances().save("mySubstances");
		myAttributes().save("myAttributes");
		super.quit();
		return(true);
	} // method quit
	
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// self
	/** @serial */
	protected TestController self = null;
	public TestController self () { return(self); }
	public TestController self (TestController c) { return(self = c); }

	// VModel model engine
	/** @serial */
	protected VModel vmodel = null;
	public VModel vmodel () { return(vmodel); }
	public VModel vmodel (VModel v) { return(vmodel = v); }
	
	// Selected Model
	/** @serial */
	protected Model currentModel = null;
	public Model currentModel () { return(currentModel); }
	public Model currentModel (Model m) { return(currentModel = m); }
	/** @deprecated Use currentModel () */
	public Model selectedModel () { return(currentModel()); }
	/** @deprecated Use currentModel (Model m) */
	public Model selectedModel (Model m) { return(currentModel(m)); }

	// Methods
	// ------------------------------------------------------------------------
	public int closeAllModels () { return(0); }
	public int closeModel () { return(0); }
	public Instance addConnect (Model model, Definition relationship, Instance independent, Instance dependent, int x, int y, int orientation) { return(null); }


	// Methods
	// -------------------------------------------------------------------------
	// Load specified controller class
	public void init () {
	//	ontology();
	//	myLibrary();
	} // method init
		
} // class

// -----------------------------------------------------------------------------
// End of File: TestController.java       (c) 2001 Northwestern University