//package edu.qrg.vmodel.controllers.Classic;

import Definition.DefInterface;
import Instance.InstInterface;
import KeyValuePair;
import KeyValuePair.KVPinterface;
import Model.Interface;
import ModelPane.Action;
import Ontology.Category;
import Reference.RefInterface;
import VModel.VMController;
import java.applet.Applet;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyVetoException;
import java.io.File;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Exception;
import java.lang.Integer;
import java.lang.Math;
import java.lang.Object;
import java.lang.Runnable;
import java.lang.String;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.ComboBoxModel;
import javax.swing.DefaultDesktopManager;
import javax.swing.JApplet;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JDesktopPane;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.JViewport;
import javax.swing.ListCellRenderer;
import javax.swing.ListModel;
import javax.swing.SwingUtilities;
import javax.swing.border.EtchedBorder;
import javax.swing.event.ListDataListener;
import javax.swing.filechooser.FileFilter;
import javax.swing.Timer;
import javax.swing.JWindow;


/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers/Classic
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Classic.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: Classic
* Purpose: Classic VModel Interface Controller
* ----------------------------------------------------------------------------
* </PRE> */
public class Classic extends VModel implements Controller {
	// Constructors
	// -------------------------------------------------------------------------
	public Classic ( ) {
		QRGutils.debug( "Wrong Constructor Called!!!!!!!!!" );
	} // constructor
	
	public Classic ( VModel v ) {
		self( this );
		vmodel( v );
		init( );
	} // constructor

	// Properties & Accessors
	// -------------------------------------------------------------------------
	// self
	protected Classic self = null;
	public Classic self ( ) { return( self ); }
	public Classic self ( Classic c ) { return( self = c ); }

	// VModel model engine
	protected VModel vmodel = null;
	public VModel vmodel ( ) { return( vmodel ); }
	public VModel vmodel ( VModel v ) { return( vmodel = v ); }
	
	// Browser	
	protected HTMLbrowser browser = null;
	public HTMLbrowser browser ( ) { 
		if ( browser == null ) browser = new HTMLbrowser( );
		return( browser ); 
	} // reader browser

	// Selected Ontology
	protected Ontology selectedOntology = null;
	/** @deprecated Use selectedLibrary ( ) */
	public Ontology selectedOntology ( ) { return( selectedOntology ); }
	/** @deprecated Use selectedLibrary ( Library l ) */
	public Ontology selectedOntology ( Ontology o ) { 
		if ( o != null ) VModelStatusBar.showText( o.documentation( ) );
		return( selectedOntology = o ); 
	} // writer

	public Library selectedLibrary ( ) { return( (Library) selectedOntology( ) ); }
	public Library selectedLibrary ( Library l ) { return( (Library) selectedOntology( l ) ); }

	// Selected Model
	/** @deprecated Use currentModel ( ) */
	public Model selectedModel ( ) { return( currentModel( ) ); }
	/** @deprecated Use currentModel ( Model m ) */
	public Model selectedModel ( Model m ) { return( currentModel( m ) ); }

	// Selected Library Element
	protected Definition.DefInterface selectedDefinition = null;
	public Definition.DefInterface selectedDefinition ( ) { return( selectedDefinition ); }
	public Definition.DefInterface selectedDefinition ( Definition.DefInterface e ) { 
		if ( e != null ) VModelStatusBar.showText( e.documentation( ) );
		return( selectedDefinition = e ); 
	} // writer
	
	protected JTree myLibraryTree = null;
	public JTree myLibraryTree ( ) { return( myLibraryTree ); }
	public JTree myLibraryTree ( JTree t ) { return( myLibraryTree = t ); }

	// Modeler
	protected JPanel modeler = null;
	public JPanel modeler ( ) { 
		if ( modeler == null ) modeler = new JPanel( new BorderLayout( ) );
		return( modeler ); 
	} // reader

	// The top-level system window
	public JFrame frame = null;
	public JFrame frame ( ) { return( frame ); }
	public JFrame frame ( JFrame f ) { return( frame = f ); }
	
	// Statusbar
	protected VModelStatusBar statusbar = new VModelStatusBar( );
	public VModelStatusBar statusbar ( ) { return( statusbar ); }
	public VModelStatusBar statusbar ( VModelStatusBar s ) { 
		return( statusbar = s ); 
	} // writer statusbar
	
	protected Image icon = null;
	public Image icon( ) { return( icon ); }
	public Image icon( Image i ) { return( icon = i ); }

	protected VModelMenuBar menubar = null;
	public VModelMenuBar menubar ( ) {
		if (menubar == null) menubar(new VModelMenuBar( ));
		return(menubar);
	} // reader menubar
	public VModelMenuBar menubar ( VModelMenuBar m ) { return( menubar = m ); }

	protected VModelSplitPane splitpane = null;
	public VModelSplitPane splitpane ( ) {
		if (splitpane == null) splitpane(new VModelSplitPane( ));
		return(splitpane);
	} // reader splitpane
	public VModelSplitPane splitpane ( VModelSplitPane s ) { 
		return( splitpane = s ); 
	} // writer splitpane

	protected VModelSidePanel sidepanel = null;
	public VModelSidePanel sidepanel ( ) { return( sidepanel ); } 
	public VModelSidePanel sidepanel ( VModelSidePanel s ) { 
		return( sidepanel = s ); 
	} // writer splitpane

	protected VModelPreferencesDialog preferencesDialog = null;
	public VModelPreferencesDialog preferencesDialog ( ) { 
		if (preferencesDialog == null) preferencesDialog = new VModelPreferencesDialog();
		return( preferencesDialog ); 
	} // reader preferencesDialog

	protected PrintPreviewDialog printPreview = null;
	public PrintPreviewDialog printPreview ( ) { 
		if (printPreview == null ) printPreview = new PrintPreviewDialog( );
		return( printPreview ); 
	} // reader

	protected final String [] splashSounds = { "ohyeah", "Dragnet", "20th_cent", 
		"ohyeah", "CavalryCall", "Dragnet", "20th_cent", "CavalryCall" };
		
	// Methods
	// ------------------------------------------------------------------------
	public void updateWidgets ( ) {
		newModelButton( ).setEnabled( true );
		boolean modelexists = ( currentModel( ) != null );
		boolean elementselected = ( ( selectedWindow( ) != null) && ( ! ((ModelFrame) selectedWindow( )).modelPane( ).selectedComponents( ).isEmpty( ) ) );
		coachButton( ).setEnabled( modelexists );
		openButton( ).setEnabled( true );
		saveButton( ).setEnabled( modelexists );
		printButton( ).setEnabled( modelexists );
		printPreviewButton( ).setEnabled( modelexists );
		undoButton( ).setEnabled( modelexists  && 
			( ! selectedWindow( ).modelPane( ).undoStack( ).empty( ) ) );
		redoButton( ).setEnabled( modelexists && 
			( ! selectedWindow( ).modelPane( ).redoStack( ).empty( ) ) );
		selectButton( ).setEnabled( modelexists );
		copyButton( ).setEnabled( modelexists && elementselected );
		cutButton( ).setEnabled( modelexists && elementselected );
		pasteButton( ).setEnabled( modelexists && elementselected );
		groupButton( ).setEnabled( modelexists && elementselected );
		menubar( ).updateWidgets( );
		if ( selectedWindow( ) != null ) selectedWindow( ).updateWidgets( );
	} // method
	
	protected FrameKeyAdapter frameKeyAdapter = null;
	public FrameKeyAdapter frameKeyAdapter ( ) { 
		if ( frameKeyAdapter == null ) frameKeyAdapter = new FrameKeyAdapter( );
		return( frameKeyAdapter ); 
	} // reader
	
	public class FrameKeyAdapter extends KeyAdapter {
		public void keyPressed(KeyEvent e) {
			if ( ( currentModel( ) != null ) && ( e.getKeyCode( ) == e.VK_DELETE ) ) {
				if ( ! ((ModelFrame) selectedWindow( )).modelPane( ).selectedComponents( ).isEmpty( ) ) {
					delete( );
				} // end if
			} // end if
		} // method
	} // innerclass
		
	// Load specified controller class
	public void init ( ) {
		controller( this );
/*
		if ( preferences( ).getBoolean( "SOUND" ) ) 
			SoundCache.playSound( splashSounds[ (int) Math.floor( Math.random( ) * ( splashSounds.length - 1 ) ) ] + ".au" );
		
		// load graphics
		loadImages( );
		
		myModels( ).icon("IconModel");
		myProcesses( ).icon("IconProcess");
		myEntities( ).icon("IconEntity");
		myAttributes( ).icon("IconAttribute");
		
		// Create external frame window.
		frame( new JFrame( ) );
		frame( ).addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				quit( );
			} // method windowClosing
		}); // addWindowListener
		frame().setIconImage( icon( ) );
		frame( ).setTitle( "" + QRGutils.projectName( ) + " v" + QRGutils.projectVersion( ) );
		frame( ).setSize( QRGutils.calcWindowSize() );
		frame( ).setLocation( QRGutils.center( QRGutils.calcWindowSize( ) ) );
		frame( ).addKeyListener( frameKeyAdapter( ) );

		// build modeler panel
		// from modeler
		// -------------------------------------------------------------------
		// Add SplitPane
		topleftpanel( new JPanel( new BorderLayout( ) ) );
		toprightpanel( new JPanel( new FlowLayout( FlowLayout.RIGHT ) ) );
		toppanel( new JPanel( new BorderLayout( ) ) );

		toolbar( ).add( newModelButton( ) );
		toolbar( ).add( openButton( ) );
		toolbar( ).add( saveButton( ) );
		toolbar( ).add( printButton( ) );
		toolbar( ).add( printPreviewButton( ) );
		toolbar( ).addSeparator( );
		toolbar( ).add( undoButton( ) );
		toolbar( ).add( redoButton( ) );
		toolbar( ).addSeparator( );
		toolbar( ).add( selectButton( ) );
		toolbar( ).add( copyButton( ) );
		toolbar( ).add( cutButton( ) );
		toolbar( ).add( pasteButton( ) );
		toolbar( ).add( groupButton( ) );
		toolbar2( ).add( new JLabel( "Selected Window: " ) );
		toolbar2( ).add( openWindows( ) );
		topleftpanel( ).add( toolbar2( ), BorderLayout.NORTH );
		topleftpanel( ).add( toolbar( ), BorderLayout.SOUTH );
		toppanel( ).add( coachButton( ), BorderLayout.EAST );
		toppanel( ).add( topleftpanel( ), BorderLayout.CENTER );
		modeler( ).add( toppanel( ), BorderLayout.NORTH );
		desktopScrollPane( ).setBorder( new EtchedBorder( ) );
		JViewport fubar = new JViewport( );
		fubar.setView( desktop( ) );
		desktopScrollPane( ).setViewportView( desktop( ) );
		
		desktop( ).setDesktopManager( new DefaultDesktopManager( ) {
			public void endDraggingFrame(JComponent f)  {
				JInternalFrame[] frames = desktop( ).getAllFrames();
				JInternalFrame jif = null;
				Point fpos = f.getLocation( );
				Dimension fsiz = f.getSize( );
				double fsizW = fsiz.width;
				double fsizH = fsiz.height;
				Dimension vsiz = desktopScrollPane( ).getViewport().getSize( );
				double vsizW = vsiz.width;
				double vsizH = vsiz.height;
				Point vp = desktopScrollPane( ).getViewport( ).getViewPosition( );
				int minX = (int) Math.min( vp.x, fpos.x );
				int minY = (int) Math.min( vp.y, fpos.y );
				int maxX = (int) Math.max( vsizW, fpos.x + fsizW );
				int maxY = (int) Math.max( vsizH, fpos.y + fsizH );
				
				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					fsiz = jif.getSize( );
					fsizW = fsiz.width;
					fsizH = fsiz.height;
					minX = (int) Math.min( minX, fpos.x );
					minY = (int) Math.min( minY, fpos.y );
					maxX = (int) Math.max( maxX, fpos.x + fsizW );
					maxY = (int) Math.max( maxY, fpos.y + fsizH );
				} // end for
				
				int w = maxX - minX;
				int h = maxY - minY;
				
				desktop( ).setSize(w,h);
				desktop( ).setPreferredSize(desktop().getSize());
				desktop( ).invalidate( );
				
				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					jif.setLocation( fpos.x - minX, fpos.y );
				} // end for
				vp.translate(- minX, 0); 

				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					jif.setLocation( fpos.x, fpos.y - minY );
				} // end for
				vp.translate( 0, - minY); 

				desktopScrollPane( ).getViewport( ).setViewPosition( vp );
				desktopScrollPane( ).setAutoscrolls( true );
				desktopScrollPane( ).doLayout( );
				desktopScrollPane( ).invalidate( );

				f.invalidate( );
				f.repaint();
			} } );

		modeler( ).add( desktopScrollPane( ), BorderLayout.CENTER );

		// Add SplitPane
		sidepanel( new VModelSidePanel( ) );
		splitpane( ).setLeftComponent( modeler( ) );
		splitpane( ).setRightComponent( sidepanel( ) );
		frame( ).getContentPane( ).add( splitpane( ), BorderLayout.CENTER );
		
		// Add StatusBar
		frame( ).getContentPane().add( statusbar( ), BorderLayout.SOUTH);
		
		// Add Menubar
//		menubar( ).menuWindow( ).addSeparator( );
//		menubar( ).menuWindow( ).add( modeler( ).modelsMenu( ) );
		frame( ).setJMenuBar( menubar( ) );
		
		if ( !classModels( ).isLeaf( ) ) sidepanel( ).add( classModels( ) );
		if ( !vModels( ).isLeaf( ) ) sidepanel( ).add( vModels( ) );
//		sidepanel( ).add( currentModel( ) );
		
		// Realize Current Project
//		realizeProject( );
*/		
		myModels( ).icon("IconModel");
		myProcesses( ).icon("IconProcess");
		myEntities( ).icon("IconEntity");
		myAttributes( ).icon("IconAttribute");
		
		if ( preferences( ).getBoolean( "SOUND" ) ) 
			SoundCache.playSound( splashSounds[ (int) Math.floor( Math.random( ) * ( splashSounds.length - 1 ) ) ] + ".au" );
		
		initDone = true;

	} // method init
	
	public static boolean initDone = false;
	
	Library qpLibrary = null;

	public void realizeProject ( ) {
//		( (HTMLpanel) sidepanel( ).projectPanel( ) ).gotoPage( QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ), project( ).getBackground( ) );
		( (HTMLpanel) sidepanel( ).projectPanel( ) ).gotoPage( QRGutils.QRGroot( ) + HELPPATH, project( ).getBackground( ) );
		Library library = (Library) XMLio.load( QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ) + project( ).getString( "LIBRARY" ) );
		QRGutils.debug("Classic.realizeProject", "----------------->"+preferences( ).getString("PROJECT")+"<----------" );
		if ( library == null ) {
			if ( qpLibrary == null ) {
				if (preferences( ).getString("PROJECT").equalsIgnoreCase("classroom.vmp")) qpLibrary = new ClassroomLibrary( );
				else qpLibrary = new QPlibrary( );
			} // end if
			library = qpLibrary;
			File file = new File(  QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ) + project( ).getString( "LIBRARY" ) );
			if ( !file.exists() ) {
				XMLio.save(  QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ) + project( ).getString( "LIBRARY" ), library );
				CMLio.save(  QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ) + project( ).getString( "LIBRARY" ) + ".cml", library );
			} // end if
		} // else XMLio.save(  QRGutils.QRGroot( ) + PROJECTPATH + project( ).getFolder( ) + "two-" + project( ).getString( "LIBRARY" ), library );
		sidepanel( ).add( library );
		projectLibrary( library );
//		load("test.vmf");
	} // method realizeProject
	
	// Description: Load several commonly used images.
	// -----------------------------------------------------------------------
	public void loadImages ( ) {
		// Named images (very common)
		icon(QRGutils.getImage(QRGutils.QRGroot()+IMAGEPATH+"vmodel.gif"));
		String bgImage = preferences().getString("BACKGROUNDIMAGE");
//		if (bgImage != null) backgroundImage(ImageCache.getImage(bgImage));
		ImageCache.loadImage("back.gif");

		// Cache these
		ImageCache.loadImage("BACK.GIF");
		ImageCache.loadImage("NEWMODEL.GIF");
		ImageCache.loadImage("OPEN.GIF");
		ImageCache.loadImage("SAVE.GIF");
		ImageCache.loadImage("PRINT.GIF");
		ImageCache.loadImage("PREVIEW.GIF");
		ImageCache.loadImage("UNDO.GIF");
		ImageCache.loadImage("REDO.GIF");
		ImageCache.loadImage("HAND.GIF");
		ImageCache.loadImage("COPY.GIF");
		ImageCache.loadImage("CUT.GIF");
		ImageCache.loadImage("PASTE.GIF");
		ImageCache.loadImage("GROUP.GIF");
		ImageCache.loadImage("COACH-LB.GIF");
		ImageCache.loadImage("COACH-LB-M.GIF");
		ImageCache.loadImage("COACH-E-M.GIF");
		ImageCache.loadImage("FORWARD.GIF");
		ImageCache.loadImage("COACH-ML-M.GIF");
		ImageCache.loadImage("EDIT.GIF");
		ImageCache.loadImage("NEWENTITY.GIF");
		ImageCache.loadImage("NEWPROCESS.GIF");
		ImageCache.loadImage("NEW.GIF");
		ImageCache.loadImage("VMODELLOGIN.GIF");
		ImageCache.loadImage("VMODEL.GIF");
		ImageCache.loadImage("COACH-T-H-S.GIF");
		ImageCache.loadImage("COACH-B-H-S.GIF");
		ImageCache.loadImage("COACH-E-H-S.GIF");
		ImageCache.loadImage("GLASSES.GIF");
		ImageCache.loadImage("GLASSES-ENTITY.GIF");
		ImageCache.loadImage("GLASSES-PROCESS.GIF");
		ImageCache.loadImage("GLASSES-RELATIONSHIP.GIF");
		ImageCache.loadImage("GLASSES-SITUATION.GIF");
		ImageCache.loadImage("GLASSES-CAUSAL.GIF");
		ImageCache.loadImage("GLASSES-JUSTIFICATION.GIF");
		ImageCache.loadImage("GLASSES-COACH.GIF");
		ImageCache.loadImage("GLASSES-ANNOTATION.GIF");
		ImageCache.loadImage("GLASSES-ROLE.GIF");
		ImageCache.loadImage("GLASSES-QP.GIF");
		ImageCache.loadImage("GLASSES-TARGET.GIF");
		ImageCache.loadImage("MAGNIFY.GIF");
		ImageCache.loadImage("ICONMODEL.GIF");
		ImageCache.loadImage("ICONENTITYDATA.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPSUPPORTS.GIF");
		ImageCache.loadImage("ICONHYPOTHESIS.GIF");
		ImageCache.loadImage("ICONRELATIONSHIP.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPCAUSAL.GIF");
		ImageCache.loadImage("ICONRELATIONSHIPSTRUCTURAL.GIF");
		ImageCache.loadImage("ICONATTRIBUTE.GIF");
		ImageCache.loadImage("ICONQUANTITY.GIF");
		ImageCache.loadImage("ICONPROCESS.GIF");
		ImageCache.loadImage("ICONENTITY.GIF");
		ImageCache.loadImage("MARKER.GIF");
    } // method loadImages

	
	public void doLogin( ) {
//		try { wait( 1350 ); }
//		catch( Exception e ) { }
		while( ! initDone ) { 
			try { wait( 1000 ); }
			catch( Exception e ) { }
		} // end while

		// Create external frame window.
		frame( new JFrame( ) );
		frame( ).addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				quit( );
			} // method windowClosing
		}); // addWindowListener
		frame().setIconImage( icon( ) );
		frame( ).setTitle( "" + QRGutils.projectName( ) + " v" + QRGutils.projectVersion( ) );
		frame( ).setSize( QRGutils.calcWindowSize() );
		frame( ).setLocation( QRGutils.center( QRGutils.calcWindowSize( ) ) );
		frame( ).addKeyListener( frameKeyAdapter( ) );

		// load graphics
		loadImages( );
		
		// build modeler panel
		// from modeler
		// -------------------------------------------------------------------
		// Add SplitPane
		topleftpanel( new JPanel( new BorderLayout( ) ) );
		toprightpanel( new JPanel( new FlowLayout( FlowLayout.RIGHT ) ) );
		toppanel( new JPanel( new BorderLayout( ) ) );

		toolbar( ).add( newModelButton( ) );
		toolbar( ).add( openButton( ) );
		toolbar( ).add( saveButton( ) );
		toolbar( ).add( printButton( ) );
		toolbar( ).add( printPreviewButton( ) );
		toolbar( ).addSeparator( );
		toolbar( ).add( undoButton( ) );
		toolbar( ).add( redoButton( ) );
		toolbar( ).addSeparator( );
		toolbar( ).add( selectButton( ) );
		toolbar( ).add( copyButton( ) );
		toolbar( ).add( cutButton( ) );
		toolbar( ).add( pasteButton( ) );
		toolbar( ).add( groupButton( ) );
		toolbar2( ).add( new JLabel( "Selected Window: " ) );
		toolbar2( ).add( openWindows( ) );
		topleftpanel( ).add( toolbar2( ), BorderLayout.NORTH );
		topleftpanel( ).add( toolbar( ), BorderLayout.SOUTH );
		toppanel( ).add( coachButton( ), BorderLayout.EAST );
		toppanel( ).add( topleftpanel( ), BorderLayout.CENTER );
		modeler( ).add( toppanel( ), BorderLayout.NORTH );
		desktopScrollPane( ).setBorder( new EtchedBorder( ) );
		JViewport fubar = new JViewport( );
		fubar.setView( desktop( ) );
		desktopScrollPane( ).setViewportView( desktop( ) );
		
		desktop( ).setDesktopManager( new DefaultDesktopManager( ) {
			public void endDraggingFrame(JComponent f)  {
				JInternalFrame[] frames = desktop( ).getAllFrames();
				JInternalFrame jif = null;
				Point fpos = f.getLocation( );
				Dimension fsiz = f.getSize( );
				double fsizW = fsiz.width;
				double fsizH = fsiz.height;
				Dimension vsiz = desktopScrollPane( ).getViewport().getSize( );
				double vsizW = vsiz.width;
				double vsizH = vsiz.height;
				Point vp = desktopScrollPane( ).getViewport( ).getViewPosition( );
				int minX = (int) Math.min( vp.x, fpos.x );
				int minY = (int) Math.min( vp.y, fpos.y );
				int maxX = (int) Math.max( vsizW, fpos.x + fsizW );
				int maxY = (int) Math.max( vsizH, fpos.y + fsizH );
				
				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					fsiz = jif.getSize( );
					fsizW = fsiz.width;
					fsizH = fsiz.height;
					minX = (int) Math.min( minX, fpos.x );
					minY = (int) Math.min( minY, fpos.y );
					maxX = (int) Math.max( maxX, fpos.x + fsizW );
					maxY = (int) Math.max( maxY, fpos.y + fsizH );
				} // end for
				
				int w = maxX - minX;
				int h = maxY - minY;
				
				desktop( ).setSize(w,h);
				desktop( ).setPreferredSize(desktop().getSize());
				desktop( ).invalidate( );
				
				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					jif.setLocation( fpos.x - minX, fpos.y );
				} // end for
				vp.translate(- minX, 0); 

				for( int i = 0; i < frames.length; i++ ) {
					jif = frames[i];
					fpos = jif.getLocation( );
					jif.setLocation( fpos.x, fpos.y - minY );
				} // end for
				vp.translate( 0, - minY); 

				desktopScrollPane( ).getViewport( ).setViewPosition( vp );
				desktopScrollPane( ).setAutoscrolls( true );
				desktopScrollPane( ).doLayout( );
				desktopScrollPane( ).invalidate( );

				f.invalidate( );
				f.repaint();
			} } );

		modeler( ).add( desktopScrollPane( ), BorderLayout.CENTER );

		// Add SplitPane
		sidepanel( new VModelSidePanel( ) );
		splitpane( ).setLeftComponent( modeler( ) );
		splitpane( ).setRightComponent( sidepanel( ) );
		frame( ).getContentPane( ).add( splitpane( ), BorderLayout.CENTER );
		
		// Add StatusBar
		frame( ).getContentPane().add( statusbar( ), BorderLayout.SOUTH);
		
		// Add Menubar
//		menubar( ).menuWindow( ).addSeparator( );
//		menubar( ).menuWindow( ).add( modeler( ).modelsMenu( ) );
		frame( ).setJMenuBar( menubar( ) );
		
		if ( !classModels( ).isLeaf( ) ) sidepanel( ).add( classModels( ) );
		if ( !vModels( ).isLeaf( ) ) sidepanel( ).add( vModels( ) );
//		sidepanel( ).add( currentModel( ) );
		
		// Realize Current Project
//		realizeProject( );

		splitpane( ).setDividerLocation( frame( ).getSize( ).width - splitpane( ).getRightComponent().getMinimumSize().width - splitpane( ).getDividerSize() - 10 );
//		splitpane( ).setDividerLocation( splitpane( ).getRightComponent().getMinimumSize().width - splitpane( ).getDividerSize() - 10 );
		splitpane( ).getRightComponent( ).doLayout( );
		frame( ).setVisible( true );
		
		LoginWizard foo = new LoginWizard( frame( ), preferences( ), true );
		
		frame( ).setTitle( frame( ).getTitle( ) + " : " + preferences( ).getString( "USERID" ) );
		String projectfile = preferences( ).getString("PROJECT");
		if (!projectfile.equals("")) {
			loadProject( QRGutils.QRGroot( ) + PROJECTPATH + projectfile );
		} // end if
		realizeProject( );
		
		loadMyModels( );
		myProcesses( (Ontology.Category) Ontology.load( "myProcesses" ) );
		myEntities( (Ontology.Category) Ontology.load( "myEntities" ) );
		myAttributes( (Ontology.Category) Ontology.load( "myAttributes" ) );
		myLibraryTree( sidepanel( ).add( myLibrary( ) ) );
		if ( preferences( ).getBoolean( "LOGGED-IN-BEFORE" ) ) {
			splitpane( ).setDividerLocation( preferences( ).getInt( "DIVIDER-LOCATION" ) );
			splitpane( ).getRightComponent( ).doLayout( );
			if ( ! preferences( ).getBoolean( "ALLOW-EMPTY-DESKTOP" ) ) makeModel( );
		} else {
			preferences( ).set( "LOGGED-IN-BEFORE", true );
			makeModel( );
		} // end if else
		//VModelLogin foo = new VModelLogin( preferences( ) );
		//foo.setVisible( true );
	 	CMLio.save( QRGutils.QRGuserpath( ) + "base.cml", ontology( ) );
		XMLio.save( QRGutils.QRGuserpath( ) + "base.xml", ontology( ) );
		ontology( ).save( "base" );
		sidepanel().librarian().sound( preferences().getBoolean("SOUND") );
	} // end method
	
	public void loadMyModels ( ) {
		String path = QRGutils.makeUserPath( MODELDIR );
		File dir = null;
		Model mumble = null;
		String [] files = null;
		QRGfilefilter fileFilter = new QRGfilefilter( );
		dir = new File(path);
		dir.mkdirs();
		fileFilter.suffix( fileFilter.VModel );
		files = dir.list( fileFilter );
		for(int i = 0; i < files.length; i++) {
			mumble = (Model) Model.load( path + files[i] );
			myModels( ).add( mumble );
		} // for i
	} // method
	
	// From Modeler Class
	// -----------------------------------------------------------------------
	// Properties & Accessors
	// -------------------------------------------------------------------------
	protected static Vector listDataListeners = null;
	public static Vector listDataListeners ( ) {
		if ( listDataListeners == null ) listDataListeners = new Vector( );
		return( listDataListeners );
	} // reader
		
	protected static ComboModel comboModel = null;
	public static ComboModel comboModel ( ) {
		if ( comboModel == null ) comboModel = new ComboModel( );
		return( comboModel );
	} // reader
	public ComboModel comboModel ( ComboModel c ) { return( comboModel = c ); }

	protected static JComboBox openWindows = null;
	public JComboBox openWindows ( ) {
		if ( openWindows == null ) {
			openWindows = new JComboBox( comboModel( ) );
			openWindows.setRenderer( new ComboRenderer( ) );
			openWindows.setOpaque( true );
		} // end if
		return( openWindows );
	} // reader
		
	protected JToolBar toolbar = null;
	public JToolBar toolbar ( ) { 
		if ( toolbar == null ) {
			toolbar = new JToolBar( );
			toolbar.setFloatable(false);
		} // end if
		return( toolbar ); 
	} // reader

	protected JToolBar toolbar2 = null;
	public JToolBar toolbar2 ( ) { 
		if ( toolbar2 == null ) {
			toolbar2 = new JToolBar( );
			toolbar2.setFloatable(false);
		} // end if
		return( toolbar2 ); 
	} // reader

	protected JPanel toppanel = null;
	public JPanel toppanel ( ) { return( toppanel ); } 
	public JPanel toppanel ( JPanel j ) { 
		return( toppanel = j ); 
	} // writer toppanel

	protected JPanel topleftpanel = null;
	public JPanel topleftpanel ( ) { return( topleftpanel ); } 
	public JPanel topleftpanel ( JPanel j ) { 
		return( topleftpanel = j ); 
	} // writer topleftpanel

	protected JPanel toprightpanel = null;
	public JPanel toprightpanel ( ) { return( toprightpanel ); } 
	public JPanel toprightpanel ( JPanel j ) { 
		return( toprightpanel = j ); 
	} // writer toprightpanel

	protected static JDesktopPane desktop = new JDesktopPane( );
	public static JDesktopPane desktop ( ) { return( desktop ); } 
	public JDesktopPane desktop ( JDesktopPane j ) { 
		return( desktop = j ); 
	} // writer desktop

	protected static JScrollPane desktopScrollPane = new JScrollPane( );
	public static JScrollPane desktopScrollPane ( ) { return( desktopScrollPane ); } 
	public static JScrollPane desktopScrollPane ( JScrollPane j ) { 
		return( desktopScrollPane = j ); 
	} // writer desktopScrollPane

	protected static ModelFrame selectedWindow = null;
	public ModelFrame selectedWindow ( ) { return( selectedWindow ); }
	public ModelFrame selectedWindow ( ModelFrame w ) { 
		return( selectedWindow = w ); 
	} // writer
	
	protected static Model currentModel = null;
	public Model currentModel ( ) { return( currentModel ); }
	public Model currentModel ( Model m ) { 
		return( currentModel = m ); 
	} // writer
	
	// forrester, bond-graphs, shueller-murphy
	
	protected JButton coachButton = null;
	public JButton coachButton ( ) { 
		if ( coachButton == null ) {
			coachButton = new JButton(ImageCache.getImage( "coach-lb.gif" ) );
			coachButton.setToolTipText( "Coach" );
		} // end if
		return( coachButton ); 
	} // reader 

	protected JButton newModelButton = null;
	public JButton newModelButton ( ) {
		if ( newModelButton == null ) {
			newModelButton = new JButton( ImageCache.getImage( "newModel.gif" ) );
			newModelButton.setToolTipText( "New Model" ); 
			newModelButton.setEnabled( true );
			newModelButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						makeModel( );
					} // method
				}); // ActionListener
		} // end if
		return( newModelButton );
	} // reader
	
	protected JButton openButton = null;
	public JButton openButton ( ) {
		if ( openButton == null ) {
			openButton = new JButton( ImageCache.getImage( "open.gif" ) );
			openButton.setToolTipText( "Open" ); 
			openButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
//						Model m = currentModel( ).load( "label" );
						load( );
					} // method
				}); // ActionListener
		} // end if
		return( openButton );
	} // reader
	
	protected JButton saveButton = null;
	public JButton saveButton ( ) {
		if ( saveButton == null ) {
			saveButton = new JButton( ImageCache.getImage( "save.gif" ) );
			saveButton.setToolTipText( "Save" ); 
			saveButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						save( );
//						CMLio.save( currentModel( ).name( ), currentModel( ) );
//						currentModel( ).save( currentModel( ).name( ) );
					} // method
				}); // ActionListener
		} // end if
		return( saveButton );
	} // reader
	
	protected JButton printButton = null;
	public JButton printButton ( ) {
		if ( printButton == null ) {
			printButton = new JButton( ImageCache.getImage( "print.gif" ) );
			printButton.setToolTipText( "Print" ); 
		} // end if
		return( printButton );
	} // reader
	
	protected JButton printPreviewButton = null;
	public JButton printPreviewButton ( ) {
		if ( printPreviewButton == null ) {
			printPreviewButton = new JButton( ImageCache.getImage( "preview.gif" ) );
			printPreviewButton.setToolTipText( "Print Preview" ); 
			printPreviewButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						printPreview().show( );
					} // method
				}); // actionListener
		} // end if
		return( printPreviewButton );
	} // reader
	
	protected JButton undoButton = null;
	public JButton undoButton ( ) {
		if ( undoButton == null ) {
			undoButton = new JButton( ImageCache.getImage( "undo.gif" ) );
			undoButton.setToolTipText( "Undo" ); 
			undoButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						if ( currentModel( ) != null ) {
							ModelPane.Action action = selectedWindow( ).modelPane( ).undoAction( );
							if ( action != null ) {
								if ( action.action( ) == ModelPane.Action.ADD ) {
									Definition.DefInterface definition = (Definition.DefInterface) action.arguments( ).elementAt( 0 );
									Instance.InstInterface instance = (Instance.InstInterface) action.arguments( ).elementAt( 1 );
									int x = ((Integer) action.arguments( ).elementAt( 2 )).intValue( );;
									int y = ((Integer) action.arguments( ).elementAt( 3 )).intValue( );;
									PeerElement peer = (PeerElement) action.arguments( ).elementAt( 4 );
									Instance.InstInterface parent = (Instance.InstInterface) action.arguments( ).elementAt( 5 );
									delete( currentModel( ), instance );
									currentModel( ).log( "undo." + action.action( ), "element = " + instance.reference( ) );
								} /* else if ( action.action( ) == ModelPane.Action.ADDCONNECT ) {
									PeerElement elementInstance = (PeerElement) action.arguments( ).elementAt( 0 );
									Definition.DefInterface element = (Definition.DefInterface) action.arguments( ).elementAt( 1 );
									int x = ((Integer) action.arguments( ).elementAt( 2 ) ).intValue( );
									int y = ((Integer) action.arguments( ).elementAt( 3 ) ).intValue( );
									int orientation = ((Integer) action.arguments( ).elementAt( 4 ) ).intValue( );
									String independent = (String) action.arguments( ).elementAt( 5 );
									String dependent = (String) action.arguments( ).elementAt( 6 );
									if ( independent != null ) disconnectIndependent( element.id( ), independent );
									if ( dependent != null ) disconnectDependent( element.id( ), dependent );
									removeElement( elementInstance );
						((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
									currentModel( ).log( "undo." + action.action( ), "element = " + elementInstance.reference( ).id( ) );
								} */ else if ( action.action( ) == ModelPane.Action.REMOVE ) {
									ModelPane pane = ((ModelFrame) selectedWindow( )).modelPane( );
									pane.deselectAll( );
									Vector selectionVector = (Vector) action.arguments( ).elementAt( 0 );
									//Vector independentConnections = (Vector) action.arguments2( );
									//Vector dependentConnections = (Vector) action.arguments3( );
									//Vector relationshipConnections = (Vector) action.arguments4( );
									Instance.InstInterface candidate = null;
									//String target = null;
									//String source = null;
									//String relation = null;
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (Instance.InstInterface) enum.nextElement( );
										addInstances( currentModel( ), candidate.reference( ) );
										pane.componentpane().add( ( PeerElement ) candidate.peer( ) );
										pane.select( (PeerElement) candidate.peer( ), false );
									} // end for
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (Instance.InstInterface) enum.nextElement( );
										pane.select( (PeerElement) candidate.peer( ), true );
										currentModel( ).log( "undo." + action.action( ), "element = " + candidate.reference( ).id( ) );
									} // end for
								} /* else if ( action.action( ) == ModelPane.Action.MOVE ) {
									ElementPane pane = ((ModelFrame) selectedWindow( )).modelPane( );
									pane.deselectAll( );
									Vector selectionVector = (Vector) action.arguments( );
									PeerElement candidate = null;
									int oldx, newx, oldy, newy;
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement( );
										oldx = ((Integer) enum.nextElement( )).intValue( );
										oldy = ((Integer) enum.nextElement( )).intValue( );
										newx = ((Integer) enum.nextElement( )).intValue( );
										newy = ((Integer) enum.nextElement( )).intValue( );
										candidate.setPosition( oldx, oldy );
										pane.select( candidate, false );
//										currentModel( ).log( "undo." + action.action( ), "element = " + candidate.reference( ).id( ) );
									} // end for
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement( );
										oldx = ((Integer) enum.nextElement( )).intValue( );
										oldy = ((Integer) enum.nextElement( )).intValue( );
										newx = ((Integer) enum.nextElement( )).intValue( );
										newy = ((Integer) enum.nextElement( )).intValue( );
										pane.select( candidate, true );
									} // end for
								} else if ( action.action( ) == ModelPane.Action.CONNECT ) {
									String relationship = (String) action.arguments( ).elementAt( 0 );
									String independent = (String) action.arguments( ).elementAt( 1 );
									String dependent = (String) action.arguments( ).elementAt( 2 );
									if ( independent != null ) disconnectIndependent( relationship, independent );
									if ( dependent != null ) disconnectDependent( relationship, dependent );
									currentModel( ).log( "undo." + action.action( ), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent );
									selectedWindow( ).repaint( );
								} */ else if ( action.action( ) == ModelPane.Action.TWIST ) {
									PeerElement peer = (PeerElement) action.arguments( ).elementAt( 0 );
									if ( ( peer != null ) && ( peer.typep( RELATIONSHIP ) ) )
										peer.turn( );
									((ModelFrame) selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} else if ( action.action( ) == ModelPane.Action.FLIP ) {
									PeerElement peer = (PeerElement) action.arguments( ).elementAt( 0 );
									if ( ( peer != null ) && ( peer.typep( RELATIONSHIP ) ) )
										peer.flip( );
									((ModelFrame) selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} /* else if ( action.action( ) == ModelPane.Action.REVERSE ) {
									String id = (String) action.arguments( ).elementAt( 0 );
									Definition.DefInterface relationship = findDefinition( currentModel( ), id );
									if ( ( relationship != null ) && ( relationship.typep( RELATIONSHIP ) ) )
										relationship.reference( ).reverse( );
									((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} */ // end if else if else ....
							} // end if
						} // end if
						updateWidgets( );
					} // method
				}); // actionListener
		} // end if
		return( undoButton );
	} // reader

// 

	protected JButton redoButton = null;
	public JButton redoButton ( ) {
		if ( redoButton == null ) {
			redoButton = new JButton( ImageCache.getImage( "redo.gif" ) );
			redoButton.setToolTipText( "Redo" ); 
			redoButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						if ( currentModel( ) != null ) {
							ModelPane.Action action = selectedWindow( ).modelPane( ).redoAction( );
							if ( action != null ) {
								if ( action.action( ) == ModelPane.Action.ADD ) {
									Definition.DefInterface definition = (Definition.DefInterface) action.arguments( ).elementAt( 0 );
									Instance.InstInterface instance = (Instance.InstInterface) action.arguments( ).elementAt( 1 );
									int x = ((Integer) action.arguments( ).elementAt( 2 )).intValue( );;
									int y = ((Integer) action.arguments( ).elementAt( 3 )).intValue( );;
									PeerElement peer = (PeerElement) action.arguments( ).elementAt( 4 );
									Instance.InstInterface parent = (Instance.InstInterface) action.arguments( ).elementAt( 5 );
									add( currentModel( ), instance, parent, x, y );
//									delete( currentModel( ), instance );
//									currentModel( ).log( "undo." + action.action( ), "element = " + instance.reference( ) );
								/// 
//
//									PeerElement elementInstance = (PeerElement) action.arguments( ).elementAt( 0 );
//									currentModel( ).add( elementInstance.reference( ) ); 
//									addElement( elementInstance, elementInstance.getLocation( ).x, elementInstance.getLocation( ).y, false );
//									currentModel( ).log( "redo." + action.action( ), "element = " + elementInstance.reference( ).id( ) );
								}  /* else if ( action.action( ) == ModelPane.Action.ADDCONNECT ) {
									PeerElement elementInstance = (PeerElement) action.arguments( ).elementAt( 0 );
									Definition.DefInterface element = (Definition.DefInterface) action.arguments( ).elementAt( 1 );
									int x = ((Integer) action.arguments( ).elementAt( 2 ) ).intValue( );
									int y = ((Integer) action.arguments( ).elementAt( 3 ) ).intValue( );
									int orientation = ((Integer) action.arguments( ).elementAt( 4 ) ).intValue( );
									String independent = (String) action.arguments( ).elementAt( 5 );
									String dependent = (String) action.arguments( ).elementAt( 6 );
									currentModel( ).add( elementInstance.reference( ) ); 
									addElement( elementInstance, elementInstance.getLocation( ).x, elementInstance.getLocation( ).y, false );
									if ( independent != null ) connectIndependent( independent, element.id( ) );
									if ( dependent != null ) connectDependent( dependent, element.id( ) );
						((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
									currentModel( ).log( "redo." + action.action( ), "element = " + elementInstance.reference( ).id( ) );
								} else if ( action.action( ) == ModelPane.Action.REMOVE ) {
									ElementPane pane = ((ModelFrame) selectedWindow( )).modelPane( );
									pane.deselectAll( );
									Vector selectionVector = (Vector) action.arguments( );
									Vector independentConnections = (Vector) action.arguments2( );
									Vector dependentConnections = (Vector) action.arguments3( );
									Vector relationshipConnections = (Vector) action.arguments4( );
									String target = null;
									String source = null;
									String relation = null;
									PeerElement candidate = null;
									for (Enumeration enum = independentConnections.elements( ) ; enum.hasMoreElements() ;) {
										source = (String) enum.nextElement( );
										target = (String) enum.nextElement( );
										disconnect( target, source );
									} // end for
									for (Enumeration enum = dependentConnections.elements( ) ; enum.hasMoreElements() ;) {
										source = (String) enum.nextElement( );
										target = (String) enum.nextElement( );
										disconnect( target, source );
									} // end for
									for (Enumeration enum = relationshipConnections.elements( ) ; enum.hasMoreElements() ;) {
										source = (String) enum.nextElement( );
										target = (String) enum.nextElement( );
										relation = (String) enum.nextElement( );
										disconnect( source, relation );
										disconnect( target, relation );
									} // end for
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement( );
										currentModel( ).remove( candidate.reference( ) );
										removeElement( candidate );
										currentModel( ).log( "redo." + action.action( ), "element = " + candidate.reference( ).id( ) );
									} // end for
								} else if ( action.action( ) == ModelPane.Action.MOVE ) {
									ElementPane pane = ((ModelFrame) selectedWindow( )).modelPane( );
									pane.deselectAll( );
									Vector selectionVector = (Vector) action.arguments( );
									PeerElement candidate = null;
									int oldx, newx, oldy, newy;
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement( );
										oldx = ((Integer) enum.nextElement( )).intValue( );
										oldy = ((Integer) enum.nextElement( )).intValue( );
										newx = ((Integer) enum.nextElement( )).intValue( );
										newy = ((Integer) enum.nextElement( )).intValue( );
										candidate.setPosition( newx, newy );
										pane.select( candidate, false );
//										currentModel( ).log( "undo." + action.action( ), "element = " + candidate.reference( ).id( ) );
									} // end for
									for (Enumeration enum = selectionVector.elements( ) ; enum.hasMoreElements() ;) {
										candidate = (PeerElement) enum.nextElement( );
										oldx = ((Integer) enum.nextElement( )).intValue( );
										oldy = ((Integer) enum.nextElement( )).intValue( );
										newx = ((Integer) enum.nextElement( )).intValue( );
										newy = ((Integer) enum.nextElement( )).intValue( );
										pane.select( candidate, true );
									} // end for
								} else if ( action.action( ) == ModelPane.Action.CONNECT ) {
									String relationship = (String) action.arguments( ).elementAt( 0 );
									String independent = (String) action.arguments( ).elementAt( 1 );
									String dependent = (String) action.arguments( ).elementAt( 2 );
									if ( independent != null ) connectIndependent( independent, relationship );
									if ( dependent != null ) connectDependent( dependent, relationship );
									currentModel( ).log( "redo." + action.action( ), "relationship= " + relationship + " independent=" + independent + " dependent=" + dependent );
									selectedWindow( ).repaint( );
								} else if ( action.action( ) == ModelPane.Action.TWIST ) {
									String id = (String) action.arguments( ).elementAt( 0 );
									Definition.DefInterface relationship = Definition.findElement( id );
									if ( ( relationship != null ) && ( relationship.typep( RELATIONSHIP ) ) )
										relationship.reference( ).twist( );
									((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} else if ( action.action( ) == ModelPane.Action.FLIP ) {
									String id = (String) action.arguments( ).elementAt( 0 );
									Definition.DefInterface relationship = Definition.findElement( id );
									if ( ( relationship != null ) && ( relationship.typep( RELATIONSHIP ) ) )
										relationship.reference( ).flip( );
									((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} else if ( action.action( ) == ModelPane.Action.REVERSE ) {
									String id = (String) action.arguments( ).elementAt( 0 );
									Definition.DefInterface relationship = Definition.findElement( id );
									if ( ( relationship != null ) && ( relationship.typep( RELATIONSHIP ) ) )
										relationship.reference( ).reverse( );
									((ModelFrame) Modeler.self( ).selectedWindow( )).modelPane( ).drawpane( ).repaint( );
								} */ // end if else if else if ....
							} // end if
						} // end if
						updateWidgets( );
					} // method
				}); // actionListener
		} // end if
		return( redoButton );
	} // reader
	
	protected JButton selectButton = null;
	public JButton selectButton ( ) {
		if ( selectButton == null ) {
			selectButton = new JButton( ImageCache.getImage( "hand.gif" ) );
			selectButton.setToolTipText( "Selection Tool" ); 
			selectButton.addActionListener( new ActionListener( ) {
					public void actionPerformed ( ActionEvent e ) {
						Librarian.selectedTree( ).clearSelection( );
						Librarian.selectedDefinition( null );
//						Librarian.selectedOntology( ).selectedDefinition( null );
					} // method
				}); // actionListener
		} // end if
		return( selectButton );
	} // reader
	
	protected JButton copyButton = null;
	public JButton copyButton ( ) {
		if ( copyButton == null ) {
			copyButton = new JButton( ImageCache.getImage( "copy.gif" ) );
			copyButton.setToolTipText( "Copy" ); 
		} // end if
		return( copyButton );
	} // reader
	
	protected JButton cutButton = null;
	public JButton cutButton ( ) {
		if ( cutButton == null ) {
			cutButton = new JButton( ImageCache.getImage( "cut.gif" ) );
			cutButton.setToolTipText( "Cut" ); 
		} // end if
		return( cutButton );
	} // reader
	
	protected JButton pasteButton = null;
	public JButton pasteButton ( ) {
		if ( pasteButton == null ) {
			pasteButton = new JButton( ImageCache.getImage( "paste.gif" ) );
			pasteButton.setToolTipText( "Paste" ); 
		} // end if
		return( pasteButton );
	} // reader
	
	protected JButton groupButton = null;
	public JButton groupButton ( ) {
		if ( groupButton == null ) {
			groupButton = new JButton( ImageCache.getImage( "group.gif" ) );
			groupButton.setToolTipText( "Group" ); 
		} // end if
		return( groupButton );
	} // reader
	
	
	// Methods
	// -------------------------------------------------------------------------
	protected JFileChooser fileDialog = null;
	public JFileChooser fileDialog ( ) {
		if (fileDialog == null) {
			fileDialog(new JFileChooser() {
				public void approveSelection() {
					boolean approve = false;
					String filename = getSelectedFile().getName();
					String suffix = "";
					String preferredSuffix = "";
					javax.swing.filechooser.FileFilter filter = getFileFilter();
					if (filter == modelFileFilter()) preferredSuffix = "." + VMODEL_SUFFIX;
					else if (filter == jpgFileFilter()) preferredSuffix = "." + JPEG_SUFFIX;
					else if (filter == tifFileFilter()) preferredSuffix = "." + TIFF_SUFFIX;
					else if (filter == htmlFileFilter()) preferredSuffix = "." + HTML_SUFFIX;
					suffix = filename.substring(filename.length() - preferredSuffix.length(), filename.length());
					if (suffix.equalsIgnoreCase(preferredSuffix)) {
						if (!getApproveButtonText().equalsIgnoreCase("OPEN")) { // assume save dialog
							if (!getSelectedFile().exists()) approve = true;
							else approve = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The file, " + filename + ", already exists.\n Do you want to overwrite it?", "Alert! File Exists", JOptionPane.YES_NO_OPTION));
						} else approve = true;
					} else {
						JOptionPane.showMessageDialog(null, "Your filename must end with " + preferredSuffix, "Alert! Improper Filename.", JOptionPane.ERROR_MESSAGE);
					} // end if preferredSuffix
					if (approve) super.approveSelection();
				} // method approveSelection
			}); // anonymous subclass
			fileDialog.setFileHidingEnabled(true);
//			fileDialog.setFileSelectionMode(JFileChooser.FILES_ONLY);
			fileDialog.setFileSelectionMode(JFileChooser.FILES_AND_DIRECTORIES);
			fileDialog.setMultiSelectionEnabled(false);
		} // if fileDialog
		return( fileDialog );
	} // reader fileDialog
	public JFileChooser fileDialog ( JFileChooser f ) { return( fileDialog = f ); }
	
	protected VModelFileFilter modelFileFilter = null;
	public VModelFileFilter modelFileFilter ( ) {
		if (modelFileFilter == null) modelFileFilter(new VModelFileFilter(VMODEL_SUFFIX,"VModel File"));
		return( modelFileFilter );
	} // reader modelFileFilter
	public VModelFileFilter modelFileFilter ( VModelFileFilter f ) { return( modelFileFilter = f ); }
	
	protected VModelFileFilter jpgFileFilter = null;
	public VModelFileFilter jpgFileFilter ( ) {
		if (jpgFileFilter == null) jpgFileFilter(new VModelFileFilter(JPEG_SUFFIX,"JPEG File"));
		return( jpgFileFilter );
	} // reader jpgFileFilter
	public VModelFileFilter jpgFileFilter ( VModelFileFilter f ) { return( jpgFileFilter = f ); }
	
	protected VModelFileFilter tifFileFilter = null;
	public VModelFileFilter tifFileFilter ( ) {
		if (tifFileFilter == null) tifFileFilter(new VModelFileFilter(TIFF_SUFFIX,"TIFF File"));
		return( tifFileFilter );
	} // reader tifFileFilter
	public VModelFileFilter tifFileFilter ( VModelFileFilter f ) { return( tifFileFilter = f ); }
	
	protected VModelFileFilter htmlFileFilter = null;
	public VModelFileFilter htmlFileFilter ( ) {
		if (htmlFileFilter == null) htmlFileFilter(new VModelFileFilter(HTML_SUFFIX,"HTML File"));
		return( htmlFileFilter );
	} // reader htmlFileFilter
	public VModelFileFilter htmlFileFilter ( VModelFileFilter f ) { return( htmlFileFilter = f ); }
	
	protected VModelFileFilter cmlFileFilter = null;
	public VModelFileFilter cmlFileFilter ( ) {
		if (cmlFileFilter == null) cmlFileFilter(new VModelFileFilter(CML_SUFFIX, "Compositional Modeling Language File"));
		return( cmlFileFilter );
	} // reader cmlFileFilter
	public VModelFileFilter cmlFileFilter ( VModelFileFilter f ) { return( cmlFileFilter = f ); }
	


	public int save ( ) {
//	 	selectedModel().savePrepAux( selectedModel().modelElement() );
    	return( save( currentModel().getBoolean("SAVEDONCE") ));
    } // method save

	public int save ( boolean savedB4 ) {
		if (!savedB4) { 
			fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
			fileDialog.setDialogTitle("Save VModel File");
			fileDialog.setApproveButtonText("Save");
			String filename = currentModel( ).name( );
			if (! filename.toUpperCase().endsWith(".VMF")) filename = QRGutils.replaceExtension(filename, "vmf");
//			String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
			String dir = QRGutils.QRGuserpath() + MODELSPATH;
			String filepath = dir + filename;
			File file = new File(filepath);
			Image pic = null;
			int result = 0;
			boolean loop = true;
			fileDialog().setFileFilter(modelFileFilter());
			fileDialog().setSelectedFile(file);
			fileDialog().setCurrentDirectory(file);
			fileDialog().rescanCurrentDirectory();
			//filedialog.setModal(true);
			result = fileDialog().showDialog( frame( ), null );
			if( result == JFileChooser.APPROVE_OPTION ) {
				file = fileDialog.getSelectedFile( );
				filename = file.getName( );
				if(filename == null) {
//					( (JComponent) (((Model) currentModel( )).reference( ) ) ).requestFocus( );
					return( -1 );
				} else {
					filename = QRGutils.addExtension(filename, "vmf");
					dir = file.getParent( ) + "/";
					filepath = dir + filename;
					( (ModelFrame) selectedWindow( ) ).setTitle( filename );
					currentModel().name( filename );
					currentModel().set("FILEPATH", filepath);
					currentModel().set("FILE", filename);
					currentModel().set("PATH", dir);
					return( save( filepath ) );
				} // end if filename
			} // end if APPROVED
		}// if savedOnce
		return( save( currentModel( ).getString( "FILEPATH" ) ) );
	} // method save
	
	public int save ( String filename ) {
		boolean tsavedOnce = currentModel( ).getBoolean( "SAVEDONCE" );
		int result = -1;
		currentModel( ).set( "SAVEDONCE", true );
		( (ModelFrame) selectedWindow( ) ).setTitle( currentModel( ).getString( "FILE" ) );
		currentModel().name( currentModel( ).getString( "FILE" ) );
		((ModelFrame) selectedWindow( )).dirty(false);
		currentModel().save( filename );
		CMLio.save( QRGutils.replaceExtension(filename, CML_SUFFIX), currentModel( ) );
		XMLio.save( QRGutils.replaceExtension(filename, XML_SUFFIX), currentModel( ) );
//						currentModel( ).save( currentModel( ).name( ) );
//		((ModelFrame) selectedWindow( )).dirty(false);
		result = 0;
		return(result);
	} // method save	

	public Model.Interface load ( ) {
		fileDialog( ).setDialogType( JFileChooser.OPEN_DIALOG );
		fileDialog( ).setDialogTitle( "Open VModel File" );
		fileDialog( ).setApproveButtonText( "Open" );
		String filename = "";
		String dir = QRGutils.QRGuserpath() + MODELSPATH;
		String filepath = dir + filename;
		File file = new File( filepath );
		Image pic = null;
		int result = 0;
		boolean loop = true;
		fileDialog( ).setFileFilter( modelFileFilter( ) );
		fileDialog( ).setSelectedFile( file );
		fileDialog( ).setCurrentDirectory( file );
		fileDialog( ).rescanCurrentDirectory( );
//		filedialog.setModal(true);
		
//		result = fileDialog().showOpenDialog((Component) frame());
		result = fileDialog( ).showDialog( frame( ), null );
		if ( result == JFileChooser.APPROVE_OPTION ) {
			file = fileDialog( ).getSelectedFile( );
			filename = file.getName( );
			if( filename != null ) {
				filename = QRGutils.addExtension( filename, "vmf" );
				dir = file.getParent( ) + "/";
				return( load( dir, filename ) );
			} // end if filename
		} // end APPROVED
		return( null );
	} // method 

	public Model.Interface load ( String dir, String filename ) {
		Model.Interface result = null;
		result = load( dir + filename );
		return( result );
	} // method 
	
	public Model.Interface load ( String filepath ) {
		Model.Interface result = null;
		result = (Model.Interface) Model.load( filepath );
		if (result != null){
			 result.set( "SAVEDONCE", true );
			 add( result );
		} // end if result
		return( result );
	} // method 
	
	// Close
	// -----------------------------------------------------------------------
//	public void close ( ) {
//		int n = 0;
//		if (closeAllModels() != -1) system().quit(0);
//	} // method close

	public int closeAllModels ( ) {
		JInternalFrame [ ] frames = desktop( ).getAllFrames( );
		ModelFrame frame = null;
		for(int i = frames.length - 1; i >= 0; i--) {
			frame = (ModelFrame) frames[ i ];
			frame.select( true );
			if ( closeModel( frame ) == -1 ) return( -1 );
		} // for i
		return( 0 );
	} // method close


	public int closeModel ( ) {
		return( closeModel( (ModelFrame) selectedWindow( ), false ) );
	} // method close

	public int closeModel( ModelFrame frame, boolean aux ) {
		int result = 0;
		if ( aux ) result = closeModelAux( frame );
		else result= closeModel( frame );
		return( result );
	} // method

	public int closeModel( ModelFrame frame ) {
		int result = 0;
		Model model = (Model) frame.model( );
		if ( frame.dirty( ) ) {
			boolean continuep = (JOptionPane.YES_OPTION == JOptionPane.showConfirmDialog(null, "The model, " + model.name( ) + ", has not been saved.\n Do you want to close it anyway?", "Alert! Model Not Saved.", JOptionPane.YES_NO_OPTION));
			if ( ! continuep ) result = -1;
		} // end if dirty
		if ( result == 0 ) closeModelAux( frame );
		return( result );
	} // method closeModel
	
	public int closeModelAux( ModelFrame frame ) {
		int result = 0;
		Model model = (Model) frame.model( );
//		models().removeElement(model);
		VModelMenuBar.menuWindowModels().remove( frame.menuItem( ) );
		frame.close( );
		frame.dispose( );
		if ( desktop( ).getAllFrames( ).length == 0 ) {
			selectedWindow( null );
			currentModel( null );
			comboModel( null );
			openWindows( ).setModel( comboModel( ) );
			openWindows.setRenderer( new ComboRenderer( ) );
			frame.menuItem( ).doClick( );
	   	updateWidgets( );
//			modeChange( null );
//			enableWidgets(-1);
			if ( ! preferences( ).getBoolean("ALLOW-EMPTY-DESKTOP")) makeModel();
		} else {
			if ( model == currentModel( ) ) {
				( (ModelFrame) desktop( ).getAllFrames( )[ 0 ] ).select( true );
			} // end if model
		} // end if size else
		repaint( );
		if ( desktop( ).getAllFrames( ).length > 0 )
			( (ModelFrame) desktop( ).getAllFrames( )[ 0 ] ).menuItem( ).setSelected( true );
		return(result);
	} // method closeModel
	
	// Methods
	// -------------------------------------------------------------------------
	// Load specified controller class
	protected ButtonGroup menuButtonGroup = null;
	public ButtonGroup menuButtonGroup ( ) {
		if ( menuButtonGroup == null ) menuButtonGroup = new ButtonGroup( );
		return( menuButtonGroup );
	} // method
	
	protected static int nextWindowLocationX = 10;
	protected static int nextWindowLocationY = 10;

	public Dimension nextWindowSize ( ) {
		Dimension result = QRGutils.calcWindowSize( desktopScrollPane( ).getSize( ) );
		return( result );
	} // method

	public Point nextWindowLocation ( ) {
		Point result = new Point( nextWindowLocationX, nextWindowLocationY );
		int width = desktopScrollPane( ).getSize( ).width - 10 - nextWindowSize( ).width;
		int height = desktopScrollPane( ).getSize( ).height - 10 - nextWindowSize( ).height;
		nextWindowLocationX += 10;
		nextWindowLocationY += 10;
		if ( nextWindowLocationX > width ) nextWindowLocationX = 5;
		if ( nextWindowLocationY > height ) nextWindowLocationY = 5;
		return( result );
	} // method
	
	public void add ( Model.Interface model ) {
		ModelFrame window =  new ModelFrame( model );
		window.setLocation( nextWindowLocation( ) );
		window.setSize(nextWindowSize( ));
		window.setPreferredSize(window.getSize());
		if (preferences().getBoolean("MAXIMIZE-NEW-MODELS")) {
//			try {window.setMaximum(true);}
//			catch (Exception e) {}
//			if (QRGutils.detectPlatform() == MACINTOSH) window.reshape(0, 0, desktop().getWidth(), desktop( ).getHeight( ));
			window.reshape(0, 0, desktop().getWidth(), desktop( ).getHeight( ));
		} // end if maximized
		window.setVisible(true);
		window.dirty( true );
		VModelMenuBar.menuWindowModels( ).add( window.menuItem( ) );
		menuButtonGroup( ).add( window.menuItem( ) );
		desktop( ).add(window);
		comboModel( null );
		openWindows( ).setModel( comboModel( ) );
		window.menuItem( ).doClick( );
	} // method
	
	public void tileModelFrames() {
		tileModelFrames(desktop().getAllFrames());
	} // method tileModelFrames

	public void tileModelFrames(Container frames[]) {
		int counter = frames.length;
		int rows = 0;
		int cols = 0;
		int extra = 0;
		int width = 0;
		int height = 0;
		int r = 0;
		int c = 0;
		int xoffset = 0;
		int yoffset = 0;
		int length = frames.length;
		int desktopheight = 0;
		JInternalFrame selectedFrame = null;
		for (int i = 0; i < length; i++) {
			if (((JInternalFrame)frames[i]).isSelected()) selectedFrame = (JInternalFrame) frames[i];
		} // for i
		rows = (int)Math.sqrt(counter);
		cols = counter/rows;
		extra = counter - rows * cols;
		if (extra != 0) {
			counter++;
			rows = (int)Math.sqrt(counter);
			cols = counter/rows;
			extra = counter - rows * cols;
		} // end if extra
		width = desktop().getWidth()/cols;
		desktopheight = desktop().getHeight();
		height = desktopheight/rows;
		for (int i = 0; i < length; i++) {
			if (width < ((JInternalFrame) frames[i]).getContentPane( ).getMinimumSize( ).width)
				width = ((JInternalFrame) frames[i]).getContentPane( ).getMinimumSize( ).width + 10;
			if (height < ((JInternalFrame) frames[i]).getMinimumSize( ).height)
				height = ((JInternalFrame) frames[i]).getMinimumSize( ).height + 32;
		} // for i
		for (int j = 0; j < length; j++) {
				try {
					((JInternalFrame)frames[j]).setMaximum(false);
					((JInternalFrame)frames[j]).setIcon(false);
					((JInternalFrame)frames[j]).reshape(c*width, r*height, width, height);
					r++;
					if (r == rows) {
						r = 0;
						c++;
						if (c == cols - extra) {
							rows++;
							height = desktopheight/rows;
						}
					}
				} catch (Exception pve) {
				pve.printStackTrace();
				}
		} // for j
		if ( selectedFrame != null ) {
			try {
				selectedFrame.show( );
				selectedFrame.toFront( );
				selectedFrame.setVisible( true );
				selectedFrame.setSelected( true );
//				( (ModelFrame) selectedFrame).select( true );
			} catch ( PropertyVetoException pve ) {}
		} // end if
	} // method tileWindows

	public void cascadeModelFrames() { 
		cascadeModelFrames( desktop( ).getAllFrames( ) );
	} // method cascadeModelFrames

	public void cascadeModelFrames(Container frames[]) {
		int fDistance = 20;
		int x = 10;
		int y = 10;
		int width = 0;
		int height = 0;
		int xoffset = 0;
		int yoffset = 0;
		int desktopheight = 0;
		int length = frames.length;
		width = desktop().getWidth()/2;
		desktopheight = desktop().getHeight();
		height = desktopheight/2;
		JInternalFrame selectedFrame = null;
		for (int i = 0; i < length; i++) {
			if (((JInternalFrame)frames[i]).isSelected()) selectedFrame = (JInternalFrame) frames[i];
			if (width < ((JInternalFrame) frames[i]).getContentPane( ).getMinimumSize( ).width)
				width = ((JInternalFrame) frames[i]).getContentPane( ).getMinimumSize( ).width + 10;
			if (height < ((JInternalFrame) frames[i]).getMinimumSize( ).height)
				height = ((JInternalFrame) frames[i]).getMinimumSize( ).height + 32;
		} // for i
		for (int i = frames.length - 1; i >= 0; i--) {
				try {
					((JInternalFrame)frames[i]).setMaximum(false);
					((JInternalFrame)frames[i]).setIcon(false);
					((JInternalFrame)frames[i]).reshape(xoffset + x,yoffset + y, width, height);
					x+=fDistance;
					y+=fDistance;
					if (x > width)
					x += - width;
					if (y > height)
					y += - height;
				} catch (Exception pve) {
					pve.printStackTrace();
				} // end try - catch
		} // for i
		if ( selectedFrame != null ) {
			try {
				selectedFrame.show( );
				selectedFrame.toFront( );
				selectedFrame.setVisible( true );
				selectedFrame.setSelected( true );
//				( (ModelFrame) selectedFrame ).select( true );
			} catch ( PropertyVetoException pve ) {}
		} // end if
	} // method cascadeWindows
	
	public Instance.InstInterface makeInstance ( Model.Interface model, Reference.RefInterface reference ) {
		Instance result = (Instance) super.makeInstance( model, reference );
		if ( result != null ) result.peer( new PeerElement( model, result ) );
//		QRGutils.debug( "Classic.makeInstance", "result=" + result + " reference=" + reference );
		return( result );
	} // method
	
//	public Instance.InstInterface add ( Model.Interface model, Definition.DefInterface element ) {
//		Instance.InstInterface result = super.add( model, element );
//		return( result );
//	} // method

	public Instance.InstInterface addDefinition ( Model.Interface model, Instance.InstInterface instance, Definition.DefInterface element ) {
		Instance.InstInterface result = super.addDefinition( model, instance, element );
		return( result );
	} // method

	public Instance.InstInterface add ( Model.Interface model, Instance.InstInterface instance, Instance.InstInterface parent, int x, int y ) {
		return( instance );
	} // method

	public Instance.InstInterface addDefinition ( Model.Interface model, Definition.DefInterface element, int clickX, int clickY, boolean clearSelectedElement ) {
		Instance grumble = (Instance) addDefinition( model, null, element );
		PeerElement peer = (PeerElement) grumble.peer( );
		String grrr = "";
		Instance childpeer = null;
		JComponent component = peer;
		component.setVisible( false );
		peer.scale( ((ModelFrame) selectedWindow( )).modelPane( ).scale( ) );
		((ModelFrame) selectedWindow( )).modelPane( ).componentpane( ).add( component );
		peer.setPosition( clickX, clickY );
		component.setVisible( true );
		((ModelFrame) selectedWindow( )).modelPane( ).scale( ((ModelFrame) selectedWindow( )).modelPane( ).scale( ) );
		for( Enumeration enum = peer.childInstances( ).elements( ); enum.hasMoreElements( ); ) {
			grrr = (String) enum.nextElement( );
//QRGutils.debug( "Classic", "add", "element=" + element + " grrr=" + grrr );			
			childpeer = (Instance) model.findInstance( grrr );
			if ( childpeer != null ) {
				((ModelFrame) selectedWindow( )).modelPane( ).componentpane( ).add( (Component) childpeer.peer( ) );
				((Component) childpeer.peer( )).setVisible( true );
				((PeerElement) childpeer.peer( )).setPosition( clickX - childpeer.reference( ).getInt( "X" ), clickY - childpeer.reference( ).getInt( "Y" ) );
				if ( childpeer.typep( RELATIONSHIP ) ) ((PeerElement) childpeer.peer( )).orientation( childpeer.reference( ).getInt( "ROTATION" ) );
			} // end if
		} // end for
		((ModelFrame) selectedWindow( )).modelPane( ).selectOne( peer );
		if ( clearSelectedElement ) {
			Librarian.selectedTree( ).clearSelection( );
			Librarian.selectedDefinition( null );
//			Librarian.selectedOntology( ).selectedDefinition( null );
		} // end if		
		Vector undoArgs = new Vector( );
		undoArgs.addElement( element );
		undoArgs.addElement( grumble );
		undoArgs.addElement( new Integer( clickX ) );
		undoArgs.addElement( new Integer( clickY ) );
		undoArgs.addElement( peer );
		undoArgs.addElement( grumble.parent( ) );
		((ModelFrame) selectedWindow( )).modelPane( ).doAction( ModelPane.Action.ADD, undoArgs );
		selectedWindow( ).dirty(true);
		return( grumble );
	} // method
	
	public void removeInstance ( Model.Interface model, Instance.InstInterface instance ) {
QRGutils.debug( "Classic.removeInstance", "instance=" + instance + " : " + instance.name( ) );
		super.removeInstance(model, instance);
		selectedWindow( ).modelPane( ).componentpane( ).remove( (PeerElement) instance.peer( ) );
	} // end if
	
// need to reduce the list to topmost elements being deleted. Selected children will be deleted recursively.
// if parents of targeted elements are not in model library, they need to be subtyped and put there.
// remove targeted elements from subtypes
// remove targeted element instances and children from model
	public void delete ( ) {
		Vector selectedTargets = new Vector( );
		Vector targets = new Vector( );
		Vector alphaTargets = new Vector( );
		Vector relationshipTargets = new Vector( );
		Vector entityTargets = new Vector( );
		PeerElement peer = null;
		Instance instance = null;
		Instance input = null;
		Instance output = null;
		PeerElement peerchild = null;
		Model.Interface model = currentModel( );
		for( Enumeration enum = selectedComponents( ).elements( ); enum.hasMoreElements( ); ) {
			peer = (PeerElement) enum.nextElement( );
			targets.addElement( peer.instance( ) );
			selectedTargets.addElement( peer.instance( ) );
		} // end for
		((ModelFrame) selectedWindow( )).modelPane( ).deselectAll( );
		for( Enumeration enum = targets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if ((instance != null) && ( ! targets.contains( instance.parent( ) ) ) ) {
				alphaTargets.addElement( instance );
				if ( instance.typep( RELATIONSHIP ) ) relationshipTargets.addElement( instance );
				else entityTargets.addElement( instance );
			} // end if
		} // end for
		
		for( Enumeration enum = alphaTargets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if ((instance != null) && ( instance.parent( ) != null ) && ( ! instance.parent( ).typep( STRUCTURE ) ) ) {
				if ( model.findLocal( instance.parent( ).definitionID( ) ) == null )
					subtype( model, instance.parent( ), instance.parent( ).name( ) + "???" );
//					subtype( model, instance, instance.name( ) + "???" );
			} // end if
		} // end for
		
		for( Enumeration enum = relationshipTargets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if (instance != null ) {
				input = (Instance) model.findInstance( instance.input( ) );
				output = (Instance) model.findInstance( instance.output( ) );
				if ( output != null ) {
					if (( instance.typep( HASATTRIBUTE ) || instance.typep( HASPARTICIPANT ) ) && 
							( ! entityTargets.contains( output ) ) ) {
						move( model, null, output );
//						alphaTargets.addElement( output );
//						entityTargets.addElement( output );
//						if ( ! targets.contains( output ) ) targets.addElement( output );
					} // end if
				} // end if
				if ( input != null ) {
					if (( instance.typep( PARTICIPATESIN ) ) && 
							( ! entityTargets.contains( input ) ) ) {
						move( model, null, input );
//						alphaTargets.addElement( input );
//						entityTargets.addElement( input );
//						if ( ! targets.contains( input ) ) targets.addElement( input );
					} // end if
				} // end if
			} // end if
		} // end for
		
		for( Enumeration enum = entityTargets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if (instance != null ) {
				for( Enumeration c = instance.inputs( ).elements( ); c.hasMoreElements( ); ) {
					String foo = (String) c.nextElement( );
					Instance.InstInterface bar = model.findInstance( foo );
					if ( bar.typep( HASATTRIBUTE ) || bar.typep( HASPARTICIPANT ) ) {
						targets.removeElement( bar );
						targets.addElement( bar );
						alphaTargets.removeElement( bar );
						alphaTargets.addElement( bar );
						relationshipTargets.removeElement( bar );
						relationshipTargets.addElement( bar );
					} // end if
				} // end for
				for( Enumeration c = instance.outputs( ).elements( ); c.hasMoreElements( ); ) {
					String foo = (String) c.nextElement( );
					Instance.InstInterface bar = model.findInstance( foo );
					if ( bar.typep( PARTICIPATESIN ) ) {
						targets.removeElement( bar );
						targets.addElement( bar );
						alphaTargets.removeElement( bar );
						alphaTargets.addElement( bar );
						relationshipTargets.removeElement( bar );
						relationshipTargets.addElement( bar );
					} // end if
				} // end for
			} // end if
		} // end for
		for( Enumeration enum = alphaTargets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if ( instance != null ) addChildInstancesToList( model, targets, instance );
		} // end for
		Vector result = new Vector( );
		for( Enumeration enum = alphaTargets.elements( ); enum.hasMoreElements( ); ) {
//		for( Enumeration enum = selectedTargets.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if ( instance != null ) {
				((ModelFrame) selectedWindow( )).modelPane( ).select( (PeerElement) instance.peer( ), false );
				result.addAll( deleteDefinition( model, instance ) );
			} // end if
		} // end for
		for( Enumeration enum = result.elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) enum.nextElement( );
			if (( instance != null ) && (instance.peer( ) != null ) ) {
				if ( ((PeerElement) instance.peer( )).getParent( ) != null ) 
					((PeerElement) instance.peer( )).getParent( ).remove( ((PeerElement) instance.peer( )) );
				((PeerElement) instance.peer( )).setVisible(false);
			} // end if
		} // end for
		QRGutils.debug( "Classic", "delete", "selectedTargets=" + targets );
		QRGutils.debug( "Classic", "delete", "targets=" + targets );
		QRGutils.debug( "Classic", "delete", "alphaTargets=" + alphaTargets );
		QRGutils.debug( "Classic", "delete", "relationshipTargets=" + relationshipTargets );
		QRGutils.debug( "Classic", "delete", "entityTargets=" + entityTargets );
		Vector undoArgs = new Vector( );
		undoArgs.addElement( alphaTargets );
		undoArgs.addElement( result );
		undoArgs.addElement( targets );
		((ModelFrame) selectedWindow( )).modelPane( ).doAction( ModelPane.Action.REMOVE, undoArgs );
		updateWidgets( );
	} // method
	
	public Vector addChildInstancesToList ( Model.Interface model, Vector targets, Instance i ) {
		Instance instance = null;
		if ( ! targets.contains( i ) ) targets.addElement( i );
		for( Enumeration enum = i.childInstances( ).elements( ); enum.hasMoreElements( ); ) {
			instance = (Instance) model.findInstance((String) enum.nextElement( ));
			addChildInstancesToList( model, targets, instance );
		} // end for
		return( targets );
	} // method
	
	public Vector selectedComponents ( ) {
		Vector result = null;
		if ( ( selectedWindow( ) != null ) &&
				( ((ModelFrame) selectedWindow( )).modelPane( ) != null ) )
			result = ((ModelFrame) selectedWindow( )).modelPane( ).selectedComponents( );
		if ( result == null ) result = new Vector( );
		return( ((ModelFrame) selectedWindow( )).modelPane( ).selectedComponents( ) );
	} // method
	
	public void delete ( Model.Interface model, Vector targets ) {
	} // method

	public void delete ( Model.Interface model, Instance.InstInterface instance ) {
		((PeerElement) instance.peer( )).setVisible( false );
		((ModelFrame) selectedWindow( )).modelPane( ).componentpane( ).remove( (PeerElement) instance.peer( ) );
//		currentModel( ).remove( instance.reference( ) );
	} // method

	public void delete ( PeerElement elementInstance  ) {
		delete( elementInstance.model( ), elementInstance.instance( ) );
	} // method
	
	// Inner Classes
	// -------------------------------------------------------------------------
	public static class ComboModel implements VModelConstants, ComboBoxModel, ListModel {
		// ComboBoxModel
		public Object getSelectedItem( ) { 
			Object result = null;
			if ( getSize( ) > 0 ) result = desktop( ).getAllFrames( )[0];
			return( result );
		} // method
		
	 	public void setSelectedItem(Object anItem) { 
	 		if ( anItem instanceof JInternalFrame ) {
	 			JInternalFrame frame = (JInternalFrame) anItem;
		 		frame.toFront( );
		 		try { 
		 			if ( frame.isIcon( ) ) frame.setIcon( false ); 
		 			frame.setSelected( true );
		 			// Quick Test. Need to expand to whole rectangle test. 
		 			if ( !desktopScrollPane( ).getViewport( ).getViewRect( ).contains( frame.getLocation( ) ) )
		 				desktopScrollPane( ).getViewport( ).setViewPosition( frame.getLocation( ));
		 		} catch ( PropertyVetoException e ) { }
		 	} // end if
	 	} // method

		// ListModel
		public void addListDataListener(ListDataListener l) { 
			listDataListeners( ).addElement( l );
		} // method

		public void removeListDataListener(ListDataListener l) { 
			listDataListeners( ).removeElement( l );
		} // method

		public Object getElementAt(int index) {
			Object result = null;
			if ( index < getSize( ) ) result = desktop( ).getAllFrames( )[ index ];
//			else System.out.println( "Modeler.ComboModel.getElementAt index=" + index + " size=" + getSize( ) );
			return( result );
		} // method

		public int getSize( ) {
			int result = desktop( ).getAllFrames( ).length;
			return( result );
		} // method
	} // innerclass

	public static class ComboRenderer extends JLabel implements ListCellRenderer {
		public ComboRenderer() {
			setOpaque(true);
		}

		public Component getListCellRendererComponent(
									JList list,
									Object value,
									int index,
									boolean isSelected,
									boolean cellHasFocus) {
			if ( value != null ) {
				setText(((JInternalFrame) value).getTitle());
				setIcon(((JInternalFrame) value).getFrameIcon());
			} // end if
//			else System.out.println( "Modeler.ComboRenderer value=" + value + " index=" + index );
			setBackground(isSelected ? Color.blue : Color.white);
			setForeground(isSelected ? Color.white : Color.black);
			return this;
		}
	}
	
	public Instance.InstInterface addConnect ( Model.Interface model, Definition.DefInterface relationship, Instance.InstInterface independent, Instance.InstInterface dependent, int x, int y, int orientation ) {
		Instance instance = (Instance) addDefinition( model, relationship, x, y, true );;
		PeerElement peerElement = (PeerElement) instance.peer( );
		boolean flip_p = false;
		orientation = peerElement.orientation( orientation );
		if ( relationship.typep( HASATTRIBUTE ) ) {
			if ( ( ! independent.definition( ).typep( ENTITY ) ) &&
					( dependent.typep( ENTITY ) ) ) {
				Instance.InstInterface foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} else if ( relationship.typep( HASPARTICIPANT ) ) {
			if ( ( ! independent.definition( ).typep( PROCESS ) ) &&
					( dependent.typep( PROCESS ) ) ) {
				Instance.InstInterface foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} else if ( relationship.typep( PARTICIPATESIN ) ) {
			if ( ( independent.definition( ).typep( PROCESS ) ) &&
					( ! dependent.typep( PROCESS ) ) ) {
				Instance.InstInterface foo = independent;
				independent = dependent;
				dependent = foo;
				flip_p = true;
			} // end if
		} // end if

//		selectedModel( ).log( "addElement", "element= " + instance.peer( ).id( ) );
// www.thriftstoreart.com
		connect( model, instance, independent, dependent );
		
		peerElement.orientation( orientation );		
		peerElement.positionMarkers( );
		
		if ( flip_p ) {
			QRGutils.beep( );
			((PeerElement) instance.peer( )).flip( );
		} // end if
		
		Librarian.selectedTree( ).clearSelection( );
		Librarian.selectedDefinition( null );
		
		Vector undoArgs = new Vector( );
		undoArgs.addElement( instance );
		undoArgs.addElement( peerElement );
		undoArgs.addElement( independent );
		undoArgs.addElement( dependent );
		undoArgs.addElement( new Integer( x ) );
		undoArgs.addElement( new Integer( y ) );
		undoArgs.addElement( new Integer( orientation ) );
//		selectedModel( ).doAction( ModelPane.Action.ADDCONNECT, undoArgs );
		updateWidgets( );
		return( instance );
	} // method

	public Definition.DefInterface subtype ( Model.Interface model, Instance.InstInterface instance, String name ) {
//QRGutils.debug("Classic.subtype", "ENTER name=" + name);
		Definition.DefInterface result = null;
		Instance.InstInterface foo = null;
		for( Enumeration enum = instance.children( ); enum.hasMoreElements( ); ) {
			foo = (Instance.InstInterface) enum.nextElement( );
			if ( foo != null ) {
				foo.reference( ).set( "X", instance.getInt( "X-OFFSET" ) - foo.getInt( "X-OFFSET" ) );
				foo.reference( ).set( "Y", instance.getInt( "Y-OFFSET" ) - foo.getInt( "Y-OFFSET" ) );
				if ( foo.typep( RELATIONSHIP ) ) foo.reference( ).set( "ROTATION", foo.getInt( "ORIENTATION" ) );
			} else instance.childInstances( ).removeElement( foo );
		} // end for
		result = super.subtype( model, instance, name );
		return( result );
	} // method
		
	public Definition.DefInterface addToLibrary( Model.Interface model, Instance.InstInterface instance ) {
		Definition.DefInterface result = super.addToLibrary( model, instance );
		Instance.InstInterface foo = null;
		for( Enumeration enum = instance.children( ); enum.hasMoreElements( ); ) {
			foo = (Instance.InstInterface) enum.nextElement( );
			foo.reference( ).set( "X", instance.getInt( "X-OFFSET" ) - foo.getInt( "X-OFFSET" ) );
			foo.reference( ).set( "Y", instance.getInt( "Y-OFFSET" ) - foo.getInt( "Y-OFFSET" ) );
			if ( foo.typep( RELATIONSHIP ) ) foo.reference( ).set( "ROTATION", foo.getInt( "ORIENTATION" ) );
		} // end for

		myLibraryTree( ).setModel( null );
		myLibraryTree( ).setModel( myLibrary( ) );
		return( result );
	} // method

	public void saveImage ( String type ) {
		selectedWindow().modelPane().deselectAll();
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setDialogTitle("Export TIFF File");
		fileDialog.setApproveButtonText("Export");
		Dimension size = selectedWindow().modelPane().viewpane().getSize();
		Image img = selectedWindow().modelPane().viewpane().createImage(size.width, size.height);
		Graphics ig = img.getGraphics();
		String name = selectedModel().getString("NAME");
		String dir = QRGutils.QRGroot() + QRGutils.QRGuserpath() + MODELSPATH;
		if (type == IMAGE_JPEG) {
			if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
		} else {	
			if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, "tif");
		}
		String filepath = dir + name;
		File file = new File(filepath);
		int result = 0;
		ig.setClip(0,0,size.width,size.height);
		fileDialog().setDialogType(JFileChooser.SAVE_DIALOG);
		fileDialog.setApproveButtonText("Export");
		if (type == IMAGE_JPEG) {
			fileDialog.setDialogTitle("Export VModel JPG Image File");
			fileDialog().setFileFilter(jpgFileFilter());
		} else {
			fileDialog.setDialogTitle("Export VModel TIF Image File");
			fileDialog().setFileFilter(tifFileFilter());
		} // end if type
		fileDialog().setSelectedFile(file);
		fileDialog().setCurrentDirectory(file);
		fileDialog().rescanCurrentDirectory();
		result = fileDialog().showDialog((Component) frame(), null);
		if(result == JFileChooser.APPROVE_OPTION) {
			file = fileDialog().getSelectedFile();
			name = file.getName();
			dir = file.getParent() + "/";
			if (name != null) {
	//			((VModelPeerElement) selectedModel().modelElement().peer()).cadPane().modelPane().paintAll(ig);
				Color fi = selectedWindow().modelPane().viewpane().getBackground();
				selectedWindow().modelPane().viewpane().setBackground(WHITE);
				selectedWindow().modelPane().viewpane().paintAll(ig);
				selectedWindow().modelPane().viewpane().setBackground(fi);
//				selectedWindow().modelPane().viewpane().print(ig);
				if (type == IMAGE_JPEG) {
					if (!name.toUpperCase().endsWith(".JPG")) name = QRGutils.replaceExtension(name, "jpg");
					JPEG jpg = new JPEG();
					jpg.compress(img, dir + name);
				} else {	
					TIFF tiff = new TIFF();
					if (!name.toUpperCase().endsWith(".TIF")) name = QRGutils.replaceExtension(name, "tif");
					tiff.encode(img, dir + name, tiff.RGB_COLOR);
				}
			} // end if name
		} // end if APPROVED
	} // end method saveImage

	// VModel.Interface Methods
	// -------------------------------------------------------------------------
	// Start Controller
	public void go ( ) {
		Runnable doStart = new Runnable( ) {
			public void run ( ) {
				doLogin( );
			} };
		SwingUtilities.invokeLater( doStart );
	} // method go
	
	// Quit Program
	public boolean quit ( ) {
		frame( ).setVisible(false);
		preferences( ).saveLocalPrefs( );
//		myModels( ).save( "myModels" );
		myProcesses( ).save( "myProcesses" );
		myEntities( ).save( "myEntities" );
		myAttributes( ).save( "myAttributes" );
		ImageCache.dumpImages( "ImageDump.java" );
		frame( ).dispose();
		return( super.quit( ) );
	} // method quit
	
	// Modeling commands
	public Model.Interface makeModel ( ) {
		Model.Interface result = super.makeModel( );
		add( result );
		updateWidgets( );
		if ( result != null ) result.log( "makeModel", "Model Created" );
		return( result );
	} // method
	
} // class

// -----------------------------------------------------------------------------
// End of File: Classic.java       (c) 2001 Northwestern University