package edu.qrg.vmodel.controllers.common;

import edu.qrg.vmodel.*;
import edu.qrg.utils.*;
import java.util.*;
import javax.swing.*;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/controllers
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Controller.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
* Interface: Controller
*   Purpose: Controller API.
* ----------------------------------------------------------------------------
* Notes:
* * Very simple to suit the task in VModel.
* * Need to add a toolbar with forward/backward
* -----------------------------------------------------------------------------
* </PRE> */
public interface Controller extends VModelConstants, VModel.VMController {
	// Properties & Accessors
	// -------------------------------------------------------------------------
	// VModel model engine
	public VModel vmodel ();
	public VModel vmodel (VModel v);
	
	public HTMLbrowser browser ();
	public VModelPreferencesDialog preferencesDialog ();
//	public PrintPreviewDialog printPreview ();
	public void saveImage (String type);

	public Ontology selectedOntology ();
	public Ontology selectedOntology (Ontology l); 

	public JFrame frame ();

	public int closeAllModels ();
	public int closeModel ();
	public int closeModel(ModelFrame frame, boolean aux);
	public int closeModel(ModelFrame frame);

	public void tileModelFrames();
	public void cascadeModelFrames();

	public ModelFrame selectedWindow ();
	public ModelFrame selectedWindow (ModelFrame w);
	public JComboBox openWindows ();
	public Model currentModel ();
	public Model currentModel (Model m);
	/** @deprecated Use currentModel () */
	public Model selectedModel ();
	/** @deprecated Use currentModel (Model m) */
	public Model selectedModel (Model m);
	public Definition selectedDefinition ();
	public Definition selectedDefinition (Definition e);
	
	public Vector addDefinition (Model model, Definition element, int clickX, int clickY, boolean clearSelectedElement, boolean undop);
	public Instance connect (Model model, Definition relationship, Instance independent, Instance dependent, int x, int y, int orientation, boolean undop);

	public void updateWidgets ();
	
	public HTMLpanel coachAskPanel ();

	public ModelOverviewDialog modelOverview ();

	public void saveHTML ();
	
	public String updateContextHelp ();

	public Model makeModel ();

	public void runSimulation ( Model model );

	public Ontology classModels ();
	public Ontology classModels (Ontology o);

	public Ontology vModels ();
	public Ontology vModels (Ontology o);

	public Ontology myModels ();
	public Ontology myModels (Ontology o);

	public Ontology myEntities ();
	public Ontology myEntities (Ontology o);

	public Ontology myThings ();
	public Ontology myThings (Ontology o);

	public Ontology myMultipleThings ();
	public Ontology myMultipleThings (Ontology o);

	public Ontology mySubstances ();
	public Ontology mySubstances (Ontology o);

	public Ontology myProcesses ();
	public Ontology myProcesses (Ontology o);

	public Ontology myAttributes ();
	public Ontology myAttributes (Ontology o);

	public Ontology projectOntology ();
	public Ontology projectOntology (Ontology o);

	public Ontology myLibrary ();
	public Ontology myLibrary (Ontology o);

	public Ontology library ();
	
	public void help ( );

	public void delete (boolean undop);

	public void copy ();

	public void cut ();

	public void paste ();

	public void printModel ();

	public JButton printPreviewButton ();

	public VModelSidePanel sidepanel (); 
	public VModelSidePanel sidepanel (VModelSidePanel s); 

	public JButton groupButton ();

} // interface Controller

// -----------------------------------------------------------------------------
// End of File: Controller.java       (c) 2001 Northwestern University