//package edu.qrg.vmodel.library.ontologies;

import CMLio.CMLable;
import Definition;
import KeyValuePair;
import KeyValuePair.KVPinterface;
import Ontology.OntInterface;
//import Ontology.Ontology;
//import Ontology.Element;
import Ontology.OntInterface;
import PList.PLinterface;
import XMLio.XMLable;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Object;
import java.lang.String;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeNode;

/** <PRE> 
* Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/library/ontologies
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: Ontology.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: Ontology
* Purpose: Categories are used to group ontological elements. Categories
*          reside within an ontology. Categories may contain sub-categories.
* ----------------------------------------------------------------------------
* function is bridge to teleology
* teleology is purpose
* </PRE> */
public class QPontology extends Ontology
		implements Cloneable, Serializable, VModelConstants, Ontology.OntInterface {
	// Constructors
	// ------------------------------------------------------------------------
	/** General initialization. */
	public QPontology ( ) {
		super( );
		id( BASEONTOLOGY );
		name( "Base Ontology" );
		documentation( "The QP Ontology is..." );
		helpURL( makeHelpURL( QPONTOLOGY ) );
		makeInitialElements( );
    } // default constructor
		
	// InnerClasses
	// ------------------------------------------------------------------------
	/** <PRE> 
	* ---------------------------------------------------------------------------
	*   Class: Ontology
	* Purpose: Categories are used to group ontological elements. Categories
	*          reside within an ontology. Categories may contain sub-categories.
	* ---------------------------------------------------------------------------
	* </PRE> */
//	public class Ontology extends Ontology
//			implements Cloneable, Serializable, VModelConstants, Ontology.Ontology {
//		// Constructors
//		// -----------------------------------------------------------------------
//		/** Purpose: General initialization. */
//		public Ontology ( ) {
//			super( );
//	   } // constructor
//			
//		/** Purpose: Initializes most frequently used slots. */
//	   public Ontology( String id, String name, String documentation, String helpURL ) {
//	   	this( );
//	    	id( id );
//	    	name( name );
//	    	documentation( documentation );
//	    	helpURL( helpURL );
//	   } // constructor
//
//		// Properties & Accessors
//		// -----------------------------------------------------------------------
//		/** Purpose: Returns the string id of the category to which this
//		             category belongs. */
//		public String category ( ) { return( getString( CATEGORY ) ); }
//		/** @see #category( ) */
//		public String category ( String s ) { return( (String) set( CATEGORY, s ) ); }
//		
//		/** Purpose: Returns the string filename of an image representing
//		             the category. */
//		public String icon ( ) { return( getString( ICON ) ); }
//		/** @see #icon( ) */
//		public String icon ( String s ) { return( (String) set( ICON, s ) ); }
//		/** Purpose: Returns the string filename of an image representing
//		             the category in an Open or Close state. */
//		public String icon ( boolean expanded ) { 
//			String result = icon( );
//			if ( expanded ) result += "Open";
//			else result += "Closed";
//			return( result ); 
//		} // method
//		
//		/** Type of ontological element. */
//		public String type ( ) { return( CATEGORY ); }
//		/** @see #type( ) */
//		public String type ( String s ) { return( CATEGORY ); }
//	
//		/** Type check */
//		public boolean typep ( String typeID ) {
//			boolean result = false;
//			Definition mumble = null;
//			result = id( ).equalsIgnoreCase( typeID ) ||
//				name( ).equalsIgnoreCase( typeID ) ||
//				category( ).equalsIgnoreCase( typeID ) ||
//				type( ).equalsIgnoreCase( typeID );
//			return( result );
//		} // method
//	
//		/** Type of ontological element. */
//		public String typeName ( ) { return( "COREONTOLOGY" ); }
//		/** @see #type( ) */
//		public String typeName ( String s ) { return( "COREONTOLOGY" ); }
//
//	} // class Ontology
	
	// Properties
	// ------------------------------------------------------
	public static Ontology entities = null;
	public static Definition entity = null;
	public static Definition process = null;
	public static Definition processRate = null;
	public static Definition agent = null;
	public static Definition collection = null;
	public static Definition collectionAmount = null;
	public static Definition modelFragment = null;
	public static Model model = null;
	
	public static Ontology attributes = null;
	public static Definition attribute =null;
	public static Ontology quantities = null;
	public static Definition quantity = null;
	public static Definition rate = null;
	public static Definition amount = null;
	public static Definition level = null;
	public static Definition magnitude = null;
	public static Definition chance = null;
	
	public static Ontology relationships = null;
	public static Definition relationship = null;
	public static Ontology structuralrelationships = null;
	public static Definition structure = null;
	public static Definition hasAttribute = null;
	public static Definition hasParticipant = null;
	public static Definition participatesIn = null;
	public static Definition does = null;
	public static Definition boundTo = null;
	public static Ontology causalrelationships = null;
	public static Definition causes = null;
	public static Definition directInfluence = null;
	public static Definition iPlus = null;
	public static Definition iMinus = null;
	public static Definition indirectInfluence = null;
	public static Definition qpropPlus = null;
	public static Definition qpropMinus = null;
	public static Definition cPlus = null;
	public static Definition cMinus = null;
	public static Ontology constraintrelationships = null;
	public static Definition constrains = null;
	public static Definition isGreaterThan = null;
	public static Definition isLessThan = null;
	public static Definition isEqualTo = null;
	public static Definition isTheSameAs = null;
	public static Definition isDifferentFrom = null;
	public static Ontology spatialrelationships = null;
	public static Definition touches = null;
	public static Definition contains = null;
	public static Definition isPartOf = null;
	
	public static Ontology justification = null;
	public static Definition data = null;
	public static Definition hypothesis = null;
	public static Definition supports = null;
	public static Definition predicts = null;
	
	public static boolean initialized = false;
	public static QPontology self = null;
	
	// Methods
	// ------------------------------------------------------------------------
	/** Construct a URL to a help file specified by base. */
	public String makeHelpURL( String base ) {
//		return( QRGutils.QRGroot( ) + HELPPATH + base + "." + HTML_SUFFIX );
		return( QRGutils.replaceExtension( base, HTML_SUFFIX ) );
	} // method
	
	public void fillSlots ( Definition definition, String name ) {
		definition.id( name );
		definition.name( name );
		definition.documentation( "A " + name + " is..." );
		definition.helpURL( makeHelpURL( name ) );
		definition.type( name );
	} // method
	
	public void fillSlots ( Instance instance, String name ) {
		instance.id( name );
		instance.name( name );
		instance.documentation( "A " + name + " is..." );
		instance.helpURL( makeHelpURL( name ) );
		instance.type( name );
	} // method
	
	public Definition makeDefinition ( Ontology category, String name ) {
		Definition result = makeDefinition( category, null, name );
		return( result );
	} // method
	
	public Definition makeDefinition ( Ontology category, Definition base, String name ) {
		Definition result = null;
		Instance instance = null;
		if ( base == null ) result =  new Definition( );
		else result = new Definition( base );
		fillSlots( result, name );
		result.removeAll( );
		instance = new Instance( result );
		result.add( instance );
		category.add( result );
		return( result );
	} // method
	
	/** Generate ontological elements to be contained in the object. */
	public void makeInitialElements( ) {
		if ( initialized ) {

			add( entities );
				
			add( attributes );
				
			add( relationships );
				
			add( justification );
				
		} else {
			self = this;
			initialized = true;
			// Categories
			entities = new Ontology(
				ENTITIES,
				ENTITIES,
				"Entities are...",
				makeHelpURL( ENTITIES ) );
			add( entities );
				
			attributes = new Ontology(
				ATTRIBUTES,
				ATTRIBUTES,
				"Attributes are...",
				makeHelpURL( ATTRIBUTES ) );
			add( attributes );
				
			quantities = new Ontology(
				QUANTITIES,
				QUANTITIES,
				"Quantity Attributes are...",
				makeHelpURL( QUANTITIES ) );
			attributes.add( quantities );
				
			relationships = new Ontology(
				RELATIONSHIPS,
				RELATIONSHIPS,
				"Relationships are...",
				makeHelpURL( RELATIONSHIPS ) );
			add( relationships );
				
			structuralrelationships = new Ontology(
				STRUCTURALRELATIONSHIPS,
				STRUCTURALRELATIONSHIPS,
				"Structural Relationships are...",
				makeHelpURL( STRUCTURALRELATIONSHIPS ) );
			relationships.add( structuralrelationships );
				
			causalrelationships = new Ontology(
				CAUSALRELATIONSHIPS,
				CAUSALRELATIONSHIPS,
				"Causal Relationships are...",
				makeHelpURL( CAUSALRELATIONSHIPS ) );
			relationships.add( causalrelationships );
				
			constraintrelationships = new Ontology(
				CONSTRAINTRELATIONSHIPS,
				CONSTRAINTRELATIONSHIPS,
				"Constraint Relationships are...",
				makeHelpURL( CONSTRAINTRELATIONSHIPS ) );
			relationships.add( constraintrelationships );
				
			spatialrelationships = new Ontology(
				SPATIALRELATIONSHIPS,
				SPATIALRELATIONSHIPS,
				"Spatial Relationships are...",
				makeHelpURL( SPATIALRELATIONSHIPS ) );
			relationships.add( spatialrelationships );
				
			justification = new Ontology(
				JUSTIFICATION,
				JUSTIFICATION,
				"Justification elements are...",
				makeHelpURL( JUSTIFICATION ) );
			add( justification );
				
			// Entities
			Instance instance = null;
			
			entity = makeDefinition( entities, ENTITY );
			entity.icon( "IconEntity" );
//			entity.CMLcommand( "defentity" );
				
			collection =  makeDefinition( entities, entity, COLLECTION );
			
//			collectionAmount =  makeDefinition( entities, entity, COLLECTIONAMOUNT );
						
			// Agents are special entities.
			// They are assumed to be autonomous.
			// And have the ability to initiate processes w/o participation.
//			agent =  makeDefinition( entities, entity, AGENT );

			// Not sure what a model fragment is in this version.			
//			modelFragment = entity.subtype( MODELFRAGMENT );
//			fillSlots( modelFragment, MODELFRAGMENT );
//			modelFragment.CMLcommand( "defmodelfragment" );
//			entities.add( modelFragment );

			process =  makeDefinition( entities, entity, PROCESS );
//			process.CMLcommand( "defprocess" );
			process.icon( "IconProcess" );

//			processRate =  makeDefinition( entities, process, PROCESSRATE );
//			processRate.documentation( "Therein squats the toad..." );
//			processRate.CMLcommand( "defprocessrate" );

//			model =  makeDefinition( entities, entity, MODEL );
//			model.icon( "IconModel" );
//			model.helpURL( "models" );

			//Attributes
			attribute = makeDefinition( attributes, ATTRIBUTE );
//			attribute.CMLcommand( "defattribute" );
			attribute.icon( "IconAttribute" );
			
			quantity =  makeDefinition( attributes, attribute, QUANTITY );
//			quantity.CMLcommand( "defquantity" );
			quantity.icon( "IconQuantity" );
			
			rate =  makeDefinition( attributes, quantity, RATE );

			amount =  makeDefinition( attributes, quantity, AMOUNT );

			level =  makeDefinition( attributes, quantity, LEVEL );

			magnitude =  makeDefinition( attributes, quantity, MAGNITUDE );

			chance =  makeDefinition( attributes, quantity, CHANCE );
			
			// Relationships
			relationship =  makeDefinition( relationships, RELATIONSHIP );
//			relationship.CMLcommand( "defrelationship" );
			relationship.icon( "IconRelationship" );

			// Structure
			structure =  makeDefinition( structuralrelationships, relationship, STRUCTURE );
			structure.icon( "IconRelationshipStructural" );
			
			hasAttribute =  makeDefinition( structuralrelationships, structure, HASATTRIBUTE );

			hasParticipant =  makeDefinition( structuralrelationships, structure, HASPARTICIPANT );

			// Same as hasParticipant but with opposite direction.
//			participatesIn =  makeDefinition( structuralrelationships, hasParticipant, PARTICIPATESIN );

			// Connects Agent to Process
//			does =  makeDefinition( structuralrelationships, structure, DOES );

			// Binds variables to instances
//			boundTo =  makeDefinition( structuralrelationships, structure, BOUNDTO );

			// Causal
			causes =  makeDefinition( causalrelationships, relationship, CAUSES );
			causes.icon( "IconRelationshipCausal" );

			directInfluence =  makeDefinition( causalrelationships, causes, DIRECTINFLUENCE );

			// Integration
			iPlus =  makeDefinition( causalrelationships, directInfluence, IPLUS );

			iMinus =  makeDefinition( causalrelationships, directInfluence, IMINUS );
			
			// Summation
			cPlus =  makeDefinition( causalrelationships, directInfluence, CPLUS );

			cMinus =  makeDefinition( causalrelationships, directInfluence, CMINUS );

			indirectInfluence =  makeDefinition( causalrelationships, causes, INDIRECTINFLUENCE );

			qpropPlus =  makeDefinition( causalrelationships, indirectInfluence, QPROPPLUS );

			qpropMinus =  makeDefinition( causalrelationships, indirectInfluence, QPROPMINUS );

			// Constraints
			constrains =  makeDefinition( constraintrelationships, relationship, CONSTRAINT );

			isGreaterThan =  makeDefinition( constraintrelationships, constrains, ISGREATERTHAN );

			isLessThan =  makeDefinition( constraintrelationships, constrains, ISLESSTHAN );

			isEqualTo =  makeDefinition( constraintrelationships, constrains, ISEQUALTO );

			isTheSameAs =  makeDefinition( constraintrelationships, constrains, ISTHESAMEAS );

			isDifferentFrom =  makeDefinition( constraintrelationships, constrains, ISDIFFERENTFROM );

			touches =  makeDefinition( spatialrelationships, constrains, TOUCHES );

			contains =  makeDefinition( spatialrelationships, constrains, CONTAINS );

			isPartOf =  makeDefinition( spatialrelationships, constrains, ISPARTOF );

			// Justification
			data =  makeDefinition( justification, entity, DATA );
//			data.CMLcommand( "defdata" );
			data.icon( "IconJustify" );
			
			hypothesis =  makeDefinition( justification, quantity, HYPOTHESIS );
//			hypothesis.CMLcommand( "defhypothesis" );
			hypothesis.icon( "IconHypothesis" );
			
			supports =  makeDefinition( justification, relationship, SUPPORTS );
			supports.icon( "IconRelationshipSupports" );

			predicts =  makeDefinition( justification, relationship, PREDICTS );
			predicts.icon( "IconRelationshipSupports" );
			
			// manipulations
			Instance processInstance = process.findInstance( PROCESS );
			Instance rateInstance = new Instance( rate.findInstance( RATE ) );
			rateInstance.id( "RATEOFPROCESS" );
			rateInstance.name( "Rate" );
			rateInstance.set( "X", 50 );
			rateInstance.set( "Y", -100 );
			process.add( rateInstance );
			Instance relationshipInstance = new Instance( hasAttribute );
			relationshipInstance.input( processInstance.id( ) );
			relationshipInstance.output( rateInstance.id( ) );
			relationshipInstance.set( "SELFCONNECT", true );
			relationshipInstance.set( "X", 20 );
			relationshipInstance.set( "Y", -41 );
			relationshipInstance.set( "ROTATION", 1 );
			process.add( relationshipInstance );
			processInstance.outputs( ).addElement( relationshipInstance.id( ) );
			rateInstance.inputs( ).addElement( relationshipInstance.id( ) );
			
		} // end if
	} // method
} // class

// ---------------------------------------------------------------------------
// End of File: QPlibrary.java                 (c) 2003 Northwestern University