package edu.qrg.vmodel;

import edu.qrg.utils.*;
import edu.qrg.utils.KeyValuePair;
//import CMLio.CMLable;
//import Definition;
//import Model. Interface;
//import PList. Interface;
//import XMLio.XMLable;
import java.awt.*;
import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Double;
import java.lang.Integer;
import java.lang.Math;
import java.lang.NumberFormatException;
import java.lang.Object;
import java.lang.Runnable;
import java.lang.String;
//import java.util.AbstractCollection;
//import java.util.AbstractList;
import java.util.Enumeration;
import java.util.EventListener;
import java.util.Vector;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.SwingUtilities;
import javax.swing.border.AbstractBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/references
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: PeerElement.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: PeerElement
* Purpose: GUI element. 
* ----------------------------------------------------------------------------
* </PRE> */
public interface Peer extends Cloneable, Serializable, VModelConstants,
		CMLio.CMLable, XMLio.XMLable, PList.PLinterface {
	public Instance instance ();
	public Instance instance (Instance i);

	public boolean selected ();
	public boolean selected (boolean b);

	public boolean active ();
	public boolean active (boolean b);
	
	public ImageIcon image ();
	
	public int mode ();
	public int mode (int i);
	
	public int view ();
	public int view (int i);
	
	public void updatePeer();

	public Vector problems ();
	public Vector problems (String err, String msg);

	// From Definition
	// Accessors
	// --------------------------------------------------------------------
	/** References to relationship definitions. */
	public Vector connections ();
	/** References to Process, Entity, Model, and Attribute definitions. */
	public Vector connectors ();

	/** Base ontological or semantic type of the definition. */
	public String Otype ();
	/** @see #Otype() */
	public String Otype (String s);

	/** Java type of the definition - corresponds to class type. */
	public String Jtype ();
	/** @see #Jtype() */
//	public String Jtype (String s);

	// methods
	// --------------------------------------------------------------------
	/** Type check. */
	public boolean typep (String type);
	/** Otype check. */
	public boolean Otypep (String Otype);
	/** Jtype check. (similar to instanceof) */
	public boolean Jtypep (String Jtype);
	
	/** Because type is related to the unique ids,
	    a type name must be looked up.
	    Returns the name of the parent type. */
	public String typeName ();

	/** List of all connected elements (connectors). */
	public Enumeration children ();

	public String icon (boolean expanded);

	/** Set the string used to represent the definition in CML. */
//	public String CMLcommand (String s);

	public Vector typeChain ();

	// From Ontology.Element
	// Properties & Accessors
	// --------------------------------------------------------------------
	/** Return the unique string identifier for the object. */
	public String id ();
	/** Set & return the unique string identifier for the object. */
	public String id (String s);

	/** Return a string name for the object. */
	public String name ();
	/** Set & return a string name for the object. */
	public String name (String s);

	/** Return a documentation string for the object. */
	public String documentation ();
	/** Sets & return a documentation string for the object. */
	public String documentation (String s);
	
	/** Return a string filename pointing to a web-based
	    documentation file for the object. */
	public String helpURL ();
	/** Sets & returns a string filename pointing to a web-based
	    documentation file for the object. */
	public String helpURL (String s);
	
	/** Returns a string filename pointing to a gif or jpg file.
	    Filename does not have to include file-extension. */
	public String icon ();
	/** Sets * returns a string filename pointing to a gif or jpg file.
	    Filename does not have to include file-extension. */
	public String icon (String name);
	
	/** Id of category to which the ontological element belongs. */
	public String category ();
	/** @see #category() */
	public String category (String s);

	/** Type of ontological element. */
	public String type ();
	/** @see #type() */
	public String type (String s);

	/** Represent object as string. */
	public String stringify ();
	/** Represent object as string with indentation. */
	public String stringify (int indent);
} // class VModelInstance

// ---------------------------------------------------------------------------
// End of File: PeerElement.java              (c) 2003 Northwestern University
