package edu.qrg.utils;

import java.io.Serializable;
import java.lang.Cloneable;
import java.lang.Object;
import java.lang.String;

/** <PRE> Sun Java 1.3.1 -Sourcepath QRG/VModel/development/code/utils
* ----------------------------------------------------------------------------
*  2003 Northwestern University Qualitative Reasoning Group Kenneth D. Forbus
* ----------------------------------------------------------------------------
* File name: KeyValuePair.java
*    System: VModel
*     Since: v0.6
*    Author: Leo C. Ureel II
* ----------------------------------------------------------------------------
*   Class: KeyValuePair
* Purpose: Groups a key and a value.
* ----------------------------------------------------------------------------
* </PRE> */
public class KeyValuePair 
		implements Cloneable, Serializable, KeyValuePair.KVPinterface {
   // Constructors
	// ------------------------------------------------------------------------
	/** General initialization. */
	public KeyValuePair() {
		super();
   } // constructor 

	/** Initialization. Specify Key and Value. */
   public KeyValuePair(String key, Object value) {
      super();
		key(key);
		value(value);
   } // constructor 

	// Interfaces
	// ------------------------------------------------------------------------
	/** <PRE>
	* ------------------------------------------------------------------------
	* Interface: KeyValuePair.KVPinterface
	* Purpose: In general, anything implementing this interface should be
	*          acceptable as a KeyValuePair.
	* ------------------------------------------------------------------------
	* </PRE> */
	public interface KVPinterface extends Cloneable, Serializable {
		/** Reader Accessor - returns the key. */
	   public String key ();
	   /** Writer Accessor - sets & returns the key. */
	   public String key (String s);

		/** Reader Accessor - returns the value. */
	   public Object value ();
	   /** Writer Accessor - sets & returns the value. */
	   public Object value (Object v);
	} // interface

	// Properties & Accessors
	// ------------------------------------------------------------------------
	/** String representation of a key.
	* * Use the accessors.
	* @see #key()
	* @see #key(String)
	* @serial
	*/
	protected String key = "";
	/** @see #key */
   public String key () { return(key); }
	/** @see #key */
   public String key (String s) { return(key = s.toUpperCase()); }

	/** Value associated with the key.
	* * Use the accessors.
	* @see #value()
	* @see #value(Object)
	* @serial
	*/
   protected Object value = null;
	/** @see #value */
   public Object value () { return(value); }
	/** @see #value */
   public Object value (Object v) { return(value = v); }

   // Method: toString
   // --------------------------------------------------------------------------
	/** Stringifies a KeyValuePair into 'key = "value"' */
   public String toString () { return(key() + " = \"" + value() + "\""); }

} // class

// ---------------------------------------------------------------------------
// End of File: KeyValuePair.java                2001 Northwestern University